<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Cleanup
*
* Runs any automated functions for each module
* 
* @package Admin
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: auto.php,v 1.20 2006/03/20 02:00:54 websterb4 Exp $
* 
*/

/**
* Include main config file 
*/
$CONFIG['NO_SESSION'] = 1;
$ACONFIG['CONFIG_NUM'] = 0;
$ACONFIG['MAX_CONFIG_NUM'] = 1;

//see if main confing file has already been included, if not include it
//if (!isset($CONFIG['FULL_URL'])) {
	require_once('../local/config.inc.php');
//}

//run autoprompter functions (will be integrated into Forum module autofunctions at some stage!)
//require_once('autoprompter.php');

require_once($CONFIG['BASE_PATH'].'/includes/modules.inc.php');

for(;$ACONFIG['CONFIG_NUM']<$ACONFIG['MAX_CONFIG_NUM'];$ACONFIG['CONFIG_NUM']++) {
	if($ACONFIG['CONFIG_NUM'] || !isset($CONFIG['SERVER_URL'])) {$CONN=get_data_config();}

	//get the time of the last cron
	$last_cron = $CONN->UnixTimestamp($CONN->GetOne("SELECT last_run FROM {$CONFIG['DB_PREFIX']}cron"));
	
	//get all module codes and run autofunctions
	
	$rs = $CONN->Execute("SELECT Code From {$CONFIG['DB_PREFIX']}ModuleTypes");
	
	while (!$rs->EOF) {
	
		$code		= $rs->fields[0];
		$module_file = $CONFIG['BASE_PATH'].'/modules/'.$code.'/'.$code.'.inc.php';
		
		if (file_exists($module_file)) {
		
			include_once($module_file);
			$auto_function = 'autofunctions_'.$code;
		   
			if (function_exists($auto_function)) {
			
				if (!$auto_function($last_cron)) {
				
					echo "Error: could not run auto functions for  $code\n";
							
				}
			
			}
		}
		
		$rs->MoveNext();
		
	}
	
	//run any other misc automated routines
	
	// change status of modules
	$date_modified = date('Y-m-d H:i:s');
	$time = time();
	$w_time = $time+3600;
	$current_date  = date('Y-m-d',$w_time);
	
	$rs = $CONN->Execute("SELECT LinkKey,ChangeStatusToKey,ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ChangeStatusDate='$current_date' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4'");
	
	while (!$rs->EOF) {
	
		$link_key=$rs->fields[0];
		$change_to_key=$rs->fields[1];
		$type_key = $rs->fields[2];
		
		$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks SET StatusKey='$change_to_key',DateModified='$date_modified' WHERE LinkKey='$link_key'");
			
		if ($type_key=='4' || $type_key=='6') {
		
			change_child_status($link_key,$change_to_key);
		
		}
		
		$rs->MoveNext();
	
	}
	
	$rs->Close();
	
	//delete items stale from trash
	$modules = new InteractModules();
	
	//delete flagged links
	
	$sql = "SELECT {$CONFIG['DB_PREFIX']}ModuleTypes.Code,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey,LinkKey,SpaceKey from {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='4' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.DateModified<DATE_SUB(CURRENT_DATE, INTERVAL {$CONFIG['KEEP_TRASH']} DAY)";
	
	//$sql = "SELECT {$CONFIG['DB_PREFIX']}ModuleTypes.Code,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey,LinkKey,SpaceKey from {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='4'";
	
	$rs = $CONN->Execute($sql);
	
	while (!$rs->EOF) {
	
		$module_code = $rs->fields[0];
		$module_key = $rs->fields[1];
		$link_key = $rs->fields[2];
		$space_key = $rs->fields[3];
		$modules->delete_module($module_key,$space_key,$link_key,'link_only',$module_code);
		$rs->MoveNext();
		
	}
	
	$rs->Close();
	
	//delete flagged modules
	
	$sql = "SELECT {$CONFIG['DB_PREFIX']}ModuleTypes.Code,ModuleKey from {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND StatusKey='4' AND {$CONFIG['DB_PREFIX']}Modules.DateModified<DATE_SUB(NOW(), INTERVAL {$CONFIG['KEEP_TRASH']} DAY)";
	
	//$sql = "SELECT {$CONFIG['DB_PREFIX']}ModuleTypes.Code,ModuleKey from {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND StatusKey='4'";
	
	$rs = $CONN->Execute($sql);
	
	
		while (!$rs->EOF) {
	
			$module_code = $rs->fields[0];
			$module_key = $rs->fields[1];
			$modules->delete_module($module_key,'','','all',$module_code);
			$rs->MoveNext();
		
		}
	
	$rs->Close();
	
	//delete stale news items
	
	$CONN->Execute("DELETE from {$CONFIG['DB_PREFIX']}News WHERE RemoveDate < CURDATE() AND RemoveDate > '0000-00-00'");
	
	//delete stale accounts
	require_once('../includes/lib/user.inc.php');
	
	$user = new InteractUser();
	
	if ($CONFIG['KEEP_STALE_ACCOUNTS']>0) {
	
		$rs = $CONN->Execute("SELECT UserKey FROM {$CONFIG['DB_PREFIX']}Users WHERE ((LastUse>'0000-00-00' AND LastUse<DATE_SUB(CURRENT_DATE, INTERVAL {$CONFIG['KEEP_STALE_ACCOUNTS']} DAY)) OR  (LastUse='0000-00-00' AND DateAdded<DATE_SUB(CURRENT_DATE, INTERVAL {$CONFIG['KEEP_STALE_ACCOUNTS']} DAY))) AND UserName!='deleteduser'");
		
		if (!$rs->EOF) {
		
			while (!$rs->EOF) {
			
				$user->deleteUser($rs->fields[0]);
				$rs->MoveNext();
				
			}
		
		}
	
		$rs->Close();
			
	}
	
	//now delete accounts flagged to be deleted
	
	$rs = $CONN->Execute("SELECT UserKey FROM {$CONFIG['DB_PREFIX']}Users Where AccountStatus='3'");
	
	while (!$rs->EOF) {
			
		$user->deleteUser($rs->fields[0]);
		$rs->MoveNext();
				
	}
	$rs->Close();
	
	//update cron table
	$date_time = $CONN->DBDate(date('Y-m-d H:i:s'));
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}cron SET last_run=$date_time")==false) {
		echo "There was a problem updating the time of the last cron job";	
	}
	
	$CONFIG=$ACONFIG['CONFIG'];
}

function change_child_status($link_key,$status_key) 
{
	global $CONN, $CONFIG;
	
	$rs=$CONN->Execute("SELECT LinkKey,ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey='$link_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4'");
	
	while (!$rs->EOF) {
	
		$child_link_key = $rs->fields[0];
		$type_key = $rs->fields[1];
		$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks SET StatusKey='$status_key' WHERE LinkKey='$child_link_key'");
				
		if ($type_key=='4' || $type_key=='6') {
		
			change_child_status($child_link_key,$status_key);
		
		}
		
		$rs->MoveNext();
	
	}
	
	$rs->Close();
	return true;

} //end change_child_status
?>