<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Interact Database Setup</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../../local/skins/default/interactstyle.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
body {
	margin: 10px;
}
 .green {color: #00A000;}
 .warnbox {background-color: #FFE0E0}
 .red {background-color: #FF0000}
-->
</style>
</head>
<body>
<div align="center"><img src="../../images/logo2.gif"></div>
<h1 align="center">Interact Setup</h1>
<p>Welcome to the Interact setup program.</p>

<?php
$backUp = '<li>If you care about your data, back up your existing installation before upgrading!</li><br />';
$secHASH = '<li>Take note of the $CONFIG[\'SECRET_HASH\'] setting from your old config.inc.php file - you will need to re-enter it later, on the server settings page</li><br />';
$confEdit = '<li>Rename <strong>/local/config_default.inc.php</strong> to <strong>/local/config.inc.php</strong></li><br /><li>Edit the new config.inc.php file, making sure to read the comments</li><br />';

if (is_file('../../includes/config.inc.php')) {
	echo '<p class="message">Error: You have a config.inc.php file in the /includes folder.<br />As of Interact version 2.0, the config.inc.php file has changed and moved to the /local folder.</p><ol>'.$backUp.$secHASH.'<li>Remove the old /includes/config.inc.php file</li><br />'.$confEdit.'</ol>';
	exit;
}

$CONFIG['NO_SESSION']='1';
/**
* Include main config file 
*/
if (!include('../../local/config.inc.php')) {
	echo '<p class="message">Error: Your config file (/local/config.inc.php) does not exist!</p>';
	echo "<ol>$confEdit</ol>";
	exit;
}

if (!isset($CONFIG['DATA_PATH'])) {
	echo '<p class="message">Error: Your /local/config.inc.php file is out of date.</p><ol>'.$secHASH.'<li>Back up and Remove your old config.inc.php file</li><br />'.$confEdit.'</ol>';exit;
}

require_once('testshortURLs.php');
require_once($CONFIG['BASE_PATH'].'/includes/adodb/adodb.inc.php');
require_once($CONFIG['BASE_PATH'].'/version.php');



$warning=false;
$warntable='<table border="1" cellspacing="0" cellpadding="5">';
    
$sfullurl='http://'.$_SERVER['SERVER_NAME'].ereg_replace('/admin/setup/index.php', '', $_SERVER['SCRIPT_NAME']);

if ($CONFIG['FULL_URL']!=$sfullurl) {
	$warning=true;
	$warntable.= '<tr><th>Your config.inc.php settings</th><td>$CONFIG[\'FULL_URL\'] = \''.$CONFIG['FULL_URL'].'\';</td></tr><tr><th>Auto-detected settings</th><td>$CONFIG[\'FULL_URL\'] = \''.$sfullurl.'\';</td></tr>';
	}

$warntable.='</table>';

if ($warning) {

	echo '<span class="message">Warning: Settings in your /local/config.inc.php file do not match auto-detected server settings.</span><br />Please check this table:<br />'.$warntable.'<br />';
} else {
	echo '<p class="green">Configuration file (config.inc.php) is correct &mdash; installed at \''.$CONFIG['FULL_URL'].'\'.</p>';
}

$warning=false;
$warntable="";
if (ini_get("magic_quotes_gpc")) {
	$warning=true;
	$warntable.='<span class="message">Warning: The PHP flag \'magic_quotes_gpc\' is set to On.</span><br />Interact will work around this problem but will be less efficient.<br />It is highly recommended that you turn it Off in php.ini or an .htaccess file.<br /><br />';
}
if (ini_get("register_globals")) {
	$warning=true;
	$warntable.='<span class="message">Warning: The PHP flag \'register_globals\' is set to On.</span><br />Interact should work with it on, but it is highly recommended for security and reliability reasons to turn it Off in php.ini or an .htaccess file.<br /><br />';
}
if (!($short_urls&6)) {
	echo '<table class="warnbox"><tr><td><span class="message">Warning: Short URLs are not operational on your server</span> - This feature allows secure access to web archives or scorm/ims packages embedded into Interact as well as providing shorter URLs.<br /><br />For example:<br />
<table border=0><tr><td align="right">Instead of a url to some embedded web pges being:&nbsp;</td><td valign="bottom"><strong>http://example.com/viewf/users/1/2/index.html</strong></td></tr><tr><td align="right" valign="top">Interact will have to use a longer URL like:&nbsp;</td><td style="white-space:nowrap"><strong>http://example.com/viewfile.php?path=users/1/2/index.html</strong><br />which will break any relative links in the page.</td></tr></table><br />You can correct this problem later (and then check the Short URL setting in Server Settings).<br />Interact will continue to function - but html links within a zip web archive or SCORM/IMS package will break.<br /><br />There are TWO solutions:<br />1) Setup a 404 redirect to direct.php (if using Apache, look in the .htaccess file in the Interact root and correct the path)<br />2) Enable AcceptPathInfo -- For <strong>Apache version 2.0.3</strong> or higher, try adding the following line into the .htaccess file in the Interact root&hellip;<br />
<pre>AcceptPathInfo On</pre></td></tr></table><br />';
}

if ($warning) {
	echo '<table class="warnbox"><tr><td>'.$warntable.'For <strong>Apache</strong>, have htaccess <a href="http://httpd.apache.org/docs/configuring.html#htaccess">AllowOverride</a> enabled in your httpd.conf file and check that the \'.htaccess\' file in the Interact root directory contains:<br /><pre>
php_flag register_globals off
php_flag magic_quotes_gpc off
&lt;Files direct>
        ForceType application/x-httpd-php
&lt;/Files>
Options  -Indexes
</pre>
See also <a href="'.$CONFIG['FULL_URL'].'/help/admin/install/install.html#security">Security Note</a> in install instructions<br /><br />
<strong>Note:</strong> If you have already set this in your .htaccess file, then the server may not be allowing these particular directives - in which case it may respond by maximising all security features and won\'t even show you the smiley face in this box: <img width="14" height="14" src="../../images/smileys/regular_smile.gif" style="border:1px solid"> &nbsp;In this case, remove the .htaccess directives (Interact will still work as well as it can despite these warnings) or change the server conf.</span>
</td></tr></table><br />';
}

$CONN = &ADONewConnection($CONFIG['DATABASE_TYPE']); 
if (!$CONN->Connect($CONFIG['DBSERVER'],$CONFIG['DBUSER'],$CONFIG['DBPASSWORD'],$CONFIG['DATABASE'])) {
	exit;
}

if ($CONN->Execute("SELECT UserKey FROM {$CONFIG['DB_PREFIX']}Users")!=false) {
	if (($rs=$CONN->Execute("SELECT * FROM {$CONFIG['DB_PREFIX']}Version"))!=false) {
		$drelease=$rs->fields[1];
		$dversion=$rs->fields[0];
		if ($dversion=='') {
			$drelease="<1.8.6";
			$dversion='2003000000';
		}
		//1.9.1 release broke version number, so set back to valid one
		if ($dversion>2147483646) {
			$dversion='2004092701';
		}
		
	} else {
		$drelease="<1.8.6";
		$dversion='2003000000';
	}
} else {
	$dversion=0;
	$drelease=0;
}

if ($dversion==0) {
	echo '<div align="center" style="margin:0px auto;left:auto;right:auto;width:280px;border-style:solid;border-width:2px;border-color:red"><form name="form1" method="post" action="'.$CONFIG['FULL_URL'].'/admin/setup/setup.php#adminpass">
<p style="font-size:small;margin-left:45px;text-align:left">
<input type="radio" name="verbose" value="1"> Show all install details<br>
<input type="radio" checked name="verbose" value="0"> Error reporting only</p>
<input type="submit" name="Submit" value="Install Database Tables Now"><br /><span style="font-size:xx-small"><strong>'.$CONFIG['DB_PREFIX'].'*</strong> tables will be inserted into <strong>'.$CONFIG['DATABASE'].'</strong> database</span>
	</form>
</div>';
} else {
	echo '<table cellpadding=4><tr><th align="right">Interact code release:</th><td>'.$release.'</td><td style="font-size:x-small">(version '.$version.')</td></tr><tr><th align="right">Interact database release:</th><td>'.$drelease.'</td><td style="font-size:x-small">(version '.$dversion.')</td></tr></table>';
	if ($dversion<$version) {
		echo '<span class="message">Your database needs to be upgraded to release '.$release.' (version '.$version.')</span><p>Before proceeding:
<ol>'.$backUp;
		if ($dversion<2005000000) {
			echo $secHASH;
		}
		echo '</ol><div align="center" style="margin:0px auto;left:auto;right:auto;width:280px;border-style:solid;border-width:2px;border-color:red"><form name="form1" method="post" action="'.$CONFIG['FULL_URL'].'/admin/setup/upgrade.php">
<p style="font-size:small;margin-left:45px;text-align:left">
<input type="radio" checked name="verbose" value="1"> Show all upgrade details<br>
<input type="radio" name="verbose" value="0"> Error reporting only</p>  <input type="submit" name="Submit" value="Upgrade Database Tables Now"><br /><span style="font-size:xx-small"><strong>'.$CONFIG['DB_PREFIX'].'*</strong> tables will be upgraded in <strong>'.$CONFIG['DATABASE'].'</strong> database</span>
	</form></div>';
	} else if ($dversion>$version) {
		echo '<span class="message">Warning: Your code is out of date!<br />You need to download a newer version of Interact to work with this database!</span>';
	} else {
		echo '<span class="green">Your database is up to date with your code.</span><p><a href="'.$CONFIG['FULL_URL'].'/">site home page</a>.</p>';}
}

echo '<br /><h2 align="center">Reference</h2>
<p><a href="'.$CONFIG['FULL_URL'].'/help/admin/install/install.html">Instructions for <strong>installing</strong> a new copy of Interact</a></p><p><a href="'.$CONFIG['FULL_URL'].'/help/admin/install/upgrade.html">Instructions for <strong>upgrading</strong> Interact</a></p>'
?>
</body></html>