#
# Table structure for table 'JournalEntries'
#

CREATE TABLE JournalEntries (
  JournalEntryKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  MultiEntryKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  AdminKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  Body mediumtext NOT NULL,
  PRIMARY KEY  (JournalEntryKey),
  KEY UserKeyIdx (UserKey),
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalEntries'
#



#
# Table structure for table 'JournalEntryComments'
#

CREATE TABLE JournalEntryComments (
  CommentKey int(11) NOT NULL auto_increment,
  JournalEntryKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified date NOT NULL default '0000-00-00',
  PRIMARY KEY  (CommentKey),
  KEY JournalEntryKeyIdx (JournalEntryKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalEntryComments'
#


#
# Table structure for table 'JournalSettings'
#

CREATE TABLE JournalSettings (
  ModuleKey int(11) NOT NULL default '0',
  TypeKey tinyint(4) NOT NULL default '0',
  StartDate datetime NOT NULL default '0000-00-00 00:00:00',
  FinishDate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalSettings'
#


#
# Table structure for table 'JournalTypes'
#

CREATE TABLE JournalTypes (
  TypeKey int(11) NOT NULL auto_increment,
  Name varchar(20) NOT NULL default '',
  PRIMARY KEY  (TypeKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalTypes'
#

INSERT INTO JournalTypes VALUES (1,'Open');
INSERT INTO JournalTypes VALUES (2,'Closed');

INSERT INTO ModuleTypes VALUES (14,'Journal','journal','','','journal');
alter table SharedItems add FilePath varchar(11) NOT NULL after FileName;