
# Table structure for table 'UserStatuses'
#
CREATE TABLE UserStatuses (
  AccountStatusKey tinyint(4) NOT NULL auto_increment,
  Name varchar(20) NOT NULL default '',
  PRIMARY KEY  (AccountStatusKey)
) TYPE=MyISAM;

#
# Dumping data for table 'UserStatuses'
#

INSERT INTO UserStatuses VALUES ('','Active');
INSERT INTO UserStatuses VALUES ('','Disabled');

#Add User_ID to Users table

ALTER TABLE Users ADD UserIDNumber varchar(20) not null after Password;

alter table ModuleTypes change Image Image varchar(15) not null;
insert into ModuleTypes values (15,'Noticeboard','noticeboard','','','noticeboard');

#
# Table structure for table 'NoticeboardSettings'
#

CREATE TABLE NoticeboardSettings (
  ModuleKey int(11) NOT NULL default '0',
  TypeKey tinyint(4) NOT NULL default '0',
  DaysToKeep tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

CREATE TABLE Notices (
  NoticeKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  Heading varchar(60) NOT NULL default '',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  RemoveDate date NOT NULL default '0000-00-00',
  UserKey int(11) NOT NULL default '0',
  PRIMARY KEY  (NoticeKey),
  KEY SpaceKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Table structure for table 'Languages'
#

CREATE TABLE Languages (
  LanguageKey tinyint(4) NOT NULL auto_increment,
  Code varchar(3) NOT NULL default '',
  Name varchar(50) NOT NULL default '',
  PRIMARY KEY  (LanguageKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Languages'
#
INSERT INTO Languages VALUES (1,'eng','English');
INSERT INTO Languages VALUES (2,'wfl','Waffle');    

ALTER TABLE Users ADD LanguageKey  tinyint(3) after AccountStatus;
UPDATE Users SET LanguageKey='1';

DROP TABLE SortOrders;
CREATE TABLE SortOrders (
  SortOrderKey tinyint(4) NOT NULL auto_increment,
  SortOrder varchar(20) NOT NULL default '',
  SortSql varchar(30) NOT NULL default '',
  PRIMARY KEY  (SortOrderKey)
) TYPE=MyISAM;

INSERT INTO SortOrders VALUES (1,'Date Added Desc','Modules.DateAdded DESC');
INSERT INTO SortOrders VALUES (2,'Numeric','ModuleSpaceLinks.SortOrder');
INSERT INTO SortOrders VALUES (3,'Alpha','Modules.Name');
INSERT INTO SortOrders VALUES (4,'Date Modified Desc','Modules.DateModified DESC');
INSERT INTO SortOrders VALUES (5,'Date Modified','Modules.DateModified');
INSERT INTO SortOrders VALUES (6,'Date Added','Modules.DateAdded');

#add new chat tables

CREATE TABLE interact_ChatBannlist (
  id int(11) NOT NULL auto_increment,
  ip varchar(15) NOT NULL default '',
  until int(11) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY ip (ip)
) TYPE=MyISAM;


CREATE TABLE interact_ChatRegisteredUsers (
  id int(11) NOT NULL auto_increment,
  user varchar(10) NOT NULL default '',
  password varchar(64) NOT NULL default '',
  email text NOT NULL,
  flag_locked tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY user (user)
) TYPE=MyISAM;


CREATE TABLE interact_ChatUsers (
  id int(11) NOT NULL auto_increment,
  user varchar(10) NOT NULL default '',
  lastping int(11) NOT NULL default '0',
  ip varchar(15) NOT NULL default '',
  room varchar(32) NOT NULL default '',
  language varchar(32) NOT NULL default '',
  version varchar(16) NOT NULL default '',
  level int(11) NOT NULL default '0',
  flag_ripped tinyint(4) NOT NULL default '0',
  sid varchar(32) NOT NULL default '',
  lastmessageping bigint(20) NOT NULL default '0',
  flood_count tinyint(4) NOT NULL default '0',
  flood_lastmessage text NOT NULL,
  PRIMARY KEY  (id),
  KEY lastping (lastping),
  KEY user (user)
) TYPE=MyISAM;


CREATE TABLE interact_Chat (
  id int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',  
  message text NOT NULL,
  user varchar(64) NOT NULL default '',
  flag_ripped tinyint(4) NOT NULL default '0',
  sendtime time NOT NULL default '00:00:00',
  timeid bigint(20) NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY timeid (timeid),
  Index ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#add prefix to all tables and remove redundant tables

ALTER TABLE AccessLevels RENAME AS interact_AccessLevels;
ALTER TABLE CalendarEvents RENAME AS interact_CalendarEvents;
ALTER TABLE Calendars RENAME AS interact_Calendars;
ALTER TABLE Categories RENAME AS interact_Categories;
ALTER TABLE CommonNavigationLinks RENAME AS interact_CommonNavigationLinks;
ALTER TABLE DefaultSpaceUserLinks RENAME AS interact_DefaultSpaceUserLinks;
ALTER TABLE DropboxFileStatus RENAME AS interact_DropboxFileStatus;
ALTER TABLE DropboxFiles RENAME AS interact_DropboxFiles;
ALTER TABLE DropboxSettings RENAME AS interact_DropboxSettings;
ALTER TABLE Files RENAME AS interact_Files;
ALTER TABLE FolderSettings RENAME AS interact_FolderSettings;
ALTER TABLE Forum RENAME AS interact_Forum;
ALTER TABLE ForumAutoPromptActions RENAME AS interact_ForumAutoPromptActions;
ALTER TABLE ForumAutoPrompts RENAME AS interact_ForumAutoPrompts;
ALTER TABLE ForumSettings RENAME AS interact_ForumSettings;
ALTER TABLE ForumThreadManagement RENAME AS interact_ForumThreadManagement;
ALTER TABLE GroupSettings RENAME AS interact_GroupSettings;
ALTER TABLE GroupUserLinks RENAME AS interact_GroupUserLinks;
ALTER TABLE JournalEntries RENAME AS interact_JournalEntries;
ALTER TABLE JournalEntryComments RENAME AS interact_JournalEntryComments;
ALTER TABLE JournalSettings RENAME AS interact_JournalSettings;
ALTER TABLE JournalTypes RENAME AS interact_JournalTypes;
ALTER TABLE Languages RENAME AS interact_Languages;
ALTER TABLE LinkEditRights RENAME AS interact_LinkEditRights;
ALTER TABLE ModuleEditRightLinks RENAME AS interact_ModuleEditRightLinks;
ALTER TABLE ModuleEditRights RENAME AS interact_ModuleEditRights;
ALTER TABLE ModuleSpaceLinks RENAME AS interact_ModuleSpaceLinks;
ALTER TABLE ModuleStatus RENAME AS interact_ModuleStatus;
ALTER TABLE ModuleTypes RENAME AS interact_ModuleTypes;
ALTER TABLE Modules RENAME AS interact_Modules;
ALTER TABLE News RENAME AS interact_News;
ALTER TABLE Notes RENAME AS interact_Notes;
ALTER TABLE NoticeboardSettings RENAME AS interact_NoticeboardSettings;
ALTER TABLE Notices RENAME AS interact_Notices;
ALTER TABLE Numbers RENAME AS interact_Numbers;
ALTER TABLE Pages RENAME AS interact_Pages;
ALTER TABLE PostType RENAME AS interact_PostType;
ALTER TABLE ReadPosts RENAME AS interact_ReadPosts;
ALTER TABLE SharedItemComments RENAME AS interact_SharedItemComments;
ALTER TABLE SharedItems RENAME AS interact_SharedItems;
ALTER TABLE SharingSettings RENAME AS interact_SharingSettings;
ALTER TABLE SortOrders RENAME AS interact_SortOrders;
ALTER TABLE SpaceCategoryLinks RENAME AS interact_SpaceCategoryLinks;
ALTER TABLE SpaceStatus RENAME AS interact_SpaceStatus;
ALTER TABLE SpaceType RENAME AS interact_SpaceType;
ALTER TABLE SpaceUserLinks RENAME AS interact_SpaceUserLinks;
ALTER TABLE Spaces RENAME AS interact_Spaces;
ALTER TABLE Statistics RENAME AS interact_Statistics;
ALTER TABLE UserGroups RENAME AS interact_UserGroups;
ALTER TABLE UserStatuses RENAME AS interact_UserStatuses;
ALTER TABLE UserUserGroupLinks RENAME AS interact_UserUserGroupLinks;
ALTER TABLE Users RENAME AS interact_Users;
ALTER TABLE WebLinks RENAME AS interact_WebLinks;
ALTER TABLE sessions RENAME AS interact_Sessions;