alter table interact_GroupSettings add MinimumUsers tinyint(4) NOT NULL after MaximumUsers;
alter table interact_GroupSettings add StartDate DateTime NOT NULL after MinimumUsers;
alter table interact_GroupSettings add FinishDate DateTime NOT NULL after StartDate;
alter table interact_GroupSettings add GroupManagement tinyint(1) NOT NULL after FinishDate;
alter table interact_Spaces add TypeKey tinyint(1) not null default '0' after VisibilityKey;
alter table interact_Spaces add OwnedByKey int(11) not null default '0' after TypeKey;



ALTER TABLE `interact_Modules` CHANGE `Description` `Description` text NOT NULL DEFAULT "";




CREATE TABLE `interact_event_types` (
  `event_type_key` int(11) NOT NULL auto_increment,
  `parent` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `colour` varchar(6) NOT NULL default '000000',
  PRIMARY KEY  (`event_type_key`),
  KEY `parent` (`parent`)
);



ALTER TABLE `interact_CalendarEvents` ADD `EventDateFinish` datetime NOT NULL DEFAULT "0000-00-00 00:00:00" ;
ALTER TABLE `interact_CalendarEvents` ADD INDEX `EventDateFinishIdx` (`EventDateFinish`);

ALTER TABLE `interact_CalendarEvents` ADD `DateFlags` tinyint(4) unsigned NOT NULL default "0";
ALTER TABLE `interact_CalendarEvents` ADD `Link` varchar(200) NOT NULL DEFAULT " " ;
ALTER TABLE `interact_CalendarEvents` ADD `EventType` int UNSIGNED NOT NULL DEFAULT "0" ;



CREATE TABLE `interact_colours` (
  `colour` char(6) NOT NULL default '000000'
);

INSERT INTO `interact_colours` (`colour`) VALUES ("900000"),("701818"),("863200",("522500"),("374310")("007000"),("227070"),("004080"),("000090"),("400080"),("800080"),("800040"),("844444"),("CE5C00"),("98722F"),("70703C"),("497749"),("4C8162"),("3D6381"), ("434384"),("685872"),("606060")



CREATE TABLE interact_online_users (
  user_key int(11) NOT NULL default '0',
  session_id varchar(32) NOT NULL default '',
  time int(11) NOT NULL default '0',
  polling tinyint(1) NOT NULL default '0',
  status_key tinyint(1) NOT NULL default '0',
  UNIQUE  (user_key, session_id),
  KEY user_key_idx (user_key)
) TYPE=MyISAM;

CREATE TABLE interact_user_messages (
  message_key int(11) NOT NULL auto_increment,
  added_by_key int(11) NOT NULL default '0',
  added_for_key int(11) NOT NULL default '0',
  message varchar(255) NOT NULL default '',
  status_key tinyint(1) NOT NULL default '0',  
  time int(11) NOT NULL default '0',
  PRIMARY KEY(message_key),
  KEY user_key_idx (added_for_key)
) TYPE=MyISAM;

Alter table interact_GradebookItems Add StatusKey tinyint(1) NOT NULL default '0' AFTER ContentModuleKey;

alter table interact_Skins add RawCss text not null after ContentBorderColour;

alter table interact_online_users add  status_key tinyint(1) NOT NULL default '0' after polling;

alter table interact_server_settings add  admins_add_spaces tinyint(1) NOT NULL default '0' after short_urls;


alter table interact_server_settings add  user_spaces tinyint(1) NOT NULL default '0' after admins_add_spaces;


# SCORM
# ------------------------------------------------------------

INSERT INTO `interact_ModuleTypes` (`ModuleTypeKey`,`Name`,`Code`,`Url`,`AdminUrl`,`Image`) VALUES (NULL,"SCORM Package","scorm","","","scorm");

CREATE TABLE `interact_scorm` (
  `module_key` int(11) NOT NULL default '0',
  `file_path` varchar(50) NOT NULL default '',
  `version` varchar(9) NOT NULL default '',
  `launch` int(10) unsigned NOT NULL default '0',
  `browsemode` tinyint(2) NOT NULL default '0',
  `auto` tinyint(1) unsigned NOT NULL default '0',
  `width` int(11) NOT NULL default '0',
  `height` int(11) NOT NULL default '0',
  PRIMARY KEY  (`module_key`),
  KEY `ModuleKeyIdx` (`module_key`)
) TYPE=MyISAM;

CREATE TABLE `interact_scorm_scoes` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `module_key` int(10) unsigned NOT NULL default '0',
  `manifest` varchar(255) NOT NULL default '',
  `organization` varchar(255) NOT NULL default '',
  `parent` varchar(255) NOT NULL default '',
  `identifier` varchar(255) NOT NULL default '',
  `launch` varchar(255) NOT NULL default '',
  `parameters` varchar(255) NOT NULL default '',
  `scormtype` varchar(5) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `prerequisites` varchar(200) NOT NULL default '',
  `maxtimeallowed` varchar(19) NOT NULL default '',
  `timelimitaction` varchar(19) NOT NULL default '',
  `datafromlms` varchar(255) NOT NULL default '',
  `masteryscore` varchar(200) NOT NULL default '',
  `next` tinyint(1) unsigned NOT NULL default '0',
  `previous` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `module_key` (`module_key`)
) TYPE=MyISAM;

CREATE TABLE `interact_scorm_scoes_track` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `userid` int(10) unsigned NOT NULL default '0',
  `module_key` int(10) NOT NULL default '0',
  `scoid` int(10) unsigned NOT NULL default '0',
  `element` varchar(255) NOT NULL default '',
  `value` longtext NOT NULL,
  `timemodified` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `track` (`userid`,`module_key`,`scoid`,`element`),
  KEY `userid` (`userid`),
  KEY `module_key` (`module_key`),
  KEY `scoid` (`scoid`),
  KEY `elemeny` (`element`)
) TYPE=MyISAM;






alter table interact_server_settings add  user_spaces tinyint(1) NOT NULL default '0' after admins_add_spaces;
rename table interact_Forum to interact_posts;
alter table interact_posts change PostKey post_key int(11) not null auto_increment;
alter table interact_posts change ModuleKey module_key int(11) not null default '0';
alter table interact_posts change ParentKey parent_key int(11) not null default '0';
alter table interact_posts change ThreadKey thread_key int(11) not null default '0';
alter table interact_posts change EntryKey entry_key int(11) not null default '0';
alter table interact_posts change TypeKey type_key int(11) not null default '0';
alter table interact_posts change UserKey added_by_key int(11) not null default '0';
alter table interact_posts change Subject subject varchar(100) not null default '';
alter table interact_posts change Body body mediumtext not null default '';
alter table interact_posts change DateAdded date_added datetime not null default '0000-00-00';
alter table interact_posts change StatusKey status_key tinyint(1) not null default '0';
update interact_posts set ShowPhoto='1' where ShowPhoto='t';
update interact_posts set ShowPhoto='0' where ShowPhoto='f';
alter table interact_posts change ShowPhoto settings tinyint(4) unsigned  not null default '0';
alter table interact_posts change Attachment attachment varchar(40) not null default '';
alter table interact_posts add extended_body text not null default '' after body;
alter table interact_posts add modified_by_key int(11) not null default '0' after added_by_key;
alter table interact_posts add user_key int(11) not null default '0' after modified_by_key;
alter table interact_posts add date_published datetime not null default '0000-00-00' after date_added;
alter table interact_posts add date_modified datetime not null default '0000-00-00' after date_published;
alter table interact_posts add multi_entry_key int(11) not null default '0' after entry_key;
rename table interact_PostUserLinks to interact_post_user_links;
alter table interact_post_user_links change ModuleKey module_key int(11) not null default '0';
alter table interact_post_user_links change UserKey user_key int(11) not null default '0';
alter table interact_post_user_links change PostKey post_key int(11) not null default '0';
alter table interact_post_user_links change ReadStatus read_status tinyint(2) NOT NULL default '0';
alter table interact_post_user_links change FlagStatus flag_status tinyint(2) NOT NULL default '0';
alter table interact_post_user_links change MonitorPost monitor_post tinyint(1) NOT NULL default '0';
rename table interact_JournalSettings to interact_journal_settings;
alter table interact_journal_settings change ModuleKey module_key int(11) not null default '0';
alter table interact_journal_settings change TypeKey options tinyint(4) unsigned  not null default '0';
alter table interact_journal_settings change StartDate start_date datetime not null default '0000-00-00';
alter table interact_journal_settings change FinishDate finish_date datetime not null default '0000-00-00';
alter table interact_journal_settings add entries_to_show int(2) not null default '0' AFTer options;
CREATE TABLE interact_journal_user_links (
  module_key int(11) NOT NULL default '0',
  user_key int(11) NOT NULL default '0',
  UNIQUE (module_key,user_key)
) TYPE=MyISAM;

# this next bit can only be done once existing tables are converted
drop table interact_JournalEntries;
drop table interact_JournalEntryComments;
drop table interact_JournalTypes;
#

rename table interact_Tags to interact_tagged_urls;

CREATE TABLE interact_tags (
  tag_key int(11) NOT NULL auto_increment,
  text varchar(50) NOT NULL default '0',
  PRIMARY KEY(tag_key),
  UNIQUE (text)
) TYPE=MyISAM;

CREATE TABLE interact_tag_links (
  tag_key int(11) NOT NULL default '0',
  user_key int(11) NOT NULL default '0',
  module_key int(11) NOT NULL default '0',
  entry_key int(11) NOT NULL default '0',
  url_key int(11) NOT NULL default '0',
  date_added datetime NOT NULL default '0000-00-00 00:00:00', 
  UNIQUE (tag_key,user_key,module_key,entry_key)
) TYPE=MyISAM;

CREATE TABLE interact_journal_links (
  link_key int(11) NOT NULL auto_increment,
  module_key int(11) NOT NULL default '0',
  journal_user_key int(11) NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  url varchar(255) NOT NULL default '',
  PRIMARY KEY  (link_key)
) TYPE=MyISAM;
 ALTER TABLE interact_ModuleSpaceLinks ADD AccessLevelKey int(11) NOT NULL AFTER StatusKey
 
 
 CREATE TABLE `interact_headings` (
  `module_key` int(11) NOT NULL default '0',
  `initial_state` tinyint(4) NOT NULL default '0',
  `level` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`module_key`)
) TYPE=MyISAM;
