# MySQL dump 8.14
#
# Host: localhost    Database: studentnet
#--------------------------------------------------------
# Server version	3.23.40

#
# Table structure for table 'AccessLevels'
#

CREATE TABLE interact_AccessLevels (
  AccessLevelKey tinyint(4) NOT NULL auto_increment,
  Name varchar(20) NOT NULL default '',
  PRIMARY KEY  (AccessLevelKey)
) TYPE=MyISAM;

#
# Dumping data for table 'AccessLevels'
#

INSERT INTO interact_AccessLevels VALUES (1,'Super Admin');
INSERT INTO interact_AccessLevels VALUES (2,'Staff');
INSERT INTO interact_AccessLevels VALUES (3,'Student');
INSERT INTO interact_AccessLevels VALUES (4,'Guest');

#
# Table structure for table 'CalendarEvents'
#

CREATE TABLE interact_CalendarEvents (
  EventKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  Name varchar(60) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  EventDate datetime NOT NULL default '0000-00-00 00:00:00',
  RemoveDate datetime NOT NULL default '0000-00-00 00:00:00',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (EventKey),
  KEY ModuleKeyIdx (ModuleKey),
  KEY EventDateIdx (EventDate)
) TYPE=MyISAM;

#
# Dumping data for table 'CalendarEvents'
#


#
# Table structure for table 'Calendars'
#

CREATE TABLE interact_Calendars (
  ModuleKey int(11) NOT NULL default '0',
  ParentCalendarKey int(11) NOT NULL default '0',
  Type varchar(6) NOT NULL default '',
  UNIQUE KEY ModuleKey (ModuleKey,ParentCalendarKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Calendars'
#



#
# Table structure for table 'Categories'
#

CREATE TABLE interact_Categories (
  CategoryKey int(11) NOT NULL auto_increment,
  CategoryName varchar(100) NOT NULL default '',
  CategoryParent int(11) NOT NULL default '0',
  StatusKey tinyint(2) NOT NULL default '0',
  SortOrder int(3) NOT NULL default '0',  
  PRIMARY KEY  (CategoryKey),
  UNIQUE KEY CategoryName (CategoryName,CategoryParent)
) TYPE=MyISAM;

#
# Dumping data for table 'Categories'
#



#
# Table structure for table 'CategoryExternalLinks'
#
CREATE TABLE interact_CategoryExternalLinks (
  LinkKey int(11) NOT NULL auto_increment,
  CategoryKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  Url varchar(200) NOT NULL default '',
  SortOrder int(3) NOT NULL default '0',
  PRIMARY KEY  (LinkKey),    
  KEY CategoryKeyIdx (CategoryKey)
) TYPE=MyISAM;

#
# Table structure for table 'CommonNavigationLinks'
#

CREATE TABLE interact_CommonNavigationLinks (
  LinkKey int(11) NOT NULL default '0',
  SpaceTypeKey tinyint(4) NOT NULL default '0',
  Name varchar(50) NOT NULL default '',
  Url varchar(100) NOT NULL default '',
  PRIMARY KEY  (LinkKey)
) TYPE=MyISAM;

#
# Dumping data for table 'CommonNavigationLinks'
#


#
# Table structure for table 'DefaultSpaceUserLinks'
#

CREATE TABLE interact_DefaultSpaceUserLinks (
  UserGroupKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  Permanent tinyint(1) NOT NULL default '0',
  UNIQUE KEY UserGroupKey (UserGroupKey,SpaceKey)
) TYPE=MyISAM;

#
# Table structure for table 'DefaultSpaceUserLinks'
#

CREATE TABLE interact_DateFormats (
  FormatKey int(11) NOT NULL default '0',
  Format varchar(15) NOT NULL default '',
  Type varchar(5) NOT NULL default ''  

) TYPE=MyISAM;

INSERT INTO interact_DateFormats VALUES (0,'dd-mm-yy','short');
INSERT INTO interact_DateFormats VALUES (1,'mm-dd-yy','short');
INSERT INTO interact_DateFormats VALUES (2,'d-m-yy','short');
INSERT INTO interact_DateFormats VALUES (3,'m-d-yy','short');
INSERT INTO interact_DateFormats VALUES (4,'dd-mm-yyyy','short');
INSERT INTO interact_DateFormats VALUES (5,'mm-dd-yyyy','short');
INSERT INTO interact_DateFormats VALUES (6,'d-m-yyyy','short');
INSERT INTO interact_DateFormats VALUES (7,'m-d-yyyy','short');
INSERT INTO interact_DateFormats VALUES (0,'d Jan 2003','long');
INSERT INTO interact_DateFormats VALUES (1,'d January 2003','long');
INSERT INTO interact_DateFormats VALUES (2,'January d 2003','long');
INSERT INTO interact_DateFormats VALUES (3,'Jan d 2003','long');
#
# Dumping data for table 'DefaultSpaceUserLinks'
#

#
# Table structure for table 'DropboxFileStatus'
#

CREATE TABLE interact_DropboxFileStatus (
  StatusKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  PRIMARY KEY  (StatusKey),
  UNIQUE KEY Name (Name)
) TYPE=MyISAM;

#
# Dumping data for table 'DropboxFileStatus'
#

INSERT INTO interact_DropboxFileStatus VALUES (1,'Submitted');
INSERT INTO interact_DropboxFileStatus VALUES (2,'Marked');
INSERT INTO interact_DropboxFileStatus VALUES (3,'Resubmit required');
INSERT INTO interact_DropboxFileStatus VALUES (4,'Being marked');
INSERT INTO interact_DropboxFileStatus VALUES (5,'Pass');
INSERT INTO interact_DropboxFileStatus VALUES (6,'Fail');
INSERT INTO interact_DropboxFileStatus VALUES (7,'Reviewed');

#
# Table structure for table 'DropboxFiles'
#

CREATE TABLE interact_DropboxFiles (
  FileKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  GradebookItemKey int(11) NOT NULL default '0',  
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  Status tinyint(4) NOT NULL default '0',
  DateStatusChanged datetime NOT NULL default '0000-00-00 00:00:00',
  Description varchar(50) NOT NULL default '',
  Comments text NOT NULL,
  FileName varchar(50) NOT NULL default '',
  PRIMARY KEY  (FileKey),
  KEY ModuleKeyIdx (ModuleKey),
  KEY UserKeyIdx (UserKey)
) TYPE=MyISAM;

#
# Dumping data for table 'DropboxFiles'
#

#
# Table structure for table 'DropboxSettings'
#

CREATE TABLE interact_DropboxSettings (
  ModuleKey int(11) NOT NULL default '0',
  FilePath varchar(20) NOT NULL default '',
  TypeKey tinyint(1) NOT NULL default '1',
  TimeAllowed int(4) NOT NULL default '0',
  DownloadFile varchar(40) NOT NULL default '', 
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

CREATE TABLE interact_DropboxDownloadLinks (
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  TimeDownloaded datetime NOT NULL default '0000-00-00 00:00:00',
  TimeUploaded datetime NOT NULL default '0000-00-00 00:00:00',
  FileName varchar(45) NOT NULL default '', 
  UNIQUE  (ModuleKey, UserKey)
) TYPE=MyISAM;

#
# Dumping data for table 'DropboxSettings'
#


#
# Table structure for table 'Files'
#

CREATE TABLE interact_Files (
  ModuleKey int(11) NOT NULL default '0',
  FilePath varchar(50) NOT NULL default '',
  FileName varchar(50) NOT NULL default '',
  Embedded tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (ModuleKey),
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Files'
#


#
# Table structure for table 'FolderSettings'
#

CREATE TABLE interact_FolderSettings (
  ModuleKey int(11) NOT NULL default '0',
  SortOrderKey tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'FolderSettings'
#


#
# Table structure for table 'Forum'
#

CREATE TABLE interact_Forum (
  PostKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  Threadkey int(11) NOT NULL default '0',
  EntryKey int(11) NOT NULL default '0',
  TypeKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  Subject varchar(50) NOT NULL default '',
  Body mediumtext NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  StatusKey tinyint(4) NOT NULL default '0',
  ShowPhoto char(1) NOT NULL default '',
  Attachment varchar(40) NOT NULL default '',
  PRIMARY KEY  (PostKey),
  KEY ModuleKeyIdx (ModuleKey),
  KEY ParentIdx (ParentKey),
  KEY ThreadKeyIdx (Threadkey)
) TYPE=MyISAM;

#
# Dumping data for table 'Forum'
#

#
# Table structure for table 'ForumPostUserLinks'
#

CREATE TABLE interact_ForumPostUserLinks (
  ModuleKey int(11) NOT NULL default '0',
  PostKey int(11) NOT NULL default '0',  
  UserKey int(11) NOT NULL default '0',
  ReadStatus tinyint(2) NOT NULL default '0',
  FlagStatus tinyint(2) NOT NULL default '0',  
  MonitorPost tinyint(1) NOT NULL default '0',
  UNIQUE  (PostKey,UserKey),
  KEY ModuleKeyIdx (ModuleKey),
  KEY UserKeyIdx (UserKey),
  KEY PostKeyIdx (PostKey)      
) TYPE=MyISAM;

#
# Table structure for table 'ForumAutoPromptActions'
#

CREATE TABLE interact_ForumAutoPromptActions (
  ActionKey tinyint(2) NOT NULL default '0',
  Name varchar(45) NOT NULL default '',
  PRIMARY KEY  (ActionKey)
) TYPE=MyISAM;

#
# Dumping data for table 'ForumAutoPromptActions'
#

INSERT INTO interact_ForumAutoPromptActions VALUES (1,'Replied');
INSERT INTO interact_ForumAutoPromptActions VALUES (2,'Passed');
INSERT INTO interact_ForumAutoPromptActions VALUES (3,'Passed on to selected user');
INSERT INTO interact_ForumAutoPromptActions VALUES (0,'No Action Taken Yet');
INSERT INTO interact_ForumAutoPromptActions VALUES (4,'Prompting Stopped - Minimum Posts Reached');
INSERT INTO interact_ForumAutoPromptActions VALUES (5,'Prompting Stopped - Maximum Passes Reached');
INSERT INTO interact_ForumAutoPromptActions VALUES (6,'No Response so flagged as pass');

#
# Table structure for table 'ForumAutoPrompts'
#

CREATE TABLE interact_ForumAutoPrompts (
  PostKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  DatePrompted datetime NOT NULL default '0000-00-00 00:00:00',
  DateActioned datetime NOT NULL default '0000-00-00 00:00:00',
  ActionTakenKey tinyint(2) NOT NULL default '0',
  PromptedByKey int(11) NOT NULL default '0',
  UNIQUE KEY PostKey (PostKey,UserKey)
) TYPE=MyISAM;

#
# Dumping data for table 'ForumAutoPrompts'
#


#
# Table structure for table 'ForumSettings'
#

CREATE TABLE interact_ForumSettings (
  ModuleKey int(11) NOT NULL default '0',
  ForumType varchar(10) NOT NULL default '',
  EditLevel tinyint(4) NOT NULL default '0',
  AutoPrompting tinyint(1) NOT NULL default '0',
  DaysToWaitDefault tinyint(2) NOT NULL default '0',
  NumberToPromptDefault tinyint(2) NOT NULL default '0',
  PassesAllowedDefault tinyint(2) NOT NULL default '0',
  ResponseTimeDefault tinyint(2) NOT NULL default '0',
  MinimumRepliesDefault tinyint(2) NOT NULL default '0',
  FilePath varchar(20) NOT NULL default '',
  UNIQUE KEY ModuleKey (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'ForumSettings'
#

#
# Table structure for table 'ForumThreadManagement'
#

CREATE TABLE interact_ForumThreadManagement (
  PostKey int(11) NOT NULL default '0',
  DaysToWait tinyint(2) NOT NULL default '0',
  NumberToPrompt tinyint(2) NOT NULL default '0',
  PassesAllowed tinyint(2) NOT NULL default '0',
  ResponseTime tinyint(2) NOT NULL default '0',
  MinimumReplies tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (PostKey)
) TYPE=MyISAM;

#
# Dumping data for table 'ForumThreadManagement'
#


#
# Table structure for table 'interact_GradebookItems'
#

CREATE TABLE interact_GradebookItems (
  ItemKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  ScaleKey int(11) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  Url varchar(150) NOT NULL default '', 
  ContentModuleKey int(11) NOT NULL default '0',
  SortOrder tinyint(3) NOT NULL default '0', 
  DueDate datetime NOT NULL default '0000-00-00 00:00:00',
  MaximumScore tinyint(3) NOT NULL default '0',
  Weighting tinyint(3) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM;

#
# Table structure for table 'interact_GradebookItemUserLinks'
#

CREATE TABLE interact_GradebookItemUserLinks (
  ItemKey int(11) NOT NULL auto_increment,
  UserKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  GradeKey int(3) NOT NULL default '0',
  Comments mediumtext NOT NULL,   
  UNIQUE(ItemKey, UserKey)
) TYPE=MyISAM;

#
# Table structure for table 'interact_GradebookScales'
#

CREATE TABLE interact_GradebookScales (
  ScaleKey int(11) NOT NULL auto_increment,
  Name varchar(100) NOT NULL default '',
  Description text NOT NULL default '',
  SpaceKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ScaleKey)
) TYPE=MyISAM;

INSERT INTO interact_GradebookScales VALUES (1,'Numeric','Standard numeric scale',0,0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (2,'Alpha','Standard a-f Alpha scale',0,0,'2003-11-03 10:02:23',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (3,'Pass/Fail','',0,0,'2003-11-03 10:05:25',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScales VALUES (4,'Complete','Basic complete/incomplete grading',0,0,'2003-11-03 10:06:33',0,'0000-00-00 00:00:00');


#
# Table structure for table 'interact_GradebookScaleGrades'
#

CREATE TABLE interact_GradebookScaleGrades (
  GradeKey int(11) NOT NULL auto_increment,  
  ScaleKey int(11) NOT NULL default '0',
  Grade varchar(255) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (GradeKey)
) TYPE=MyISAM;

INSERT INTO interact_GradebookScaleGrades VALUES (1,2,'A',1,'2003-11-03 10:03:36',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (2,2,'A+',1,'2003-11-03 10:03:44',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (3,2,'A-',1,'2003-11-03 10:03:49',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (4,2,'B',1,'2003-11-03 10:03:53',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (5,2,'B+',1,'2003-11-03 10:03:58',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (6,2,'B-',1,'2003-11-03 10:04:03',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (7,2,'C',1,'2003-11-03 10:04:09',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (8,2,'C+',1,'2003-11-03 10:04:13',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (9,2,'C-',1,'2003-11-03 10:04:18',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (10,2,'D',1,'2003-11-03 10:04:22',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (11,2,'D+',1,'2003-11-03 10:04:27',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (12,2,'D-',1,'2003-11-03 10:04:31',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (13,2,'E',1,'2003-11-03 10:04:37',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (14,2,'E+',1,'2003-11-03 10:04:45',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (15,2,'E-',1,'2003-11-03 10:04:50',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (16,2,'F',1,'2003-11-03 10:04:54',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (17,3,'Pass',1,'2003-11-03 10:05:37',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (18,3,'Fail',1,'2003-11-03 10:05:42',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (19,3,'Resubmit',1,'2003-11-03 10:05:49',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (20,3,'Pass with distinction',1,'2003-11-03 10:06:02',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (21,3,'Complete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00');
INSERT INTO interact_GradebookScaleGrades VALUES (22,3,'Incomplete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00');

#
# Table structure for table 'GroupSettings'
#

CREATE TABLE interact_GroupSettings (
  ModuleKey int(11) NOT NULL default '0',
  SortOrderKey tinyint(4) NOT NULL default '0',
  AccessKey tinyint(4) NOT NULL default '0',
  AccessCode varchar(10) NOT NULL default '',
  VisibilityKey tinyint(4) NOT NULL default '0',
  MaximumUsers tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'GroupSettings'
#


#
# Table structure for table 'GroupUserLinks'
#

CREATE TABLE interact_GroupUserLinks (
  GroupKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',  
  UNIQUE KEY GroupKey (GroupKey,UserKey),
  KEY GroupKeyIdx (GroupKey)
) TYPE=MyISAM;

#
# Table structure for table 'Icons'
#

CREATE TABLE interact_Icons (
  IconKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  Description varchar(255) NOT NULL default '',  
  SmallIcon varchar(30) NOT NULL default '',
  LargeIcon varchar(30) NOT NULL default '',
  Primary KEY GroupKey (IconKey)
) TYPE=MyISAM;

insert into interact_Icons values ('0','Default',' Default system icon','','');
insert into interact_Icons values ('2',' None','No icon','','');
#
# Dumping data for table 'GroupUserLinks'
#



#
# Table structure for table 'JournalEntries'
#

CREATE TABLE interact_JournalEntries (
  JournalEntryKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  MultiEntryKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  AdminKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  Body mediumtext NOT NULL,
  PRIMARY KEY  (JournalEntryKey),
  KEY UserKeyIdx (UserKey),
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalEntries'
#



#
# Table structure for table 'JournalEntryComments'
#

CREATE TABLE interact_JournalEntryComments (
  CommentKey int(11) NOT NULL auto_increment,
  JournalEntryKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified date NOT NULL default '0000-00-00',
  PRIMARY KEY  (CommentKey),
  KEY JournalEntryKeyIdx (JournalEntryKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalEntryComments'
#


#
# Table structure for table 'JournalSettings'
#

CREATE TABLE interact_JournalSettings (
  ModuleKey int(11) NOT NULL default '0',
  TypeKey tinyint(4) NOT NULL default '0',
  StartDate datetime NOT NULL default '0000-00-00 00:00:00',
  FinishDate datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalSettings'
#


#
# Table structure for table 'JournalTypes'
#

CREATE TABLE interact_JournalTypes (
  TypeKey int(11) NOT NULL auto_increment,
  Name varchar(20) NOT NULL default '',
  PRIMARY KEY  (TypeKey)
) TYPE=MyISAM;

#
# Dumping data for table 'JournalTypes'
#

INSERT INTO interact_JournalTypes VALUES (1,'Open');
INSERT INTO interact_JournalTypes VALUES (2,'Closed');

CREATE TABLE interact_KBSettings (
  ModuleKey int(11) NOT NULL default '0',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  FilePath varchar(50) NOT NULL default '',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBTemplates (
  TemplateKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  SummaryFields tinyint(1) NOT NULL default '1',  
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (TemplateKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBEntries (
  EntryKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  StatusKey tinyint(1) NOT NULL default '2',
  PRIMARY KEY  (EntryKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBEntryData (
  DataKey int(11) NOT NULL auto_increment,
  EntryKey int(11) NOT NULL default '0',
  FieldKey int(11) NOT NULL default '0',
  Data text not null default '',
  PRIMARY KEY  (DataKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBModuleTemplateLinks (
  ModuleKey int(11) NOT NULL default '0',
  TemplateKey int(11) NOT NULL default '0',
  UNIQUE  (ModuleKey, TemplateKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBEntryCategoryLinks (
  EntryKey int(11) NOT NULL default '0',
  CategoryKey int(11) NOT NULL default '0',
  UNIQUE  (EntryKey, CategoryKey)
) TYPE=MyISAM;

CREATE TABLE interact_KBFields (
  FieldKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(50) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  DisplayOrder tinyint(2) NOT NULL default '0',
  NumberOfLines tinyint(2) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',  
  PRIMARY KEY (FieldKey)
) TYPE=MyISAM;

#
# Table structure for table 'Languages'
#

CREATE TABLE interact_Languages (
  LanguageKey tinyint(4) NOT NULL auto_increment,
  Code varchar(3) NOT NULL default '',
  Name varchar(50) NOT NULL default '',
  PRIMARY KEY  (LanguageKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Languages'
#
INSERT INTO interact_Languages VALUES (1,'eng','English');
INSERT INTO interact_Languages VALUES (2,'wfl','Waffle');
INSERT INTO interact_Languages VALUES (3,'tur','Turkish');    


#
# Table structure for table 'ModuleEditRightLinks'
#

CREATE TABLE interact_ModuleEditRightLinks (
  UserKey int(11) NOT NULL default '0',
  GroupKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  LinkKey int(11) NOT NULL default '0',
  EditLevel tinyint(4) NOT NULL default '0',
  UNIQUE KEY UserKey (UserKey,GroupKey,ModuleKey,LinkKey,EditLevel)
) TYPE=MyISAM;

#
# Dumping data for table 'ModuleEditRightLinks'
#


#
# Table structure for table 'ModuleSpaceLinks'
#

CREATE TABLE interact_ModuleSpaceLinks (
  LinkKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  GroupKey int(11) NOT NULL default '0',
  StatusKey tinyint(4) NOT NULL default '0',
  IconKey int(11) NOT NULL default '1',   
  AddedByKey int(11) NOT NULL default '0',
  OwnerKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  EditRightsKey tinyint(2) NOT NULL default '0',
  ChangeStatusDate date NOT NULL default '0000-00-00',
  ChangeStatusToKey int(11) NOT NULL default '0',
  SortOrder tinyint(4) NOT NULL default '0',
  Target varchar(10) NOT NULL default '',
  PRIMARY KEY  (LinkKey),
  KEY ModuleKeyIdx (ModuleKey),
  KEY SpaceKeyIdx (SpaceKey),
  KEY ParentKeyIdx (ParentKey),
  KEY GroupKeyIdx (GroupKey),
  KEY DateAddedIdx (DateAdded)
) TYPE=MyISAM;

#
# Dumping data for table 'ModuleSpaceLinks'
#



#
# Table structure for table 'ModuleStatus'
#

CREATE TABLE interact_ModuleStatus (
  ModuleStatusKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  PRIMARY KEY  (ModuleStatusKey),
  UNIQUE KEY Name (Name)
) TYPE=MyISAM;

#
# Dumping data for table 'ModuleStatus'
#

INSERT INTO interact_ModuleStatus VALUES (1,'Visible');
INSERT INTO interact_ModuleStatus VALUES (2,'Hidden');
INSERT INTO interact_ModuleStatus VALUES (3,'Closed');

#
# Table structure for table 'ModuleTypes'
#

CREATE TABLE interact_ModuleTypes (
  ModuleTypeKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  Code varchar(15) NOT NULL default '',
  Url varchar(50) NOT NULL default '',
  AdminUrl varchar(40) NOT NULL default '',
  Image varchar(15) NOT NULL default '',
  PRIMARY KEY  (ModuleTypeKey)
) TYPE=MyISAM;

#
# Dumping data for table 'ModuleTypes'
#

INSERT INTO interact_ModuleTypes VALUES (1,'File','file','/files/file.php','/files/fileinput.php','file');
INSERT INTO interact_ModuleTypes VALUES (2,'Link','weblink','/links/goto.php','/links/linkinput.php','link');
INSERT INTO interact_ModuleTypes VALUES (3,'Discussion Forum','forum','/forums/forum.php','/forums/foruminput.php','forum');
INSERT INTO interact_ModuleTypes VALUES (4,'Folder','folder','/folders/folder.php','/folders/folderinput.php','folder');
INSERT INTO interact_ModuleTypes VALUES (5,'Note','note','/notes/note.php','/notes/noteinput.php','note');
INSERT INTO interact_ModuleTypes VALUES (6,'Group','group','/groups/group.php','/groups/groupinput.php','group');
INSERT INTO interact_ModuleTypes VALUES (7,'Calendar','calendar','/calendars/calendar.php','/calendars/calendarinput.php','calendar');
INSERT INTO interact_ModuleTypes VALUES (8,'Dropbox','dropbox','/dropboxes/dropbox.php','/dropboxes/dropboxinput.php','dropbox');
INSERT INTO interact_ModuleTypes VALUES (9,'sharing','sharing','/sharing/share.php','/sharing/sharinginput.php','sharing');
INSERT INTO interact_ModuleTypes VALUES (10,'Heading','heading','','/modules/headinginput.php','');
INSERT INTO interact_ModuleTypes VALUES (12,'Page','page','/pages/page.php','/pages/pageinput.php','page');
INSERT INTO interact_ModuleTypes VALUES (13,'Chat','chat','','','chat');
INSERT INTO interact_ModuleTypes VALUES (14,'Journal','journal','','','journal');
INSERT INTO interact_ModuleTypes VALUES (15,'Noticeboard','noticeboard','','','noticeboard');
INSERT INTO interact_ModuleTypes VALUES (16,'Gradebook','gradebook','','','gradebook');
INSERT INTO interact_ModuleTypes VALUES (17,'Quiz','quiz','','','quiz');
INSERT INTO interact_ModuleTypes VALUES (18,'KnowledgeBase','kb','','','kb');

#
# Table structure for table 'Modules'
#

CREATE TABLE interact_Modules (
  ModuleKey int(11) NOT NULL auto_increment,
  ModuleTypeKey int(11) NOT NULL default '0',
  StatusKey tinyint(4) NOT NULL default '1',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  OwnerKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  EditRightsKey tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Modules'
#


#
# Table structure for table 'News'
#

CREATE TABLE interact_News (
  NewsKey int(11) NOT NULL auto_increment,
  SpaceKey int(11) NOT NULL default '0',
  Heading varchar(60) NOT NULL default '',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  RemoveDate date NOT NULL default '0000-00-00',
  UserKey int(11) NOT NULL default '0',
  PRIMARY KEY  (NewsKey),
  KEY SpaceKeyIdx (SpaceKey)
) TYPE=MyISAM;

#
# Dumping data for table 'News'
#

#
# Table structure for table 'Notes'
#

CREATE TABLE interact_Notes (
  ModuleKey int(11) NOT NULL default '0',
  Note mediumtext NOT NULL
) TYPE=MyISAM;

#
# Dumping data for table 'Notes'
#

#
# Table structure for table 'NoticeboardSettings'
#

CREATE TABLE interact_NoticeboardSettings (
  ModuleKey int(11) NOT NULL default '0',
  TypeKey tinyint(4) NOT NULL default '0',
  DaysToKeep tinyint(2) NOT NULL default '0',  
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Table structure for table 'Notices'
#

CREATE TABLE interact_Notices (
  NoticeKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  Heading varchar(60) NOT NULL default '',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  RemoveDate date NOT NULL default '0000-00-00',
  UserKey int(11) NOT NULL default '0',
  PRIMARY KEY  (NoticeKey),
  KEY SpaceKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'News'
#

#
# Dumping data for table 'FolderSettings'
#

#
# Table structure for table 'Numbers'
#

CREATE TABLE interact_Numbers (
  NumberKey tinyint(4) NOT NULL auto_increment,
  Number int(10) NOT NULL default '0',
  PRIMARY KEY  (NumberKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Numbers'
#



#
# Table structure for table 'Pages'
#

CREATE TABLE interact_Pages (
  ModuleKey int(11) NOT NULL default '0',
  Body longtext NOT NULL
) TYPE=MyISAM;

#
# Dumping data for table 'Pages'
#



#
# Table structure for table 'PostType'
#

CREATE TABLE interact_PostType (
  TypeKey int(11) NOT NULL auto_increment,
  Name varchar(100) NOT NULL default '',
  PRIMARY KEY  (TypeKey)
) TYPE=MyISAM;

#
# Dumping data for table 'PostType'
#

INSERT INTO interact_PostType VALUES (1,'Question');
INSERT INTO interact_PostType VALUES (2,'Answer');
INSERT INTO interact_PostType VALUES (3,'Agree');
INSERT INTO interact_PostType VALUES (4,'Disagree');
INSERT INTO interact_PostType VALUES (5,'Request for clarification');
INSERT INTO interact_PostType VALUES (6,'Statement');
INSERT INTO interact_PostType VALUES (7,'Opinion');
INSERT INTO interact_PostType VALUES (8,'Greeting');
INSERT INTO interact_PostType VALUES (9,'Response');
INSERT INTO interact_PostType VALUES (11,'Suggestion');
INSERT INTO interact_PostType VALUES (12,'Hot Tip');
INSERT INTO interact_PostType VALUES (13,'Formal Task');
INSERT INTO interact_PostType VALUES (14,'Waffle');
INSERT INTO interact_PostType VALUES (15,'Comment');
INSERT INTO interact_PostType VALUES (16,'News');

CREATE TABLE interact_QuizSettings (
  ModuleKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(2) NOT NULL default '0',
  OpenDate datetime NOT NULL default '0000-00-00 00:00:00',
  CloseDate datetime NOT NULL default '0000-00-00 00:00:00',
  Attempts tinyint(2) NOT NULL default '0',
  ShuffleQuestions tinyint(1) NOT NULL default '0',
  ShuffleAnswers tinyint(1) NOT NULL default '0', 
  GradingKey tinyint(2) NOT NULL default '0',
  BuildOnPrevious tinyint(1) NOT NULL default '0',
  ShowFeedback tinyint(1) NOT NULL default '0', 
  ShowCorrect tinyint(1) NOT NULL default '0', 
  MinutesAllowed int(3) NOT NULL default '0',           
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTItem (
  ItemKey int(11) NOT NULL auto_increment,
  Name varchar(255) NOT NULL default '',
  Mattext text NOT NULL default '',
  ResponseType varchar(5) NOT NULL default '',
  RenderType varchar(20) NOT NULL default '',
  Rcardinality varchar(10) NOT NULL default '',
  Rtiming varchar(3) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  ModifiedByKey int(11) NOT NULL default '0', 
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',     
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTResponse (
  ItemKey int(11) NOT NULL default '0',
  Mattext text NOT NULL default '',
  Ident varchar(100) NOT NULL default '',
  UNIQUE  (Ident)
) TYPE=MyISAM;

CREATE TABLE interact_QTResprocessing (
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',
  Score FLOAT(3,1) NOT NULL default '',
  FeedbackType varchar(100) NOT NULL default '',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  unique(ItemKey,ResponseIdent)  
) TYPE=MyISAM;

CREATE TABLE interact_QTFeedback (
  ItemKey int(11) NOT NULL default '0',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  Mattext text NOT NULL default ''
) TYPE=MyISAM;

CREATE TABLE interact_QTCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  UserKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTCategoryItemLinks(
  CategoryKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, ItemKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTModuleItemLinks(
  LinkKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  SortOrder int(4) NOT NULL default '0',
  Score FLOAT(3,1) NOT NULL default '0',
  PRIMARY KEY  (LinkKey)
) TYPE=MyISAM;

CREATE TABLE interact_QTAttempts(
  AttemptKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  TimeStarted datetime NOT NULL default '0000-00-00 00:00:00', 
  TimeFinished datetime NOT NULL default '0000-00-00 00:00:00',    
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00', 
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (AttemptKey)
) TYPE=MyISAM;


#
# Table structure for table 'SharedItemComments'
#

CREATE TABLE interact_SharedItemComments (
  CommentKey int(11) NOT NULL auto_increment,
  SharedItemKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  Subject varchar(50) NOT NULL default '',
  Body text NOT NULL,
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (CommentKey),
  KEY SharedItemKeyIdx (SharedItemKey)
) TYPE=MyISAM;

#
# Dumping data for table 'SharedItemComments'
#


#
# Table structure for table 'SharedItems'
#

CREATE TABLE interact_SharedItems (
  SharedItemKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  Name varchar(100) NOT NULL default '',
  Description text NOT NULL,
  Url varchar(100) NOT NULL default '',
  FileName varchar(50) NOT NULL default '',
  FilePath varchar(11) NOT NULL default '',  
  PRIMARY KEY  (SharedItemKey),
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'SharedItems'
#


#
# Table structure for table 'SharingSettings'
#

CREATE TABLE interact_SharingSettings (
  ModuleKey int(11) NOT NULL default '0',
  FilePath varchar(20) NOT NULL default '',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'SharingSettings'
#

#
# Table structure for table 'SortOrders'
#

CREATE TABLE interact_SortOrders (
  SortOrderKey tinyint(4) NOT NULL auto_increment,
  SortOrder varchar(20) NOT NULL default '',
  SortSql varchar(30) NOT NULL default '',
  PRIMARY KEY  (SortOrderKey)
) TYPE=MyISAM;

#
# Dumping data for table 'SortOrders'
#

INSERT INTO interact_SortOrders VALUES (1,'Date Added','Modules.DateAdded');
INSERT INTO interact_SortOrders VALUES (2,'Date Added Desc','Modules.DateAdded DESC');
INSERT INTO interact_SortOrders VALUES (3,'Numeric','ModuleSpaceLinks.SortOrder');
INSERT INTO interact_SortOrders VALUES (4,'Alpha','Modules.Name');
INSERT INTO interact_SortOrders VALUES (5,'Date Modified','Modules.DateModified');
INSERT INTO interact_SortOrders VALUES (6,'Date Modified Desc','Modules.DateModified DESC');

#
# Table structure for table 'interact_SpaceChildLinks'
#

CREATE TABLE interact_SpaceChildLinks (
  SpaceKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  UNIQUE KEY SpaceKey (SpaceKey,ParentKey)
) TYPE=MyISAM;
INSERT INTO interact_SpaceChildLinks VALUES ('1','0');
#
# Dumping data for table 'SpaceCategoryLinks'
#


#
# Table structure for table 'SpaceStatus'
#

CREATE TABLE interact_SpaceStatus (
  SpaceStatusKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  PRIMARY KEY  (SpaceStatusKey),
  UNIQUE KEY Name (Name)
) TYPE=MyISAM;

#
# Dumping data for table 'SpaceStatus'
#

INSERT INTO interact_SpaceStatus VALUES (1,'Open');
INSERT INTO interact_SpaceStatus VALUES (2,'Restricted');
INSERT INTO interact_SpaceStatus VALUES (3,'Hidden');
INSERT INTO interact_SpaceStatus VALUES (4,'Archived');
INSERT INTO interact_SpaceStatus VALUES (5,'Public');
#
# Table structure for table 'SpaceType'
#

CREATE TABLE interact_SpaceType (
  SpaceTypeKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  PRIMARY KEY  (SpaceTypeKey),
  UNIQUE KEY Name (Name)
) TYPE=MyISAM;

#
# Dumping data for table 'SpaceType'
#

INSERT INTO interact_SpaceType VALUES (1,'Course');
INSERT INTO interact_SpaceType VALUES (2,'Intranet');
INSERT INTO interact_SpaceType VALUES (3,'Template');
INSERT INTO interact_SpaceType VALUES (4,'Personal');

#
# Table structure for table 'SpaceUserLinks'
#

CREATE TABLE interact_SpaceUserLinks (
  SpaceKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  UNIQUE KEY SpaceKey (SpaceKey,UserKey)
) TYPE=MyISAM;

#
# Dumping data for table 'SpaceUserLinks'
#



#
# Table structure for table 'Spaces'
#

CREATE TABLE interact_Spaces (
  SpaceKey int(11) NOT NULL auto_increment,
  Code varchar(20) NOT NULL default '',
  ShortName varchar(20) NOT NULL default '',
  CombineNames tinyint(1) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  VisibilityKey tinyint(4) NOT NULL default '0',
  FilePath varchar(20) NOT NULL default '',
  AccessCode varchar(15) NOT NULL default '',
  NewUserAlert varchar(5) NOT NULL default '',
  Header mediumtext NOT NULL,
  ShortDateFormatKey tinyint(4) NOT NULL default '0',
  LongDateFormatKey tinyint(4) NOT NULL default '0',
  SortOrder int(3) NOT NULL default '0',
  ShowMembers tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (SpaceKey)
) TYPE=MyISAM;

#
# Table structure for table 'Spaces'
#

CREATE TABLE interact_SpaceChildLinks (
  SpaceKey int(11) NOT NULL default '',
  ParentKey int(11) NOT NULL default '0',
  Unique  (SpaceKey,ParentKey)
) TYPE=MyISAM;

#
# Dumping data for table 'Spaces'
#



#
# Table structure for table 'Statistics'
#

CREATE TABLE interact_Statistics (
  SpaceKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  DateAccessed datetime NOT NULL default '0000-00-00 00:00:00',
  UseType varchar(5) NOT NULL default '',
  Location varchar(40) NOT NULL default ''
) TYPE=MyISAM;

#
# Dumping data for table 'Statistics'
#


#
# Table structure for table 'UserGroups'
#

CREATE TABLE interact_UserGroups (
  UserGroupKey int(6) NOT NULL auto_increment,
  GroupName varchar(50) NOT NULL default '',
  PRIMARY KEY  (UserGroupKey)
) TYPE=MyISAM;

#
# Dumping data for table 'UserGroups'
#

INSERT INTO interact_UserGroups VALUES (1,'Staff');
INSERT INTO interact_UserGroups VALUES (2,'Students');


#
# Table structure for table 'UserUserGroupLinks'
#

CREATE TABLE interact_UserUserGroupLinks (
  UserKey int(11) NOT NULL default '0',
  UserGroupKey int(11) NOT NULL default '0',
  UNIQUE KEY UserKey (UserKey,UserGroupKey)
) TYPE=MyISAM;

#
# Dumping data for table 'UserUserGroupLinks'
#



#
# Table structure for table 'Users'
#

CREATE TABLE interact_Users (
  UserKey int(11) NOT NULL,
  UserName varchar(20) NOT NULL default '',
  Password varchar(20) NOT NULL default '',
  UserIDNumber varchar(20) NOT NULL default '',
  FirstName varchar(50) NOT NULL default '',
  LastName varchar(50) NOT NULL default '',
  Email varchar(50) NOT NULL default '',
  Details mediumtext NOT NULL,
  LevelKey tinyint(4) NOT NULL default '0',
  Photo varchar(15) NOT NULL default '',
  FilePath varchar(20) NOT NULL default '',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  UseCount int(11) NOT NULL default '0',
  LastUse datetime NOT NULL default '0000-00-00 00:00:00',
  AccountStatus tinyint(4) NOT NULL default '0',
  LanguageKey tinyint(3) NOT NULL default '0',
  AutoLoadEditor tinyint(1) NOT NULL default '1',
  ReadPostsFlag tinyint(1) NOT NULL default '0',  
  PRIMARY KEY  (UserKey),
  UNIQUE KEY UserName (UserName),
  KEY UserNameIdx (UserName)
) TYPE=MyISAM;

#
# Dumping data for table 'Users'
#

ALTER TABLE interact_Users CHANGE UserKey UserKey int(11) NOT NULL auto_increment;

INSERT INTO interact_Users VALUES ('','admin','admin','','Mr','Administrator','admin@admin.com','',1,'','1/1','0000-00-00 00:00:00',107,'2003-04-23 13:03:40',1,1,1,0), ('','deleteduser','xyz123','','Deleted','User','deleted@deleteduser.com','Account used when deleting users from system - do not remove','4','','','','','','2','1',1,0);


#
# Table structure for table 'UserStatuses'
#
CREATE TABLE interact_UserStatuses (
  AccountStatusKey tinyint(4) NOT NULL auto_increment,
  Name varchar(20) NOT NULL default '',
  PRIMARY KEY  (AccountStatusKey)
) TYPE=MyISAM;

#
# Table structure for table 'Tags'
#
CREATE TABLE interact_Tags (
  TagKey int(11) NOT NULL auto_increment,
  Url varchar(255) NOT NULL default '',
  Heading varchar(100) not null default '',
  Note text NOT NULL default '',
  AddedForKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',    
  GroupKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (TagKey),
  KEY AddedForKeyIdx (AddedForKey),
  KEY SpaceKeyIdx (SpaceKey),
  KEY GroupKeyIdx (GroupKey)

) TYPE=MyISAM;

CREATE TABLE interact_TagCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM;

CREATE TABLE interact_TagCategoryLinks (
  CategoryKey int(11) NOT NULL auto_increment,
  TagKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, TagKey)
) TYPE=MyISAM;

#
# Dumping data for table 'UserStatuses'
#

INSERT INTO interact_UserStatuses VALUES ('','Active');
INSERT INTO interact_UserStatuses VALUES ('','Disabled');
INSERT INTO interact_UserStatuses VALUES ('','To be deleted');

#
# Table structure for table 'WebLinks'
#

CREATE TABLE interact_WebLinks (
  ModuleKey int(11) NOT NULL default '0',
  Url varchar(200) NOT NULL default '',
  PRIMARY KEY  (ModuleKey),
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM;

#
# Dumping data for table 'WebLinks'
#


#
# Table structure for table 'sessions'
#

CREATE TABLE interact_Sessions (
  SESSKEY varchar(32) NOT NULL default '',
  EXPIRY int(11) unsigned NOT NULL default '0',
  EXPIREREF varchar(64),
  DATA text NOT NULL,
  PRIMARY KEY  (SESSKEY),
  KEY EXPIRY (EXPIRY)
) TYPE=MyISAM;

#
# Dumping data for table 'sessions'
#


CREATE TABLE interact_ChatMessages (
   type tinyint(1) DEFAULT '0' NOT NULL,
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   m_time int(11) DEFAULT '0' NOT NULL,
   address varchar(30) NOT NULL,
   message text NOT NULL
);

CREATE TABLE interact_ChatUsers (
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   u_time int(11) DEFAULT '0' NOT NULL,
   status varchar(1) NOT NULL,
   ip varchar(16) NOT NULL,
   UNIQUE room (room, username)
);


CREATE TABLE interact_ChatRegUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   password varchar(32) NOT NULL,
   firstname varchar(64) NOT NULL,
   lastname varchar(64) NOT NULL,
   country varchar(64) NOT NULL,
   website varchar(64) NOT NULL,
   email varchar(64) NOT NULL,
   showemail tinyint(1) NOT NULL,
   perms varchar(9) NOT NULL,
   rooms varchar(128) NOT NULL,
   reg_time int(11) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   gender tinyint(1) DEFAULT '0' NOT NULL
);
INSERT INTO interact_ChatRegUsers VALUES('admin', '', '21232f297a57a5a743894a0e4a801fc3', '', '', '', '', '', 0, 'admin', '', '', '', '');

CREATE TABLE interact_ChatBanUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   rooms varchar(100) NOT NULL,
   ban_until int(11) DEFAULT '0' NOT NULL
);

#
# Table structure for table 'interact_Version'
#

CREATE TABLE interact_Version (
  Version int(11) NOT NULL default '0',
  Release varchar(10) NOT NULL default ''
) TYPE=MyISAM;
INSERT INTO interact_Version VALUES ('2004062601','1.8.8');