<?php
if (isset($argv) && $argv[1]=='c') {
	$command_line = true;
}

if (isset($argv) && $argv[2]=='snet') {
	$smartnet 		= true;
}

if ((isset($argv[3]) && $argv[3]=='v') || isset($_POST['verbose'])) {
	$verbo = true;	
} else {
	$verbo = false;
}

$header = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Interact Database Setup - Upgrade</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="../../local/skins/default/interactstyle.css" rel="stylesheet" type="text/css">
<style type="text/css">
<!--
body {
	margin: 10px;
}
-->
</style>
</head>
<body>

<div align="center"><img src="../../images/logo2.gif"></div>
<h1>Interact Database Setup  - Upgrade Existing Installation</h1>';
if (!isset($command_line)) {
	echo $header;
}
/**
* Include main config file 
*/

$CONFIG['NO_SESSION']='1';
set_time_limit(0);
//see if main confing file has already been included, if not include it

if (!isset($CONFIG['SERVER_URL'])) {
    require_once('../../local/config.inc.php');
}
require_once('testshortURLs.php');


//make a database conection
$CONN = &ADONewConnection($CONFIG['DATABASE_TYPE']); 
if (!$CONN->Connect($CONFIG['DBSERVER'],$CONFIG['DBUSER'],$CONFIG['DBPASSWORD'],$CONFIG['DATABASE'])) {

	echo '<p class="message">The setup scripts were not able to connect to the database that you have specified in your configuration files</p>'.$CONN->ErrorMsg();
	echo '<p>Please check that the following lines in your config.inc.php file are correctly set for your database<br/ >$CONFIG[\'DBUSER\']<br />$CONFIG[\'DBPASSWORD\']<br />$CONFIG[\'DATABASE\']</p>';
	echo '<p align="center"><a href="index.php">Return to setup screen</a></p>';
	exit;
	
}

if ($CONN->Execute("SELECT UserKey FROM {$CONFIG['DB_PREFIX']}Users")===false && $CONN->Execute("SELECT UserKey FROM Users")===false) {

    echo '<p class="message">You don\'t appear to have Interact installed, please check your database settings in your includes/config.inc.php file, or use the database installation option if this is a new installation of Interact.</p>';
	    echo '<p align="center"><a href="index.php">Return to setup screen</a></p>';
	exit;
}

//first see if new data direcories
if ((!isset($CONFIG['DATA_PATH'])) || (!is_dir($CONFIG['DATA_PATH']))) {

   echo '<p class="message">The data directory "'.$CONFIG['DATA_PATH'].'" does not seem to exist, please make sure this directory exists on your webserver - or change your config file $CONFIG[\'DATA_PATH\'] setting to point to a directory that does exist.</p>';
	exit;
	
}

makeDir($CONFIG['MODULE_FILE_SAVE_PATH']);
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/icons');

makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/file');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/kb');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/sharing');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/forum');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/dropbox');
makeDir($CONFIG['MODULE_FILE_SAVE_PATH'].'/scorm');
	

if (!isset($command_line)) {
	echo '<div align="center" class="quizFeedback"><p>Upgrading Database Tables...</p></div>';
}

//see if version 1.7 being upgraded

if ($CONN->Execute("SELECT JournalEntryKey FROM {$CONFIG['DB_PREFIX']}JournalEntries")===false && $CONN->Execute("SELECT JournalEntryKey FROM JournalEntries")===false && $CONN->Execute("SELECT post_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {

	run17Upgrade();
	
} 

//see if version 1.8 being upgraded

if ($CONN->Execute("SELECT SortOrderKey FROM {$CONFIG['DB_PREFIX']}SortOrders")===false && $CONN->Execute("SELECT AccountStatusKey FROM UserStatuses")===false) {

    run18Upgrade();
	
} 
//see if version 1.8.5 being upgraded

if ($CONN->Execute("SELECT Version FROM {$CONFIG['DB_PREFIX']}Version")===false) {

    run185Upgrade();
	
} 

//see if version 1.8.6 being upgraded

if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}DropboxDownloadLinks")===false) {

    require_once('updateforums.php');
	run186Upgrade();
	
} 

//see if version 1.8.7 being upgraded

if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}GroupUserLinks")===false) {

    require_once('updatecategories.php');
	run187Upgrade();
	
} 

//see if version 1.9 being upgraded

$rs = $CONN->Execute("SELECT Release FROM {$CONFIG['DB_PREFIX']}Version WHERE Release='1.9'");
if ($rs!==FALSE && !$rs->EOF) {run19Upgrade();} 


//1.9.1 had no database updates.

//see if >= version 1.9.2 being upgraded
$oldversion=$CONN->GetOne("SELECT Version FROM {$CONFIG['DB_PREFIX']}Version");

if ($oldversion) {

	//Note: a previous upgrade may have broken Version string - hence >2147483646 value.
	if ($oldversion<2005030401 || $oldversion>2147483646) {
		run2005030401Upgrade();
		$oldversion=2005030401;
	}
	
	//upgrade for 2rc2
	if ($oldversion<2005062901) {run2005062901Upgrade();}

	//upgrade for verion 2
	if ($oldversion<2005111001) {run2005111001Upgrade();}
	
	//upgrade for version 2.1B1
	if ($oldversion<2005121401) {run2005121401Upgrade();}
	
	//upgrade for version 2.1RC1
	if ($oldversion<2006011201) {run2006011201Upgrade();}

	//upgrade for version 2.2B1
	if ($oldversion<2006031601) {run2006031601Upgrade();}

	//upgrade for version 2.2RC1
	if ($oldversion<2006041201) {run2006041201Upgrade();}
	//upgrade for version 2.2RC2
	if ($oldversion<2006050301) {run2006050301Upgrade();}
	if ($oldversion<2006052301) {run2006052301Upgrade();
		if (!isset($command_line)) {
			echo '<div align="center" class="quizFeedback">
			<p>Upgrade Complete!</p>
		
			<p align="center">You should now visit the <strong><a href="'.$CONFIG['FULL_URL'].'/admin/settings.php">server settings page</a></strong> to check your settings.</a></p>';
		}
	} else {
		if (!isset($command_line)) {	
			echo '<div align="center" class="quizFeedback">
	<p>No upgrades necessary!  Your database is already up to date.</p>';
		}
	
	}
}
if (!isset($command_line)) {
	echo '<p align="center">Return to <a href="index.php">main setup page</a>.</p><p align="center"><a href="'.$CONFIG['FULL_URL'].'/">site home page</a>.</p>
</div></body></html>';
}

/////
//
// 1.7 - 1.8 upgrade functions
//
/////
function run17Upgrade() {

    global $CONN, $CONFIG, $verbo;
	if ($verbo) echo "<h2>Running version 1.7 - 1.8 upgrade functions</h2>";
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalEntries (
        JournalEntryKey int(11) NOT NULL auto_increment,
        ModuleKey int(11) NOT NULL default '0',
        MultiEntryKey int(11) NOT NULL default '0',
        UserKey int(11) NOT NULL default '0',
        AdminKey int(11) NOT NULL default '0',
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        DateModified datetime NOT NULL default '0000-00-00 00:00:00',
        Body mediumtext NOT NULL,
        PRIMARY KEY  (JournalEntryKey),
        KEY UserKeyIdx (UserKey),
        KEY ModuleKeyIdx (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalEntries table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalEntries table has been successfully created</p>';
	
    }

	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalEntryComments (
        CommentKey int(11) NOT NULL auto_increment,
        JournalEntryKey int(11) NOT NULL default '0',
        ParentKey int(11) NOT NULL default '0',
        UserKey int(11) NOT NULL default '0',
        Body text NOT NULL,
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        DateModified date NOT NULL default '0000-00-00',
        PRIMARY KEY  (CommentKey),
        KEY JournalEntryKeyIdx (JournalEntryKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalEntryComments table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalEntryComments table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalSettings (
        ModuleKey int(11) NOT NULL default '0',
        TypeKey tinyint(4) NOT NULL default '0',
        StartDate datetime NOT NULL default '0000-00-00 00:00:00',
        FinishDate datetime NOT NULL default '0000-00-00 00:00:00',
        PRIMARY KEY  (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalSettings table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalSettings table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE JournalTypes (
        TypeKey int(11) NOT NULL auto_increment,
        Name varchar(20) NOT NULL default '',
        PRIMARY KEY  (TypeKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the JournalTypes table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The JournalTypes table has been successfully created</p>';
	
    }

    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO JournalTypes VALUES 
	    (1,'Open'),
	    (2,'Closed')")===false) {

        echo '<p class="message">There was a problem adding the default JournalTypes: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default journal types have been successfully added</p>';
	
    }
	
    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO ModuleTypes VALUES (14,'Journal','journal','','','journal')")===false) {

        echo '<p class="message">There was a problem adding the journal module type: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The journal module type has been successfully added</p>';
	
    }
	    /////////////////////////////////////////////////

    if ($CONN->Execute("ALTER TABLE SharedItems ADD FilePath varchar(11) NOT NULL AFTER FileName")===false) {

        echo '<p class="message">There was a problem adding new field to the Shared Items Table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>New field for SharedItems table successfully added</p>';
	
    }
	
	return true;	
}

/////
//
// 1.8 - 1.8.5 upgrade functions
//
/////
function run18Upgrade() {

    global $CONN, $CONFIG, $verbo;
	
	if ($verbo) echo "<h2>Running version 1.8 - 1.8.5 upgrade functions</h2>";
	
		    /////////////////////////////////////////////////

    if ($CONN->Execute("SELECT FilePath FROM {$CONFIG['DB_PREFIX']}SharedItems")===false) {
	
	    if ($CONN->Execute("ALTER TABLE SharedItems ADD FilePath varchar(11) NOT NULL AFTER FileName")===false) {

            echo '<p class="message">There was a problem adding new field to the Shared Items Table: '.$CONN->ErrorMsg().'</p>';} else {

            if ($verbo) echo '<p>New field for SharedItems table successfully added</p>';
	
        }
		
	}
	
	    /////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE UserStatuses (
        AccountStatusKey tinyint(4) NOT NULL auto_increment,
        Name varchar(20) NOT NULL default '',
        PRIMARY KEY  (AccountStatusKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the UserStatuses table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The UserStatuses table has been successfully created</p>';
	
    }


    /////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO UserStatuses VALUES 
	    ('','Active'),
	    ('','Disabled')")===false) {

        echo '<p class="message">There was a problem adding the default user statuses: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default user statuses have been successfully added</p>';
	
    }
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("ALTER TABLE ModuleTypes CHANGE Image Image varchar(15) not null")===false) {

        echo '<p class="message">There was a problem update the ModuleTypes Image Field: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default ModuleTypes Image Field has been successfully updated</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("ALTER TABLE Users ADD UserIDNumber varchar(20) not null after Password")===false) {

        echo '<p class="message">There was a problem adding UserIDNumber to the User table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default UserIDNumber field has been successfully added</p>';
	
    }
	
		/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO ModuleTypes VALUES (15,'Noticeboard','noticeboard','','','noticeboard')")===false) {

        echo '<p class="message">There was a problem adding the Noticeboard module type: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The Noticeboard module type has been successfully added</p>';
	
    }
  
  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE NoticeboardSettings (
        ModuleKey int(11) NOT NULL default '0',
        TypeKey tinyint(4) NOT NULL default '0',
        DaysToKeep tinyint(2) NOT NULL default '0',
        PRIMARY KEY  (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the NoticeboardSettings table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The NoticeboardSettings table has been successfully created</p>';
	
    }
	
	  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE Notices (
        NoticeKey int(11) NOT NULL auto_increment,
        ModuleKey int(11) NOT NULL default '0',
        Heading varchar(60) NOT NULL default '',
        Body text NOT NULL,
        DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
        RemoveDate date NOT NULL default '0000-00-00',
        UserKey int(11) NOT NULL default '0',
        PRIMARY KEY  (NoticeKey),
        KEY SpaceKeyIdx (ModuleKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the Notices table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The Notices table has been successfully created</p>';
	
    }
	
		  	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE Languages (
        LanguageKey tinyint(4) NOT NULL auto_increment,
        Code varchar(3) NOT NULL default '',
        Name varchar(50) NOT NULL default '',
        PRIMARY KEY  (LanguageKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the Languages table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The Languages table has been successfully created</p>';
	
    }

	/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO Languages VALUES (1,'eng','English')")===false) {

        echo '<p class="message">There was a problem adding the default languages: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default languages have been successfully added</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("ALTER TABLE Users ADD LanguageKey  tinyint(3) after AccountStatus")===false) {

        echo '<p class="message">There was a problem adding the language key field to the Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The language key field has been successfully added</p>';
	
    }
	
	////////////////////////////////////////////////
	
    if ($CONN->Execute("UPDATE Users SET LanguageKey='1'")===false) {

        echo '<p class="message">There was a problem adding the Users language key field: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The language key field has been successfully updated</p>';
	
    }
	
		////////////////////////////////////////////////
	
    if ($CONN->Execute("DROP TABLE SortOrders")===false) {

        echo '<p class="message">There was a problem dropping the SortOrders table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The Sort Orders table has been successfully dropped</p>';
	
    }
	
	////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE SortOrders (
        SortOrderKey tinyint(4) NOT NULL auto_increment,
        SortOrder varchar(20) NOT NULL default '',
        SortSql varchar(30) NOT NULL default '',
        PRIMARY KEY  (SortOrderKey)
        ) TYPE=MyISAM")===false) {

        echo '<p class="message">There was a problem adding the SortOrders table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The SortOrders  table has been successfully created</p>';
	
    }
	
	/////////////////////////////////////////////////
	
    if ($CONN->Execute("INSERT INTO SortOrders VALUES 
	    (1,'Date Added Desc','Modules.DateAdded DESC'),
	    (2,'Numeric','ModuleSpaceLinks.SortOrder'),
	    (3,'Alpha','Modules.Name'),
	    (4,'Date Modified Desc','Modules.DateModified DESC'),
	    (5,'Date Modified','Modules.DateModified'),
	    (6,'Date Added','Modules.DateAdded')")===false) {

        echo '<p class="message">There was a problem adding the default sort orders: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The default sort orders have been successfully added</p>';
	
    }
	
	//now rename all the tables
	$CONN->Execute("ALTER TABLE AccessLevels RENAME AS {$CONFIG['DB_PREFIX']}AccessLevels");
	$CONN->Execute("ALTER TABLE CalendarEvents RENAME AS {$CONFIG['DB_PREFIX']}CalendarEvents");
	$CONN->Execute("ALTER TABLE Calendars RENAME AS {$CONFIG['DB_PREFIX']}Calendars");
	$CONN->Execute("ALTER TABLE Categories RENAME AS {$CONFIG['DB_PREFIX']}Categories");
	$CONN->Execute("ALTER TABLE CommonNavigationLinks RENAME AS {$CONFIG['DB_PREFIX']}CommonNavigationLinks");	
	$CONN->Execute("ALTER TABLE DefaultSpaceUserLinks RENAME AS {$CONFIG['DB_PREFIX']}DefaultSpaceUserLinks");
	$CONN->Execute("ALTER TABLE DropboxFileStatus RENAME AS {$CONFIG['DB_PREFIX']}DropboxFileStatus");
	$CONN->Execute("ALTER TABLE DropboxFiles RENAME AS {$CONFIG['DB_PREFIX']}DropboxFiles");
	$CONN->Execute("ALTER TABLE DropboxSettings RENAME AS {$CONFIG['DB_PREFIX']}DropboxSettings");
	$CONN->Execute("ALTER TABLE Files RENAME AS {$CONFIG['DB_PREFIX']}Files");
	$CONN->Execute("ALTER TABLE FolderSettings RENAME AS {$CONFIG['DB_PREFIX']}FolderSettings");							
	$CONN->Execute("ALTER TABLE Forum RENAME AS {$CONFIG['DB_PREFIX']}posts");
	$CONN->Execute("ALTER TABLE ForumAutoPromptActions RENAME AS {$CONFIG['DB_PREFIX']}ForumAutoPromptActions");
	$CONN->Execute("ALTER TABLE ForumAutoPrompts RENAME AS {$CONFIG['DB_PREFIX']}ForumAutoPrompts");
	$CONN->Execute("ALTER TABLE ForumThreadManagement RENAME AS {$CONFIG['DB_PREFIX']}ForumThreadManagement");
	$CONN->Execute("ALTER TABLE ForumSettings RENAME AS {$CONFIG['DB_PREFIX']}ForumSettings");

	$CONN->Execute("ALTER TABLE GroupSettings RENAME AS {$CONFIG['DB_PREFIX']}GroupSettings");	
	$CONN->Execute("ALTER TABLE GroupUserLinks RENAME AS {$CONFIG['DB_PREFIX']}GroupUserLinks");
	$CONN->Execute("ALTER TABLE JournalEntries RENAME AS {$CONFIG['DB_PREFIX']}JournalEntries");
	$CONN->Execute("ALTER TABLE JournalEntryComments RENAME AS {$CONFIG['DB_PREFIX']}JournalEntryComments");
	$CONN->Execute("ALTER TABLE JournalSettings RENAME AS {$CONFIG['DB_PREFIX']}JournalSettings");
	$CONN->Execute("ALTER TABLE JournalTypes RENAME AS {$CONFIG['DB_PREFIX']}JournalTypes;");					
	$CONN->Execute("ALTER TABLE Languages RENAME AS {$CONFIG['DB_PREFIX']}Languages");					
	$CONN->Execute("ALTER TABLE LinkEditRights RENAME AS {$CONFIG['DB_PREFIX']}LinkEditRights");					
	$CONN->Execute("ALTER TABLE ModuleEditRightLinks RENAME AS {$CONFIG['DB_PREFIX']}ModuleEditRightLinks");					
	$CONN->Execute("ALTER TABLE ModuleEditRights RENAME AS {$CONFIG['DB_PREFIX']}ModuleEditRights");					
	$CONN->Execute("ALTER TABLE ModuleSpaceLinks RENAME AS {$CONFIG['DB_PREFIX']}ModuleSpaceLinks");					
	$CONN->Execute("ALTER TABLE ModuleStatus RENAME AS {$CONFIG['DB_PREFIX']}ModuleStatus");					
	$CONN->Execute("ALTER TABLE ModuleTypes RENAME AS {$CONFIG['DB_PREFIX']}ModuleTypes");					
	$CONN->Execute("ALTER TABLE News RENAME AS {$CONFIG['DB_PREFIX']}News");
	$CONN->Execute("ALTER TABLE Notes RENAME AS {$CONFIG['DB_PREFIX']}Notes");
    $CONN->Execute("ALTER TABLE Notices RENAME AS {$CONFIG['DB_PREFIX']}Notices");	
	$CONN->Execute("ALTER TABLE NoticeboardSettings RENAME AS {$CONFIG['DB_PREFIX']}NoticeboardSettings");
	$CONN->Execute("ALTER TABLE Pages RENAME AS {$CONFIG['DB_PREFIX']}Pages");
    $CONN->Execute("ALTER TABLE PostType RENAME AS {$CONFIG['DB_PREFIX']}PostType");	
	$CONN->Execute("ALTER TABLE ReadPosts RENAME AS {$CONFIG['DB_PREFIX']}ReadPosts");
	$CONN->Execute("ALTER TABLE SharedItemComments RENAME AS {$CONFIG['DB_PREFIX']}SharedItemComments");
	$CONN->Execute("ALTER TABLE SharedItems RENAME AS {$CONFIG['DB_PREFIX']}SharedItems");
	$CONN->Execute("ALTER TABLE SharingSettings RENAME AS {$CONFIG['DB_PREFIX']}SharingSettings");
	$CONN->Execute("ALTER TABLE SortOrders RENAME AS {$CONFIG['DB_PREFIX']}SortOrders");
	$CONN->Execute("ALTER TABLE SpaceCategoryLinks RENAME AS {$CONFIG['DB_PREFIX']}SpaceCategoryLinks");
	$CONN->Execute("ALTER TABLE SpaceStatus RENAME AS {$CONFIG['DB_PREFIX']}SpaceStatus");
	$CONN->Execute("ALTER TABLE SpaceType RENAME AS {$CONFIG['DB_PREFIX']}SpaceType");
	$CONN->Execute("ALTER TABLE SpaceUserLinks RENAME AS {$CONFIG['DB_PREFIX']}SpaceUserLinks");
	$CONN->Execute("ALTER TABLE Spaces RENAME AS {$CONFIG['DB_PREFIX']}Spaces");
	$CONN->Execute("ALTER TABLE Statistics RENAME AS {$CONFIG['DB_PREFIX']}Statistics");
	$CONN->Execute("ALTER TABLE UserGroups RENAME AS {$CONFIG['DB_PREFIX']}UserGroups");
	$CONN->Execute("ALTER TABLE UserStatuses RENAME AS {$CONFIG['DB_PREFIX']}UserStatuses");
	$CONN->Execute("ALTER TABLE UserUserGroupLinks RENAME AS {$CONFIG['DB_PREFIX']}UserUserGroupLinks");
	$CONN->Execute("ALTER TABLE Users RENAME AS {$CONFIG['DB_PREFIX']}Users");
	$CONN->Execute("ALTER TABLE WebLinks RENAME AS {$CONFIG['DB_PREFIX']}WebLinks");
	$CONN->Execute("ALTER TABLE sessions RENAME AS {$CONFIG['DB_PREFIX']}Sessions");
	$CONN->Execute("ALTER TABLE Modules RENAME AS {$CONFIG['DB_PREFIX']}Modules");																										

	return true;	
}

/////
//
// 1.8.5 - 1.8.6 upgrade functions
//
/////
function run185Upgrade() {

    global $CONN, $CONFIG, $verbo;
	if ($verbo) echo "<h2>Running version 1.8.5 - 1.8.6 upgrade functions</h2>";


	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES ('','Gradebook','gradebook','','','gradebook')")===false) {

        echo '<p class="message">There was a problem adding the gradebook '.$CONFIG['DB_PREFIX'].'ModuleTypes table values: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table values have been successfully added</p>';
	
    }	
	
	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}UserStatuses VALUES ('','To be deleted')")===false) {

        echo '<p class="message">There was a problem adding the to be deleted value '.$CONFIG['DB_PREFIX'].'UserStatuses table value: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table values have been successfully added</p>';
	
    }
	
	///////////////////////////////////////////////////////

 if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookItems (
  ItemKey int(11) NOT NULL auto_increment,
  ModuleKey int(11) NOT NULL default '0',
  ScaleKey int(11) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  Url varchar(150) NOT NULL default '', 
  ContentModuleKey int(11) NOT NULL default '0',
  SortOrder tinyint(3) NOT NULL default '0', 
  DueDate datetime NOT NULL default '0000-00-00 00:00:00',
  MaximumScore tinyint(3) NOT NULL default '0',
  Weighting tinyint(3) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookItems  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookItems table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookItemUserLinks (
  ItemKey int(11) NOT NULL auto_increment,
  UserKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  GradeKey int(3) NOT NULL default '0',
  Comments mediumtext NOT NULL,   
  UNIQUE(ItemKey, UserKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookItemUserLinks  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookItemUserLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookScales (
  ScaleKey int(11) NOT NULL auto_increment,
  Name varchar(100) NOT NULL default '',
  Description text NOT NULL default '',
  SpaceKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ScaleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookScales table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookScales table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}GradebookScales VALUES 
(1,'Numeric','Standard numeric scale',0,0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00'),
(2,'Alpha','Standard a-f Alpha scale',0,0,'2003-11-03 10:02:23',0,'0000-00-00 00:00:00'),
(3,'Pass/Fail','',0,0,'2003-11-03 10:05:25',0,'0000-00-00 00:00:00'),
(4,'Complete','Basic complete/incomplete grading',0,0,'2003-11-03 10:06:33',0,'0000-00-00 00:00:00')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'GradebookScales table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'GradebookScales table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}GradebookScaleGrades (
  GradeKey int(11) NOT NULL auto_increment,  
  ScaleKey int(11) NOT NULL default '0',
  Grade varchar(255) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (GradeKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}GradebookScaleGrades VALUES 
(1,2,'A',1,'2003-11-03 10:03:36',0,'0000-00-00 00:00:00'),
(2,2,'A+',1,'2003-11-03 10:03:44',0,'0000-00-00 00:00:00'),
(3,2,'A-',1,'2003-11-03 10:03:49',0,'0000-00-00 00:00:00'),
(4,2,'B',1,'2003-11-03 10:03:53',0,'0000-00-00 00:00:00'),
(5,2,'B+',1,'2003-11-03 10:03:58',0,'0000-00-00 00:00:00'),
(6,2,'B-',1,'2003-11-03 10:04:03',0,'0000-00-00 00:00:00'),
(7,2,'C',1,'2003-11-03 10:04:09',0,'0000-00-00 00:00:00'),
(8,2,'C+',1,'2003-11-03 10:04:13',0,'0000-00-00 00:00:00'),
(9,2,'C-',1,'2003-11-03 10:04:18',0,'0000-00-00 00:00:00'),
(10,2,'D',1,'2003-11-03 10:04:22',0,'0000-00-00 00:00:00'),
(11,2,'D+',1,'2003-11-03 10:04:27',0,'0000-00-00 00:00:00'),
(12,2,'D-',1,'2003-11-03 10:04:31',0,'0000-00-00 00:00:00'),
(13,2,'E',1,'2003-11-03 10:04:37',0,'0000-00-00 00:00:00'),
(14,2,'E+',1,'2003-11-03 10:04:45',0,'0000-00-00 00:00:00'),
(15,2,'E-',1,'2003-11-03 10:04:50',0,'0000-00-00 00:00:00'),
(16,2,'F',1,'2003-11-03 10:04:54',0,'0000-00-00 00:00:00'),
(17,3,'Pass',1,'2003-11-03 10:05:37',0,'0000-00-00 00:00:00'),
(18,3,'Fail',1,'2003-11-03 10:05:42',0,'0000-00-00 00:00:00'),
(19,3,'Resubmit',1,'2003-11-03 10:05:49',0,'0000-00-00 00:00:00'),
(20,3,'Pass with distinction',1,'2003-11-03 10:06:02',0,'0000-00-00 00:00:00'),
(21,3,'Complete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00'),
(22,3,'Incomplete',1,'2003-11-03 10:06:45',0,'0000-00-00 00:00:00')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'GradebookScaleGrades table </p>';
	
}



if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Users VALUES ('','deleteduser','xyz123','','Deleted','User','deleted@deleteduser.com','Account used when deleting users from system - do not remove','4','','','','','','2','1')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Users table </p>';
	
}
	
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}UserNotes (
  UserNoteKey tinyint(4) NOT NULL auto_increment,
  Url varchar(255) NOT NULL default '',
  Note text NOT NULL default '',
  AddedForKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',    
  GroupKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (UserNoteKey),
  KEY AddedForKeyIdx (AddedForKey),
  KEY SpaceKeyIdx (SpaceKey),
  KEY GroupKeyIdx (GroupKey)
) TYPE=MyISAM")===false) {


    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'UserNotes  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNotes table has been successfully created</p>';
	
}
		
///////////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxFiles ADD GradebookItemKey int(11) NOT NULL default '0' AFTER UserKey")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'DropboxFiles  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxFiles table has been successfully updated</p>';
	
}


/////////////////////////////////////////////////


if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}DateFormats (
  FormatKey int(11) NOT NULL default '0',
  Format varchar(15) NOT NULL default '',
  Type varchar(5) NOT NULL default ''  
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'DateFormats table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DateFormats table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}DateFormats VALUES (0,'dd-mm-yy','short'),
(1,'mm-dd-yy','short'),
(2,'d-m-yy','short'),
(3,'m-d-yy','short'),
(4,'dd-mm-yyyy','short'),
(5,'mm-dd-yyyy','short'),
(6,'d-m-yyyy','short'),
(7,'m-d-yyyy','short'),
(0,'d Jan 2003','long'),
(1,'d January 2003','long'),
(2,'January d 2003','long'),
(3,'Jan d 2003','long')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'DateFormats table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'DateFormats table </p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShortDateFormatKey tinyint(4) NOT NULL AFTER Header")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD LongDateFormatKey  tinyint(4) NOT NULL AFTER Header")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
}
/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}SpaceStatus VALUES 
(3,'Hidden'),
(4,'Archived')")===false) {

    echo '<p class="message">There was a problem adding values to  the '.$CONFIG['DB_PREFIX'].'SpaceStatus table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus table was successfuly updated</p>';
	
}

	/////////////////////////////////////////////////

    if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Version (
        Version int(11) NOT NULL default '0',
        Release varchar(10) NOT NULL default ''
        ) TYPE=MyISAM;")===false) {

        echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Version table has been successfully created</p>';
	
    }
	/////////////////////////////////////////////////

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Version VALUES ('2003120101','1.8.6')")===false) {

        echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Version table values: '.$CONN->ErrorMsg().'</p>';
	
    } else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Version table values have been successfully added</p>';
	
    }	

	return true;	
}

/////
//
// 1.8.6 - 1.8.7 upgrade functions
//
/////
function run186Upgrade() {

    global $CONN, $CONFIG, $verbo;
/////////////////////////////////////////////////

if ($verbo) echo "<h2>Running version 1.8.6 - 1.8.7 upgrade functions</h2>";
if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}Categories")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Categories ADD StatusKey tinyint(2) NOT NULL AFTER CategoryParent")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories Status field already exists</p>';

}

/////////////////////////////////////////////////

if ($CONN->Execute("SELECT SortOrder FROM {$CONFIG['DB_PREFIX']}Categories")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Categories ADD SortOrder int(3) NOT NULL AFTER StatusKey")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories SortOrder field already exists</p>';

}

/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT SortOrder FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SortOrder int(3) NOT NULL AFTER LongDateFormatKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces SortOrder field already exists</p>';

}


/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT Type FROM {$CONFIG['DB_PREFIX']}Calendars")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Calendars ADD Type varchar(6) NOT NULL AFTER ParentCalendarKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Calendars table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Calendars table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Calendars Type field already exists</p>';

}
/////////////////////////////////////////////////////////////////

if ($CONN->Execute("SELECT FilePath FROM {$CONFIG['DB_PREFIX']}ForumSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ForumSettings ADD FilePath varchar(20) NOT NULL default '' AFTER MinimumRepliesDefault")===false) {

        echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'ForumSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ForumSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ForumSettings FilePath field already exists</p>';

}

if ($CONN->Execute("SELECT Attachment FROM {$CONFIG['DB_PREFIX']}posts")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts ADD Attachment varchar(40) NOT NULL default '' AFTER ShowPhoto")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum Attachment field already exists</p>';

}

if ($CONN->Execute("SELECT AutoLoadEditor FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    if ($CONN->Execute("Alter table {$CONFIG['DB_PREFIX']}Users ADD AutoLoadEditor tinyint(1) NOT NULL default '1' AFTER LanguageKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'User AutoLoadEditor field already exists</p>';

}




    if ($CONN->Execute("alter table {$CONFIG['DB_PREFIX']}Modules change Description Description text not null")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Modules table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Modules table was successfuly updated</p>';
	
    }
	
if ($CONN->Execute("SELECT TypeKey FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD TypeKey tinyint(1) NOT NULL default '1' AFTER FilePath")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings Type field already exists</p>';

}

if ($CONN->Execute("SELECT TimeAllowed FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD TimeAllowed int(4) NOT NULL default '0' AFTER TypeKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings TimeAllowed field already exists</p>';

}

if ($CONN->Execute("SELECT DownloadFile FROM {$CONFIG['DB_PREFIX']}DropboxSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}DropboxSettings ADD DownloadFile varchar(40) NOT NULL default '' AFTER TimeAllowed")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'DropboxSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxSettings DownloadFile field already exists</p>';

}


$rs = $CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}AccessLevels WHERE AccessLevelKey='5'");

if ($rs->RecordCount()<1) {
    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}AccessLevels values ('5','Permanent Guest')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'AccessLevels table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'AccessLevels table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'AccessLevels permanent guest level already exists</p>';

}

$rs = $CONN->Execute("SELECT SpaceStatusKey FROM {$CONFIG['DB_PREFIX']}SpaceStatus WHERE SpaceStatusKey='5'");
if ($rs->RecordCount()<1) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}SpaceStatus VALUES (5,'Public')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'SpaceStatus table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceStatus public access level already exists</p>';

}

$rs = $CONN->Execute("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE ModuleTypeKey='17'");
if ($rs->RecordCount()<1) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES (17,'Quiz','quiz','','','quiz')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes quiz module settings already exist</p>';

}

//drop existing chat tables
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}Chat");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatUsers");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatBannlist");
$CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}ChatRegisteredUsers");
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QuizSettings (
  ModuleKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(2) NOT NULL default '0',
  OpenDate datetime NOT NULL default '0000-00-00 00:00:00',
  CloseDate datetime NOT NULL default '0000-00-00 00:00:00',
  Attempts tinyint(2) NOT NULL default '0',
  ShuffleQuestions tinyint(1) NOT NULL default '0',
  ShuffleAnswers tinyint(1) NOT NULL default '0', 
  GradingKey tinyint(2) NOT NULL default '0',
  BuildOnPrevious tinyint(1) NOT NULL default '0',
  ShowFeedback tinyint(1) NOT NULL default '0', 
  ShowCorrect tinyint(1) NOT NULL default '0',
  MinutesAllowed int(3) NOT NULL default '0',            
  KEY ModuleKeyIdx (ModuleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QuizSettings table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QuizSettings table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTItem (
  ItemKey int(11) NOT NULL auto_increment,
  Name varchar(255) NOT NULL default '',
  Mattext text NOT NULL default '',
  ResponseType varchar(5) NOT NULL default '',
  RenderType varchar(20) NOT NULL default '',
  Rcardinality varchar(10) NOT NULL default '',
  Rtiming varchar(3) NOT NULL default '',
  AddedByKey int(11) NOT NULL default '0',
  ModifiedByKey int(11) NOT NULL default '0', 
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',     
  PRIMARY KEY  (ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTItem table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTItem table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTResponse (
  ItemKey int(11) NOT NULL default '0',
  Mattext text NOT NULL default '',
  Ident varchar(100) NOT NULL default '',
  UNIQUE  (Ident)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTResponse table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResponse table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTResprocessing (
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',
  Score tinyint(3) NOT NULL default '',
  FeedbackType varchar(100) NOT NULL default '',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  unique(ItemKey,ResponseIdent)  
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTResprocessing table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResprocessing table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTFeedback (
  ItemKey int(11) NOT NULL default '0',
  FeedbackLinkrefid varchar(100) NOT NULL default '',
  Mattext text NOT NULL default ''
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTFeedback table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTFeedback table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  UserKey int(11) NOT NULL default '0',
  SpaceKey int(11) NOT NULL default '0',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTCategories table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTCategories table has been successfully created</p>';
	
}


///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTCategoryItemLinks(
  CategoryKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTCategoryItemLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTCategoryItemLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTModuleItemLinks(
  LinkKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  ItemKey int(11) NOT NULL default '0',
  SortOrder int(4) NOT NULL default '0',
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (LinkKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTAttempts(
  AttemptKey int(11) NOT NULL auto_increment,  
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',
  TimeStarted datetime NOT NULL default '0000-00-00 00:00:00', 
  TimeFinished datetime NOT NULL default '0000-00-00 00:00:00',    
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00', 
  Score int(4) NOT NULL default '0',
  PRIMARY KEY  (AttemptKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTAttempts table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTAttempts table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}QTAttemptsData(
  AttemptKey int(11) NOT NULL auto_increment,  
  ItemKey int(11) NOT NULL default '0',
  ResponseIdent varchar(100) NOT NULL default '',
  Correct tinyint(1) NOT NULL default '0',  
  Unique (AttemptKey, ItemKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'QTAttemptsData table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTAttemptsData table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatMessages (
   type tinyint(1) DEFAULT '0' NOT NULL,
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   m_time int(11) DEFAULT '0' NOT NULL,
   address varchar(30) NOT NULL,
   message text NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatMessages  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatMessages table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatUsers (
   room varchar(60) NOT NULL,
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   u_time int(11) DEFAULT '0' NOT NULL,
   status varchar(1) NOT NULL,
   ip varchar(16) NOT NULL,
   UNIQUE room (room, username)
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatUsers table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatRegUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   password varchar(32) NOT NULL,
   firstname varchar(64) NOT NULL,
   lastname varchar(64) NOT NULL,
   country varchar(64) NOT NULL,
   website varchar(64) NOT NULL,
   email varchar(64) NOT NULL,
   showemail tinyint(1) NOT NULL,
   perms varchar(9) NOT NULL,
   rooms varchar(128) NOT NULL,
   reg_time int(11) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   gender tinyint(1) DEFAULT '0' NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatRegUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatRegUsers table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ChatRegUsers VALUES
('admin', '', '21232f297a57a5a743894a0e4a801fc3', '', '', '', '', '', 0, 'admin', '', '', '', '')")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'ChatRegUsers table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'ChatRegUsers table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}ChatBanUsers (
   username varchar(30) NOT NULL,
   latin1 tinyint(1) DEFAULT '0' NOT NULL,
   ip varchar(16) NOT NULL,
   rooms varchar(100) NOT NULL,
   ban_until int(11) DEFAULT '0' NOT NULL
)")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'ChatBanUsers  table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ChatBanUsers table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004040501', Release='1.8.7'
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
	
}
/////////////////////////////////////////////////


if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}CategoryExternalLinks (
  LinkKey int(11) NOT NULL auto_increment,
  CategoryKey int(11) NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  Url varchar(200) NOT NULL default '',
  SortOrder int(3) NOT NULL default '0',
  PRIMARY KEY  (LinkKey),    
  KEY CategoryKeyIdx (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'CategoryExternalLinks table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CategoryExternalLinks table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Categories SET StatusKey='1'")===false) {

    echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Categories table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Categories table has been successfully updated</p>';
	
}
///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}DropboxDownloadLinks (
  ModuleKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  TimeDownloaded datetime NOT NULL default '0000-00-00 00:00:00',
  TimeUploaded datetime NOT NULL default '0000-00-00 00:00:00',
  FileName varchar(45) NOT NULL default '', 
  UNIQUE  (ModuleKey, UserKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'DropboxDownloadLinks table: '.$CONN->ErrorMsg().'</p>';
	
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'DropboxDownloadLinks table has been successfully created</p>';
	
}

//remove waffle language settings

$rs = $CONN->Execute("SELECT LanguageKey FROM {$CONFIG['DB_PREFIX']}Languages WHERE Code='wfl'"); 
while (!$rs->EOF) {

    $language_key = $rs->fields[0];
	$rs->MoveNext();
	
}
$CONN->Execute("DELETE FROM {$CONFIG['DB_PREFIX']}Languages WHERE LanguageKey='$language_key'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Languages SET LanguageKey='1' WHERE LanguageKey='$language_key'");
return true;

}

/////
//
// 1.8.7 - 1.8.8 upgrade functions
//
/////
function run187Upgrade() {

    global $CONN, $CONFIG, $verbo;
/////////////////////////////////////////////////

if ($verbo) echo "<h2>Running version 1.8.7 - 1.8.8 upgrade functions</h2>";
if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}GroupUserLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupUserLinks ADD DateAdded datetime NOT NULL default '0000-00-00 00:00:00' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupUserLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupUserLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupUserLinks DateAdded field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}SpaceUserLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}SpaceUserLinks ADD DateAdded datetime NOT NULL default '0000-00-00 00:00:00' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'SpaceUserLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceUserLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceUserLinks DateAdded field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessKey FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD AccessKey tinyint(4) NOT NULL default '1' AFTER SortOrderKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings AccessKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessCode FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD AccessCode varchar(10) NOT NULL default '' AFTER AccessKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings AccessCode field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT VisibilityKey FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD VisibilityKey tinyint(4) NOT NULL default '2' AFTER AccessCode")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings VisibilityKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT MaximumUsers FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD MaximumUsers tinyint(4) NOT NULL default '0' AFTER VisibilityKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings MaximumUsers field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT IconKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD IconKey int(11) NOT NULL default '1' AFTER StatusKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks IconKey field already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Icons (
  IconKey int(11) NOT NULL auto_increment,
  Name varchar(30) NOT NULL default '',
  Description varchar(255) NOT NULL default '',  
  SmallIcon varchar(30) NOT NULL default '',
  LargeIcon varchar(30) NOT NULL default '',
  Primary KEY GroupKey (IconKey)
) TYPE=MyISAM;")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Icons table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Icons table has been successfully created</p>';
	
}

/////////////////////////////////////////////////


if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Icons VALUES 
	('0','Default',' Default system icon','',''),
	('2',' None','No icon','','')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Icons table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Icons table </p>';
	
}

//////////////////////////////////////////////////

$rs = $CONN->Execute("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='kb'");
if ($rs->EOF) {

    if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes VALUES ('','KnowledgeBase','kb','','','kb')")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes KB entry already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBSettings (
  ModuleKey int(11) NOT NULL default '0',
  AccessLevelKey tinyint(4) NOT NULL default '0',
  FilePath varchar(50) NOT NULL default '',
  PRIMARY KEY  (ModuleKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBSettings table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBSettings table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBCategories table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBCategories table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBTemplates (
  TemplateKey int(11) NOT NULL auto_increment,
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(100) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  SummaryFields tinyint(1) NOT NULL default '1',  
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (TemplateKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBTemplates table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}KBTemplates VALUES 
(1,0,'Glossary','For entering word definitions',1,4,'2004-06-08 14:08:06',0,'0000-00-00 00:00:00'),
(2,0,'FAQs','For entering Frequently Asked Questions',1,4,'2004-07-05 15:39:16',0,'0000-00-00 00:00:00'),
(3,0,'Files','For sharing files',1,4,'2004-07-05 15:47:38',0,'0000-00-00 00:00:00'),
(4,0,'Links','For sharing links to websites',1,4,'2004-07-05 15:48:50',0,'0000-00-00 00:00:00')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
		
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'KBtemplates table </p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntries (
  EntryKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  ModuleKey int(11) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (EntryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntries table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntries table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntryData (
  DataKey int(11) NOT NULL auto_increment,
  EntryKey int(11) NOT NULL default '0',
  FieldKey int(11) NOT NULL default '0',
  Data text not null default '',
  PRIMARY KEY  (DataKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntryData table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntryData table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBModuleTemplateLinks (
  ModuleKey int(11) NOT NULL default '0',
  TemplateKey int(11) NOT NULL default '0',
  UNIQUE  (ModuleKey, TemplateKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBModuleTemplateLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBModuleTemplateLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBEntryCategoryLinks (
  EntryKey int(11) NOT NULL default '0',
  CategoryKey int(11) NOT NULL default '0',
  UNIQUE  (EntryKey, CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBEntryCategoryLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntryCategoryLinks table has been successfully created</p>';
	
}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}KBFields (
  FieldKey int(11) NOT NULL auto_increment,
  TemplateKey int(11) NOT NULL default '0',
  TypeKey tinyint(1) NOT NULL default '0',
  Name varchar(50) NOT NULL default '',
  Description varchar(255) NOT NULL default '',
  DisplayOrder tinyint(2) NOT NULL default '0',
  NumberOfLines tinyint(2) NOT NULL default '0',
  AddedByKey int(11) NOT NULL default '0',
  DateAdded datetime NOT NULL default '0000-00-00 00:00:00',
  ModifiedByKey int(11) NOT NULL default '0',
  DateModified datetime NOT NULL default '0000-00-00 00:00:00',  
  PRIMARY KEY (FieldKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'KBFields table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBFields table has been successfully created</p>';
	
}

/////////////////////////////////////////////////

if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}KBFields VALUES 
(1,1,1,'Word','Enter the word to be defined',1,1,4,'2004-06-08 14:08:27',0,'0000-00-00 00:00:00'),
(2,1,1,'Definition','Enter the definition of the word',2,15,4,'2004-06-08 14:08:45',0,'0000-00-00 00:00:00'),
(3,2,1,'Question','Enter question including ?',1,1,4,'2004-07-05 15:45:56',0,'0000-00-00 00:00:00'),
(4,2,1,'Answer','Enter the answer to the question',2,15,4,'2004-07-05 15:46:17',0,'0000-00-00 00:00:00'),
(5,3,1,'Title','Title of file',1,1,4,'2004-07-05 15:47:55',0,'0000-00-00 00:00:00'),
(6,3,1,'Description','Description of file',2,15,4,'2004-07-05 15:48:13',0,'0000-00-00 00:00:00'),
(7,3,3,'File','Upload file',3,0,4,'2004-07-05 15:48:30',0,'0000-00-00 00:00:00'),
(8,4,1,'Title','Title of website',1,1,4,'2004-07-05 15:49:22',0,'0000-00-00 00:00:00'),
(9,4,1,'Description','Description of website',2,15,4,'2004-07-05 15:49:42',0,'0000-00-00 00:00:00'),
(10,4,2,'Url','Url of website',3,0,4,'2004-07-05 15:49:55',0,'0000-00-00 00:00:00')
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'KBTemplates table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'KBtemplates table </p>';
	
}

///////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}QTModuleItemLinks CHANGE Score Score FLOAT(3,1) not null default '0'")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTModuleItemLinks table has been successfully updated</p>';
	
}

///////////////////////////////////////////////////

if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}QTResprocessing CHANGE Score Score FLOAT(3,1) not null default '0'")===false) {

    echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'QTResprocessing table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'QTResprocessing table has been successfully updated</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT Embedded FROM {$CONFIG['DB_PREFIX']}Files")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Files ADD Embedded tinyint(1) not null AFTER FileName")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Files table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Files table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Files embedded field  already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT EntryKey FROM {$CONFIG['DB_PREFIX']}posts")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add EntryKey int(11) not null after ThreadKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table was successfuly updated</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum entrykey field  already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}UserNotes RENAME AS {$CONFIG['DB_PREFIX']}Tags")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'UserNotes table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNotes table was successfuly renamed to Tags</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNote table already renamed</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Tags CHANGE UserNoteKey TagKey int(11) NOT NULL auto_increment")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserNoteKey  already renamed</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT Heading FROM {$CONFIG['DB_PREFIX']}Tags")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Tags ADD Heading varchar(100) not null after Url")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Heading field  already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}TagCategories (
  CategoryKey int(11) NOT NULL auto_increment,
  ParentKey int(11) NOT NULL default '0',
  UserKey int(11) NOT NULL default '0',  
  Name varchar(255) NOT NULL default '',
  PRIMARY KEY  (CategoryKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'TagCategories  table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'TagCategories table has been successfully created</p>';
	
}


///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}TagCategoryLinks (
  CategoryKey int(11) NOT NULL auto_increment,
  TagKey int(11) NOT NULL default '0',
  UNIQUE  (CategoryKey, TagKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'TagCategoryLinks  table: '.$CONN->ErrorMsg().'</p>';
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'TagCategoryLinks table has been successfully created</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ReadPostsFlag FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD ReadPostsFlag tinyint(1) NOT NULL default '0' AFTER AutoLoadEditor")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users ReadPostsFlag field  already exists</p>';

}

///////////////////////////////////////////////////////

if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}SpaceChildLinks (
  SpaceKey int(11) NOT NULL default '0',
  ParentKey int(11) NOT NULL default '0',
  UNIQUE KEY SpaceKey (SpaceKey,ParentKey)
) TYPE=MyISAM")===false) {

    echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'SpaceChildLinks table: '.$CONN->ErrorMsg().'</p>';

	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'SpaceChildLinks table has been successfully created</p>';
	
}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ShortName FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShortName varchar(20) NOT NULL default '' AFTER Code")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces ShortName field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT CombineNames FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD CombineNames tinyint(1) NOT NULL default '0' AFTER ShortName")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces CombineNames field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD AccessLevelKey tinyint(4) NOT NULL default '0' AFTER Description")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces AccessLevelKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT VisibilityKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD VisibilityKey tinyint(4) NOT NULL default '0' AFTER AccessLevelKey")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces VisibilityKey field already exists</p>';

}

//////////////////////////////////////////////////

if ($CONN->Execute("SELECT ShowMembers FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {

    if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ShowMembers tinyint(1) NOT NULL default '1' AFTER SortOrder")===false) {

        echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';} else {

        if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table was successfuly altered</p>';
	
    }
	
} else {

    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces ShowMembers field already exists</p>';

}

$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='2' WHERE StatusKey='3' OR StatusKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='1' WHERE StatusKey='1' OR StatusKey='2' OR StatusKey='5'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='1' WHERE StatusKey='1'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='2' WHERE StatusKey='2' OR StatusKey='3' OR StatusKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='3' WHERE StatusKey='5'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET AccessLevelKey='2' WHERE TypeKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET VisibilityKey='3' WHERE TypeKey='4'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET ShortName=Code WHERE TypeKey='1'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET CombineNames='1' WHERE TypeKey='1'");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces DROP StatusKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces DROP TypeKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ReadPosts RENAME AS {$CONFIG['DB_PREFIX']}PostUserLinks");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD ReadStatus tinyint(2) NOT NULL AFTER UserKey");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD FlagStatus tinyint(2) NOT NULL AFTER ReadStatus");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}PostUserLinks ADD MonitorPost tinyint(2) NOT NULL AFTER FlagStatus");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}PostUserLinks SET ReadStatus='1'");
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD INDEX DateAddedIdx (DateAdded)"); 
$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD INDEX GroupKeyIdx (GroupKey)"); 
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Tags SET Heading=Note"); 
/////////////////////////////////////////////////

if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004080701', Release='1.9'
")===false) {

    echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';} else {

    if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
	
}

} //end run187Upgrade 

function run19upgrade() {

	global $CONN, $CONFIG, $verbo;

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT NavigationMode FROM {$CONFIG['DB_PREFIX']}FolderSettings")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}FolderSettings ADD NavigationMode tinyint(1) NOT NULL default '0' AFTER SortOrderKey")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'FolderSettings table: '.$CONN->ErrorMsg().'</p>';} 

		else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'FolderSettings table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'FolderSettings NavigationMode field already exists</p>';

	}

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT AccountCreationPassword FROM {$CONFIG['DB_PREFIX']}UserGroups")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}UserGroups ADD AccountCreationPassword varchar(15) NOT NULL default '0' AFTER GroupName")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'UserGroups table: '.$CONN->ErrorMsg().'</p>';} 

		else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserGroups table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'UserGroups AccountCreationPassword field already exists</p>';

	}

	//////////////////////////////////////////////////

	if ($CONN->Execute("SELECT PreferedName FROM {$CONFIG['DB_PREFIX']}Users")===false) {

    		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD PreferedName varchar(30) NOT NULL default '0' AFTER LastName")===false) {

        		echo '<p class="message">There was an error altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
				
			} else {

        		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table was successfuly altered</p>';
	
    		}
	
	} else {


	    if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users PreferedName field already exists</p>';

	}

	/////////////////////////////////////////////////

	if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}AccessLevels VALUES (5,'Permanent Guest')")===false) {

    		if ($verbo) echo '<p>Could not add the default Access levels: '.$CONN->ErrorMsg().' (they probably exist already)</p>';
	
	} else {

    		if ($verbo) echo '<p>The default access level 5 has been successfully added</p>';
	
	}

	
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}AccessLevels SET Name='Admin' WHERE AccessLevelKey='2'");
$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}AccessLevels SET Name='User' WHERE AccessLevelKey='3'");

	/////////////////////////////////////////////////

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2004092701', Release='1.9.1'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The default values were added to the '.$CONFIG['DB_PREFIX'].'Version table </p>';
		
	}


} //end run19upgrade
//////////////////////////////////
function run2005030401upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	///////////////////////////////////////////////////////
	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}Skins (
  	SkinKey int(11) NOT NULL auto_increment,
  	UserKey int(11) NOT NULL default '0',
  	Template varchar(20) NOT NULL default '',
  	ScopeKey tinyint(2) NOT NULL default '0',
  	Name varchar(20) NOT NULL default '',
  	BodyBackground varchar(11) NOT NULL default '',
  	BodyFont varchar(50) NOT NULL default '',
  	BodyBorderColour varchar(11) NOT NULL default '',
  	OuterBoxBackground varchar(11) NOT NULL default '',
  	OuterBoxBorderColour varchar(11) NOT NULL default '',
  	HeaderLogo varchar(255) NOT NULL default '',
  	HeaderLogoHeight varchar(6) NOT NULL default '',
  	HeaderLogoWidth varchar(6) NOT NULL default '',
  	HeaderHeight varchar(6) NOT NULL default '',
  	HeaderBackground varchar(11) NOT NULL default '',
  	HeaderBorderColour varchar(50) NOT NULL default '',
	ServerNameColour varchar(11) NOT NULL default '',
  	InnerBoxBackground varchar(11) NOT NULL default '',
  	InnerBoxBorderColour varchar(11) NOT NULL default '',
  	NavBackground varchar(11) NOT NULL default '',
  	NavBorderColour varchar(11) NOT NULL default '',
  	ContentBackground varchar(11) NOT NULL default '',
  	ContentBorderColour varchar(11) NOT NULL default '',
  	PRIMARY KEY  (SkinKey)
	) TYPE=MyISAM")===false) {

    		echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table has been successfully created</p>';
	
	}
	///////////////////////////////////////////////////////

	$rs = $CONN->Execute("SELECT * FROM {$CONFIG['DB_PREFIX']}Skins");
	if ($rs->EOF) {
	
		if ($CONN->Execute("insert into {$CONFIG['DB_PREFIX']}Skins values ('','1','default','1','Default','','','','','','','','','','','','','','','','','','')")===false) {
	    	echo '<p class="message">There was a problem adding default value to the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table default values have been successfully created</p>';
		}
	}
	
	///////////////////////////////////////////////////////
	//update kb entry table to allow for new status_key field
	if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}KBEntries")===false) {

		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}KBEntries ADD StatusKey tinyint(1) NOT NULL default '2' AFTER DateModified")===false) {

   			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'KBEntries table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	

		} else {

   			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'KBEntries table updated</p>';
	
		}

	}		
	///////////////////////////////////////////////////////
	//update adodb seesion table
	if ($CONN->Execute("SELECT EXPIREREF FROM {$CONFIG['DB_PREFIX']}Sessions")===false) {

		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Sessions ADD EXPIREREF varchar(64) AFTER EXPIRY")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Sessions table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Sessions table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add module key to spaces table
	if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
	
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD ModuleKey int(11) NOT NULL AFTER SpaceKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	
	///////////////////////////////////////////////////////
	//add skin key to spaces table
	if ($CONN->Execute("SELECT SkinKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SkinKey int(11) NOT NULL AFTER ModuleKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}		
	///////////////////////////////////////////////////////
	//add skin key to users table
	if ($CONN->Execute("SELECT SkinKey FROM {$CONFIG['DB_PREFIX']}Users")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users ADD SkinKey int(11) NOT NULL AFTER ReadPostsFlag")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table updated</p>';
	
		}
	}		

	///////////////////////////////////////////////////////
	//change password field to allow for encrypted passwords
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users CHANGE Password Password varchar(32) NOT NULL")===false) {

    	echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >Check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Users table updated</p>';
	
	}		
	
	///////////////////////////////////////////////////////
	//add new block key to ModuleSpaceLinks table
	if ($CONN->Execute("SELECT BlockKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD BlockKey tinyint(2) NOT NULL AFTER ParentKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table updated</p>';
	
		}
	}		

	//encrypt existing user passwords
	$rs = $CONN->Execute("SELECT UserKey, Password FROM {$CONFIG['DB_PREFIX']}Users");

	while(!$rs->EOF) {
	
		if (strlen($rs->fields[1])!=32) {
			$password = md5($rs->fields[1]);
			$user_key = $rs->fields[0];
			if ($verbo) echo "ecrypting password for user_key $user_key<br />";
			$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Users SET Password='$password' WHERE UserKey='$user_key'");
		}
		$rs->MoveNext();

	}
	
	//add space moduletype
	$rs = $CONN->Execute("SELECT Code FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='space'");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes(Name, Code) VALUES ('Space', 'space')")===false) {
		    echo '<p class="message">There was a problem adding the new space module type'.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {
    		if ($verbo) echo '<p>The new space module type has been added</p>';
		}
	}
    
	//add default space
	$rs = $CONN->Execute("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE Code='XXHOMEXX'");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Spaces(Code, ShortName,Name,CombineNames,Description,AccessLevelKey,VisibilityKey,AccessCode,NewUserAlert, ShortDateFormatKey, LongDateFormatKey, SortOrder, ShowMembers) VALUES ('XXHOMEXX', '','Home','0', 'Home','1','1','','false', '1', '1', '0', '0')")===false) {
	    	echo '<p class="message">There was a problem adding the default space values'.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Default space has been added</p>';
			$CONFIG['DEFAULT_SPACE_KEY'] = $CONN->Insert_ID();
			$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET default_space_key='{$CONFIG['DEFAULT_SPACE_KEY']}'"); 
		}
	} else {
		$CONFIG['DEFAULT_SPACE_KEY'] = $rs->fields[0];
	}


	///////////////////////////////////////////////////////
	//see if server_settings table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}server_settings (
  		server_name varchar(100) NOT NULL default '',
  		default_skin_key int(11) NOT NULL default '1',
  		default_language varchar(3) NOT NULL default 'eng',
  		short_date_format tinyint NOT NULL default '0',
  		long_date_format tinyint NOT NULL default '0',
  		error_email varchar(50) NOT NULL default '',
  		no_reply_email varchar(50) NOT NULL default '',
  		email_type varchar(8) NOT NULL default '',
  		sendmail_path varchar(50) NOT NULL default '',
  		sendmail_args varchar(50) NOT NULL default '',
  		email_host varchar(50) NOT NULL default '',
  		email_port int(3) NOT NULL default '',
  		email_auth varchar(5) NOT NULL default '',
  		email_username varchar(50) NOT NULL default '',
  		email_password varchar(20) NOT NULL default '',
  		max_file_upload_size int(11) NOT NULL default '',
  		keep_trash int(3) NOT NULL default '',
  		keep_stale_accounts int(3) NOT NULL default '',
  		show_emails tinyint(1) NOT NULL default '0',
  		secure_server tinyint(1) NOT NULL default '0',
  		secure_account_creation tinyint(1) NOT NULL default '0',
  		account_creation_password varchar(20) NOT NULL default '',
  		secret_hash varchar(100) NOT NULL default '',    
  		allow_tags tinyint(1) NOT NULL default '0',
  		default_space_key int(11) NOT NULL default '0',  
  		global_gradebook tinyint(1) NOT NULL default '0',
  		devolve_account_creation tinyint(1) NOT NULL default '0',
  		self_delete tinyint(1) NOT NULL default '0',
  		display_latest tinyint(1) NOT NULL default '0',
  		usergroup_self_select tinyint(1) NOT NULL default '0',
  		single_accounts tinyint(1) NOT NULL default '0',
  		admin_set_skin tinyint(1) NOT NULL default '0',
  		user_set_skin tinyint(1) NOT NULL default '0', 
  		short_urls tinyint(1) NOT NULL default '0'    
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table has been successfully created</p>';
	
	}
	///////////////////////////////////////////////////////
	
	$rs = $CONN->Execute("SELECT server_name FROM {$CONFIG['DB_PREFIX']}server_settings");
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}server_settings VALUES ('Interact',1,'eng',0,0,'noreply@yourdomain.com','webmaster@yourdomian.com','sendmail','/usr/sbin/sendmail','','',0,'2','','',5242880,30,365,2,1,1,'','topsecretstringdonttellanyone',1,".$CONFIG['DEFAULT_SPACE_KEY'].",1,1,1,0,1,1,2,2,".$short_urls.")")===false) {

  			echo '<p class="message">There was a problem adding default values to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings default values successfully added</p>';
	
		}
	}
	
	/////////////////////////////////////////////////


	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}cron (
  			last_run datetime NOT NULL 
   			) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'cron table: '.$CONN->ErrorMsg().'</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'cron table has been successfully created</p>';
	
	}
	/////////////////////////////////////////////////

	$date_time = $CONN->DBDate(date('Y-m-d H:i:s'));

	if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}cron(last_run) VALUES($date_time)")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'cron table default setting: '.$CONN->ErrorMsg().'</p>';

		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'cron table default entry has been successfully added</p>';
	
	}
	///////////////////////////////////////////////////////

	if ($CONN->Execute("CREATE TABLE {$CONFIG['DB_PREFIX']}module_subscription_links (
  module_key int(11) NOT NULL default '',
  user_key int(11) NOT NULL default '',
  type_key tinyint(1) NOT NULL default '0',
  UNIQUE(module_key, user_key)
  ) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'module_subscription_links table: '.$CONN->ErrorMsg().'</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'module_subscription_links table has been successfully created</p>';
	
	}



	//now convert all spaces to modules
	require_once('convertspaces.php');
	$converted_spaces = array();
	if ($verbo) echo "Now converting existing Spaces to Modules<br />";

	convert_spaces(0, $converted_spaces);
	
		/////////////////////////////////////////////////

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005030401', Release='2.0'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}

} // end run2005030401upgrade
//////////////////////////////////
function run2005062901upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo;
	
	///////////////////////////////////////////////////////
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Skins CHANGE HeaderLogo HeaderLogo varchar(255) NOT NULL")===false) {

    		echo '<p class="message">There was a problem changing values in the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The skins table has been updated</p>';
		
	}	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005062901', Release='2.0'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}	
} // end run2005062901upgrade	

//////////////////////////////////
function run2005111001upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	///////////////////////////////////////////////////////
	//add new Minimum uses field to groupsettings table
	if ($CONN->Execute("SELECT MinimumUsers FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings ADD MinimumUsers tinyint(4) NOT NULL after MaximumUsers")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}		
	///////////////////////////////////////////////////////
	//add new startdate field to groupsettings table
	if ($CONN->Execute("SELECT StartDate FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add StartDate DateTime NOT NULL after MinimumUsers")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	
	
	///////////////////////////////////////////////////////
	//add new finish date field to groupsettings table
	if ($CONN->Execute("SELECT FinishDate FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add FinishDate DateTime NOT NULL after StartDate")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new group management field to groupsettings table
	if ($CONN->Execute("SELECT GroupManagement FROM {$CONFIG['DB_PREFIX']}GroupSettings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GroupSettings add GroupManagement tinyint(1) NOT NULL after FinishDate")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GroupSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GroupSettings table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new type key to spaces table
	if ($CONN->Execute("SELECT TypeKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces add TypeKey tinyint(1) not null default '0' after VisibilityKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//add new owned by key to spaces table
	if ($CONN->Execute("SELECT OwnedByKey FROM {$CONFIG['DB_PREFIX']}Spaces")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces add OwnedByKey int(11) not null default '0' after TypeKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Spaces table updated</p>';
	
		}
	}	

	///////////////////////////////////////////////////////
	//change module description field to a text field
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Modules CHANGE Description Description text NOT NULL DEFAULT''")===false) {
   		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Modules table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >Check your database settings and try again</p>';
		exit;	
	
	} else {

   		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Modules table updated</p>';
	
	}	

	///////////////////////////////////////////////////////
	//see if events type table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}event_types (
  		event_type_key int(11) NOT NULL auto_increment,
  		parent int(11) NOT NULL default '0',
  		name varchar(100) NOT NULL default '',
  		colour varchar(6) NOT NULL default '000000',
  		PRIMARY KEY  (event_type_key),
  		KEY parent (parent)
  		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'event types table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'event_types table has been successfully created</p>';
	
	}
	
	///////////////////////////////////////////////////////
	//add new eventdatefinish  to calendarevents table
	if ($CONN->Execute("SELECT EventDateFinish FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD EventDateFinish datetime NOT NULL DEFAULT '0000-00-00 00:00:00'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}	
	///////////////////////////////////////////////////////
	//add new dateflags  to calendarevents table
	if ($CONN->Execute("SELECT DateFlags FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD DateFlags tinyint(4) unsigned NOT NULL default '0'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new link field to calendarevents table
	if ($CONN->Execute("SELECT Link FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD Link varchar(200) NOT NULL DEFAULT ''")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new eventtype  field to calendarevents table
	if ($CONN->Execute("SELECT EventType FROM {$CONFIG['DB_PREFIX']}CalendarEvents")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD EventType int UNSIGNED NOT NULL DEFAULT '0'")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'CalendarEvents table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'CalendarEvents table updated</p>';
	
		}
	}

	$CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}CalendarEvents ADD INDEX EventDateFinishIdx (EventDateFinish)");

    		
	
	///////////////////////////////////////////////////////
	//see if colours table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}colours (
  		colour char(6) NOT NULL default '000000'
  		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'colours table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'colours table has been successfully created</p>';
	
	}
    //add default colours to colours table
    $rs = $CONN->Execute("SELECT colour FROM {$CONFIG['DB_PREFIX']}colours"); 
	if ($rs->EOF) {
		if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}colours(colour) VALUES ('900000'),('701818'),('863200'),('522500'),('374310'),('007000'),('227070'),('004080'),('000090'),('400080'),('800080'),('800040'),('844444'),('CE5C00'),('98722F'),('70703C'),('497749'),('4C8162'),('3D6381'), ('434384'),('685872'),('606060')")===false) {
    		echo '<p class="message">There was a problem adding default colours to the '.$CONFIG['DB_PREFIX'].'colours table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>Default values added to the  '.$CONFIG['DB_PREFIX'].'colours table</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//see if online users table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}online_users (
  		user_key int(11) NOT NULL default '0',
  		session_id varchar(32) NOT NULL default '',
  		time int(11) NOT NULL default '0',
  		polling tinyint(1) NOT NULL default '0',
  		status_key tinyint(1) NOT NULL default '0',
  		UNIQUE  (user_key, session_id),
  		KEY user_key_idx (user_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'online_users table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'online_users table has been successfully created</p>';
	
	}

	
	///////////////////////////////////////////////////////
	//see if online users_messages table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}user_messages (
  		message_key int(11) NOT NULL auto_increment,
  		added_by_key int(11) NOT NULL default '0',
  		added_for_key int(11) NOT NULL default '0',
  		message varchar(255) NOT NULL default '',
  		status_key tinyint(1) NOT NULL default '0',  
  		time int(11) NOT NULL default '0',
  		PRIMARY KEY(message_key),
  		KEY user_key_idx (added_for_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'user_messages table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'user_messages table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//add new status_key field to gradebookitems table
	if ($CONN->Execute("SELECT StatusKey FROM {$CONFIG['DB_PREFIX']}GradeBookItems")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}GradebookItems Add StatusKey tinyint(1) NOT NULL default '0' AFTER ContentModuleKey")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'GradeBookItems table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'GradeBookItems table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new rawcss field to skins table
	if ($CONN->Execute("SELECT RawCss FROM {$CONFIG['DB_PREFIX']}Skins")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Skins add RawCss text not null after ContentBorderColour")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Skins table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Skins table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new statuskey field to onlineusers table
	if ($CONN->Execute("SELECT status_key FROM {$CONFIG['DB_PREFIX']}online_users")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}online_users add status_key tinyint(1) NOT NULL default '0' after polling")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'online_users table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'online_users table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//add new admins_add_spaces field to server settings table
	if ($CONN->Execute("SELECT admins_add_spaces FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add admins_add_spaces tinyint(1) NOT NULL default '0' after short_urls")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}	
	
	///////////////////////////////////////////////////////
	//add new user_spaces field to server settings table
	if ($CONN->Execute("SELECT user_spaces FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add user_spaces tinyint(1) NOT NULL default '0' after admins_add_spaces")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//add new enable_portfolios field to server settings table
	if ($CONN->Execute("SELECT enable_portfolios FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings add enable_portfolios tinyint(1) NOT NULL default '0' after user_spaces")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'server_settings table updated</p>';
	
		}
	}
	
	
	///////////////////////////////////////////////////////
	//rename Forum to posts table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}Forum")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}Forum to {$CONFIG['DB_PREFIX']}posts")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Forum table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Forum table renamed</p>';
	
		}
	}

	//now do all column renames for forum table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change PostKey post_key int(11) not null auto_increment");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ParentKey parent_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ThreadKey thread_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change EntryKey entry_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change TypeKey type_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change UserKey added_by_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Subject subject varchar(100) not null default ''");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Body body mediumtext not null default ''");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change DateAdded date_added datetime not null default '0000-00-00'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change StatusKey status_key tinyint(1) not null default '0'");
	$CONN->Execute("update {$CONFIG['DB_PREFIX']}posts set ShowPhoto='1' where ShowPhoto='t'");
	$CONN->Execute("update {$CONFIG['DB_PREFIX']}posts set ShowPhoto='0' where ShowPhoto='f'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change ShowPhoto settings tinyint(4) unsigned  not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}posts change Attachment attachment varchar(40) not null default ''");
	
	///////////////////////////////////////////////////////
	//add new extended body to posts table
	if ($CONN->Execute("SELECT extended_body FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add extended_body text not null default '' after body")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add new modified_by_key to posts table
	if ($CONN->Execute("SELECT modified_by_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add modified_by_key int(11) not null default '0' after added_by_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	
	///////////////////////////////////////////////////////
	//add new user_key to posts table
	if ($CONN->Execute("SELECT user_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add user_key int(11) not null default '0' after modified_by_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new date_published to posts table
	if ($CONN->Execute("SELECT date_published FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add date_published datetime not null default '0000-00-00' after date_added")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new date_modified to posts table
	if ($CONN->Execute("SELECT date_modified FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add date_modified datetime not null default '0000-00-00' after date_published")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//add new multi_entry_key to posts table
	if ($CONN->Execute("SELECT multi_entry_key FROM {$CONFIG['DB_PREFIX']}posts")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}posts add multi_entry_key int(11) not null default '0' after entry_key")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'posts table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'posts table updated</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//rename PostUserLinks to post_user_links table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}PostUserLinks")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}PostUserLinks to {$CONFIG['DB_PREFIX']}post_user_links")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'PostUserLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'PostUserLinks table renamed</p>';
	
		}
	}
	///////////////////////////////////////////////////////
	//rename ForumPostUserLinks to post_user_links table
	if ($CONN->Execute("SELECT PostKey FROM {$CONFIG['DB_PREFIX']}ForumPostUserLinks")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}ForumPostUserLinks to {$CONFIG['DB_PREFIX']}post_user_links")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ForumPostUserLinks table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'PostUserLinks table renamed</p>';
	
		}
	}
	//now update columns in post_user_links table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change UserKey user_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change PostKey post_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change ReadStatus read_status tinyint(2) NOT NULL default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change FlagStatus flag_status tinyint(2) NOT NULL default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}post_user_links change MonitorPost monitor_post tinyint(1) NOT NULL default '0'");
	
	///////////////////////////////////////////////////////
	//rename JournalSettings to journal_settings
	if ($CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}JournalSettings")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalSettings to {$CONFIG['DB_PREFIX']}journal_settings")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'JournalSettings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'JournalSettings table renamed</p>';
	
		}
	}

	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}journal_settings SET TypeKey='0' WHERE TypeKey='2'");
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}journal_settings SET TypeKey=TypeKey+4");
	//now rename columns in journal_settings table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change ModuleKey module_key int(11) not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change TypeKey options tinyint(4) unsigned  not null default '0'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change StartDate start_date datetime not null default '0000-00-00'");
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}journal_settings change FinishDate finish_date datetime not null default '0000-00-00'");
	
	///////////////////////////////////////////////////////
	//add new entries_to_show to journal_settings table
	if ($CONN->Execute("SELECT entries_to_show FROM {$CONFIG['DB_PREFIX']}journal_settings")===false) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}journal_settings add entries_to_show int(2) not null default '15' after options")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'jounral_settings table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {


			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'jounral_settings table updated</p>';
	
		}
	}

	///////////////////////////////////////////////////////
	//see if journal_user_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}journal_user_links (
  		module_key int(11) NOT NULL default '0',
  		user_key int(11) NOT NULL default '0',
  		UNIQUE (module_key,user_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'journal_user_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'journal_user_links table has been successfully created</p>';
	
	}
	
	///////////////////////////////////////////////////////
	//see if journal_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}journal_links (
  		link_key int(11) NOT NULL auto_increment,
  		module_key int(11) NOT NULL default '0',
  		journal_user_key int(11) NOT NULL default '0',
  		name varchar(255) NOT NULL default '',
  		url varchar(255) NOT NULL default '',
  		PRIMARY KEY  (link_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'journal_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'journal_links table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//rename Tags to tagged_urls table
	if ($CONN->Execute("SELECT TagKey FROM {$CONFIG['DB_PREFIX']}Tags")!=false) {
		if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}Tags to {$CONFIG['DB_PREFIX']}tagged_urls")===false) {

    		echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'Tags table: '.$CONN->ErrorMsg().'</p>';
			echo '<p >Check your database settings and try again</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'Tags table renamed</p>';
	
		}
	}
	//now update columns in bookamrks table tag column table
	$CONN->Execute("alter table {$CONFIG['DB_PREFIX']}tagged_urls change TagKey UrlKey int(11) not null auto_increment");
	
	///////////////////////////////////////////////////////
	//see if tags table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}tags (
  		tag_key int(11) NOT NULL auto_increment,
  		text varchar(50) NOT NULL default '0',
  		PRIMARY KEY(tag_key),
  		UNIQUE (text)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'tags table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'tags table has been successfully created</p>';
	
	}

	///////////////////////////////////////////////////////
	//see if tag_links table exists, if not create
	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}tag_links (
  		tag_key int(11) NOT NULL default '0',
  		user_key int(11) NOT NULL default '0',
  		module_key int(11) NOT NULL default '0',
  		entry_key int(11) NOT NULL default '0',
  		url_key int(11) NOT NULL default '0',
  		date_added datetime NOT NULL default '0000-00-00 00:00:00', 
  		UNIQUE (tag_key,user_key,module_key,entry_key)
		) TYPE=MyISAM")===false) {

    	echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'tag_links table: '.$CONN->ErrorMsg().'</p>';
		echo '<p >If this is a fresh install then delete the tables from your '.$CONFIG['DATABASE'].' database and try again. If this is an upgrade then you need to check your database settings and try again</p>';
		exit;	
	
	} else {

    	if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'tag_links table has been successfully created</p>';
	
	}
	//now add scorm tables
	
	///////////////////////////////////////////////////////

	if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm (
  		`module_key` int(11) NOT NULL default '0',
  		`file_path` varchar(50) NOT NULL default '',
  		`version` varchar(9) NOT NULL default '',
  		`launch` int(10) unsigned NOT NULL default '0',
  		`browsemode` tinyint(2) NOT NULL default '0',
  		`auto` tinyint(1) unsigned NOT NULL default '0',
  		`width` int(11) NOT NULL default '0',
  		`height` int(11) NOT NULL default '0',
  		PRIMARY KEY  (`module_key`),
  		KEY `ModuleKeyIdx` (`module_key`)
		) TYPE=MyISAM")===false) {

    		echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm table: '.$CONN->ErrorMsg().'</p>';
			exit;	
	
		} else {

    		if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm table has been successfully created</p>';
	
		}
		
		///////////////////////////////////////////////////////

		if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm_scoes (
  			`id` int(10) unsigned NOT NULL auto_increment,
  			`module_key` int(10) unsigned NOT NULL default '0',
  			`manifest` varchar(255) NOT NULL default '',
  			`organization` varchar(255) NOT NULL default '',
  			`parent` varchar(255) NOT NULL default '',
  			`identifier` varchar(255) NOT NULL default '',
  			`launch` varchar(255) NOT NULL default '',
  			`parameters` varchar(255) NOT NULL default '',
  			`scormtype` varchar(5) NOT NULL default '',
  			`title` varchar(255) NOT NULL default '',
  			`prerequisites` varchar(200) NOT NULL default '',
  			`maxtimeallowed` varchar(19) NOT NULL default '',
  			`timelimitaction` varchar(19) NOT NULL default '',
  			`datafromlms` varchar(255) NOT NULL default '',
  			`masteryscore` varchar(200) NOT NULL default '',
  			`next` tinyint(1) unsigned NOT NULL default '0',
  			`previous` tinyint(1) unsigned NOT NULL default '0',
  			PRIMARY KEY  (`id`),
  			UNIQUE KEY `id` (`id`),
  			KEY `module_key` (`module_key`)
			) TYPE=MyISAM")===false) {

    			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm_scoes table: '.$CONN->ErrorMsg().'</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm_scoes table has been successfully created</p>';
	
			}
			///////////////////////////////////////////////////////

			if ($CONN->Execute("CREATE TABLE IF NOT EXISTS {$CONFIG['DB_PREFIX']}scorm_scoes_track (
  				`id` int(10) unsigned NOT NULL auto_increment,
  				`userid` int(10) unsigned NOT NULL default '0',
  				`module_key` int(10) NOT NULL default '0',
  				`scoid` int(10) unsigned NOT NULL default '0',
  				`element` varchar(255) NOT NULL default '',
  				`value` longtext NOT NULL,
  				`timemodified` int(10) unsigned NOT NULL default '0',
  				PRIMARY KEY  (`id`),
  				UNIQUE KEY `track` (`userid`,`module_key`,`scoid`,`element`),
  				KEY `userid` (`userid`),
  				KEY `module_key` (`module_key`),
  				KEY `scoid` (`scoid`),
  				KEY `elemeny` (`element`)
				) TYPE=MyISAM")===false) {

    			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'scorm_scoes_track table: '.$CONN->ErrorMsg().'</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'scorm_scoes_track table has been successfully created</p>';
	
			}
	
		if ($CONN->GetOne("SELECT ModuleTypeKey FROM {$CONFIG['DB_PREFIX']}ModuleTypes WHERE Code='scorm'")===false) {
			if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}ModuleTypes (ModuleTypeKey,Name,Code,Url,AdminUrl,Image) VALUES (NULL,'IMS/SCORM Package','scorm','','','scorm')")===false) {

    			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleTypes table: '.$CONN->ErrorMsg().'</p>';
				echo '<p >Check your database settings and try again</p>';
				exit;	
	
			} else {

    			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleTypes table updated</p>';
	
			}
		}
		///////////////////////////////////////////////////////
		//add new accesslevelkey field to modulespacelinks table
		if ($CONN->Execute("SELECT AccessLevelKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks")===false) {
			if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ADD AccessLevelKey int(11) NOT NULL AFTER StatusKey")===false) {

    			echo '<p class="message">There was a problem modifying the '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table: '.$CONN->ErrorMsg().'</p>';
				echo '<p >Check your database settings and try again</p>';
				exit;	
	
			} else {


				if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'ModuleSpaceLinks table was updated</p>';
	
			}
		}
		
	//now convert all journal entries and comments to posts
	require_once('convertjournals.php');
	if ($verbo) echo "Now converting journal entries and comments to posts<br />";
	convert_journals();
	//rename old journal entries tables
	if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalEntries to {$CONFIG['DB_PREFIX']}old_journal_entries")===false) {

    	echo '<p class="message">There was a problem renaming the no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntries table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    	if ($verbo) echo '<p>The no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntries table renamed was renamed</p>';
	
	}
    //rename old journal comments table
	if ($CONN->Execute("rename table {$CONFIG['DB_PREFIX']}JournalEntryComments to {$CONFIG['DB_PREFIX']}old_journal_comments")===false) {

    	echo '<p class="message">There was a problem renaming the no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntryComments table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    	if ($verbo) echo '<p>The no-longer-required '.$CONFIG['DB_PREFIX'].'JournalEntryComments entries table was renamed</p>';
	
	}
    //drop journal types table
	if ($CONN->Execute("drop table {$CONFIG['DB_PREFIX']}JournalTypes")===false) {

    	echo '<p class="message">There was a problem dropping the obsolete '.$CONFIG['DB_PREFIX'].'JournalTypes table: '.$CONN->ErrorMsg().'</p>';
	} else {
    	if ($verbo) echo '<p>The obsolete '.$CONFIG['DB_PREFIX'].'JournalTypes table was dropped</p>';
	
	}
	
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005111001', Release='2.1B1'")===false) {

    		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	
	} else {

    
		if ($verbo) echo '<p>The database version has been updated</p>';
		
	}	
} // end run2005111001upgrade	

function run2005121401upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	//only go ahead if headings table doesn't exist yet.
	if (!$CONN->Execute("SELECT module_key FROM {$CONFIG['DB_PREFIX']}headings WHERE module_key=0")) {
		if ($CONN->Execute("CREATE TABLE IF NOT EXISTS `{$CONFIG['DB_PREFIX']}headings` (
	  `module_key` int(11) NOT NULL default '0',
	  `initial_state` tinyint(4) NOT NULL default '0',
	  `level` tinyint(4) NOT NULL default '1',
	  PRIMARY KEY  (`module_key`)
	) TYPE=MyISAM")===false) {
			echo '<p class="message">There was a problem adding the '.$CONFIG['DB_PREFIX'].'headings table: '.$CONN->ErrorMsg().'</p>';
			exit;
		} else {
			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'headings table has been successfully created</p>';
		}

	//upgrade old headings with new data
		if($rs=$CONN->Execute("SELECT ModuleKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleTypeKey=10")) {
			while(!$rs->EOF) {
				if ($CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}headings(module_key,initial_state,level) values ('".$rs->fields[0]."','0','1')")===false) {
					echo '<p class="message">There was a problem adding an entry for heading component #'.$rs->fields[0].' to the '.$CONFIG['DB_PREFIX'].'headings table: '.$CONN->ErrorMsg().'</p>';
					exit;
				}
				$rs->MoveNext();
			}
			if ($verbo) echo '<p>The '.$CONFIG['DB_PREFIX'].'headings table has been populated with default values for existing headings</p>';
		} else {
			echo '<p class="message">There was a problem finding existing headings to update: '.$CONN->ErrorMsg().'</p>';
			exit;
		}
	} else {
		if ($verbo) echo "{$CONFIG['DB_PREFIX']}headings table already exists - presuming headings upgrade has already been done.";}

	///////////////////////////////////////////////////////
	//update short_urls as it now holds 2 bits of data

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET short_urls = '$short_urls'")===false) {
		echo '<p class="message">There was a problem updating short_urls with new data in the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';exit;
	} else {
    	if ($verbo) echo '<p>Updated short_urls with new data in the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';	
	}


	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2005121401', Release='2.1RC1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2005121401upgrade

function run2006011201upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	
	if ($verbo) echo '<strong>Release 2.1</strong>';

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006011201', Release='2.1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006011201upgrade



function run2006031601Upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $short_urls;
	if ($verbo) echo '<strong>Release 2.2</strong>';
	
//dump current sessions
	$CONN->Execute('DELETE FROM `'.$CONFIG['DB_PREFIX'].'Sessions'.'`');

	if($CONN->Execute("SELECT SpaceMap FROM {$CONFIG['DB_PREFIX']}Spaces")===FALSE) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD SpaceMap tinyint(1) NOT NULL DEFAULT '0' AFTER ShowMembers;")===FALSE) {
			echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>'; exit;}
		if ($verbo) echo '<p>Updated the '.$CONFIG['DB_PREFIX'].'Spaces table</p>';
	}

	if($CONN->Execute("SELECT AltHome FROM {$CONFIG['DB_PREFIX']}Spaces")===FALSE) {
		if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Spaces ADD AltHome varchar(255) NOT NULL default '' AFTER SpaceMap;")===FALSE) {
			echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Spaces table: '.$CONN->ErrorMsg().'</p>'; exit;}
		if ($verbo) echo '<p>Updated the '.$CONFIG['DB_PREFIX'].'Spaces table</p>';
	}


	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings CHANGE default_language default_language varchar(32) NOT NULL DEFAULT 'en'")===FALSE) {
		echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';exit;}
	if ($verbo) echo '<p>Altered the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';	


	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Users CHANGE LanguageKey LanguageKey varchar(32) NOT NULL DEFAULT ''")===FALSE) {
		echo '<p class="message">There was a problem altering the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';exit;}
	if ($verbo) echo '<p>Updated LanguageKey in the '.$CONFIG['DB_PREFIX'].'Users table</p>';	

	$lang_trans=array('eng'=>'en','mri'=>'mi','tur'=>'tr','esp'=>'es','jpn'=>'ja');
	if (($rs=$CONN->Execute("SELECT LanguageKey,Code FROM {$CONFIG['DB_PREFIX']}Languages"))===false) {
		if($verbo) echo '<p>Languages already updated</p>';} else {
	
		while(!$rs->EOF) {
			if($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Users SET LanguageKey='".$lang_trans[$rs->fields[1]]."' WHERE LanguageKey='".$rs->fields[0]."'")===FALSE) {
				echo '<p class="message">There was a problem updating the '.$CONFIG['DB_PREFIX'].'Users table: '.$CONN->ErrorMsg().'</p>';exit;}
			$rs->MoveNext();
		}
		if ($verbo) {
			echo '<p>Updated Language Keys with new codes in the '.$CONFIG['DB_PREFIX'].'Users table</p>';	
		}
	}
	
	
	$new_lang_code=$lang_trans[$CONN->GetOne("SELECT default_language FROM {$CONFIG['DB_PREFIX']}server_settings")];
	if($new_lang_code) {if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET default_language='".$new_lang_code."'")===FALSE) {
		echo '<p class="message">There was a problem updating the default language in the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	}
	if ($verbo) echo '<p>Updated default_language in the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
	}

	if ($CONN->Execute("DROP TABLE IF EXISTS {$CONFIG['DB_PREFIX']}Languages")===FALSE) {
		echo '<p class="message">There was a problem dropping the obsolete '.$CONFIG['DB_PREFIX'].'Languages table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) {
			echo '<p>Dropped the obsolete '.$CONFIG['DB_PREFIX'].'Languages table</p>';	
		}
	}


if ($CONN->Execute("SELECT options FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings ADD options smallint UNSIGNED NOT NULL DEFAULT '1'")===FALSE) {
		echo '<p class="message">There was a problem adding the options field to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	} else {
		if ($verbo) {
			echo '<p>Added the options field to the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
		}
	}
} else {
	if ($verbo) {
		echo "options field already added to {$CONFIG['DB_PREFIX']}server_settings table.";
	}
}


if ($CONN->Execute("SELECT Release FROM {$CONFIG['DB_PREFIX']}Version")===false) {
	if ($verbo) echo '<p>Release field in the '.$CONFIG['DB_PREFIX'].'Version table already renamed.</p>';} else {

	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}Version CHANGE Release ReleaseName varchar(10)")===FALSE) {echo '<p class="message">There was a problem renaming the Release field in the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';exit;} 
	if ($verbo) echo '<p>Renamed Release field to "ReleaseName" in the '.$CONFIG['DB_PREFIX'].'Version table</p>';
} 
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006031601', ReleaseName='2.2'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}

}

function run2006041201upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo;
	
	if ($verbo) echo '<strong>Release 2.2RC1</strong>';

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006041201', ReleaseName='2.2RC1'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006041201upgrade

function run2006050301upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $smartnet ;
	
	if ($verbo) echo '<strong>Release 2.2RC2</strong>';

if ($CONN->Execute("SELECT auth_type FROM {$CONFIG['DB_PREFIX']}server_settings")===false) {
	if ($CONN->Execute("ALTER TABLE {$CONFIG['DB_PREFIX']}server_settings ADD auth_type varchar(25) NOT NULL DEFAULT '' AFTER options")===FALSE) {
		echo '<p class="message">There was a problem adding the auth_type field to the '.$CONFIG['DB_PREFIX'].'server_settings table: '.$CONN->ErrorMsg().'</p>';
		exit;
	} else {
		if ($verbo) { 
			echo '<p>Added the auth_type field to the '.$CONFIG['DB_PREFIX'].'server_settings table</p>';
		}
	}
} else {
	if ($verbo) {
		echo "auth_type field already added to {$CONFIG['DB_PREFIX']}server_settings table.";
	}
}	
	
if (!empty($smartnet) && $smartnet==true) {
	$auth_type = 'snet_ldap';	
} else {
	$auth_type = 'dbencrypt';	
}
if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}server_settings SET auth_type='$auth_type'")===false) {
   		echo '<p class="message">There was a problem adding the default auth_type value: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The default auth_type value has been added</p>';
	}
	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006050301', ReleaseName='2.2'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006050301upgrade

function run2006052301upgrade() {
//////////////////////////////////

	global $CONN, $CONFIG, $verbo, $smartnet ;
	
	if ($verbo) echo '<strong>Release 2.2</strong>';

	if ($CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Version SET Version='2006052301', ReleaseName='2.2'")===false) {
   		echo '<p class="message">There was a problem adding values to the '.$CONFIG['DB_PREFIX'].'Version table: '.$CONN->ErrorMsg().'</p>';
	} else {
		if ($verbo) echo '<p>The database version has been updated</p>';
	}	
} //end run2006052301upgrade

function makeDir($dirPath) {
	if (!is_dir($dirPath)) {

		if (!mkdir($dirPath,0777)) {
			echo '<p class="message">There was a problem creating the directory '.$dirPath.'<br />Please check that your webserver has write access to allow this and then try running this script again</p>';
			exit;
						
		} else {if ($verbo) echo '<p>Created '.$dirPath.' directory</p>';}
	}
}

?>