<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Look up a users details
*
* Retrieve a users details by username, firstname, lastname
*
* @package ServerAdmin
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: userlookup.php,v 1.10 2006/03/13 21:42:40 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../../local/config.inc.php');

require_once($CONFIG['LANGUAGE_CPATH'].'/admin_strings.inc.php');

//check to see if user is logged in. If not refer to Login page.
authenticate_admins();

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(
	'header'	 => 'Header.ihtml',
	'navigation' => 'admin/AdminNavigation.ihtml',
	'form'	   => 'admin/UserLookup.ihtml',
	'footer'	 => 'Footer.ihtml'));

$t->set_block('form', 'ResultBlock', 'RBlock');


if ($_SERVER['REQUEST_METHOD']=='POST') {
 
	$search_data = $_POST['search_data'];
	
	$rs = $CONN->Execute("select FirstName,LastName,Email,UserName,Password,LevelKey,UserKey, AccountStatus, UserIDNumber from {$CONFIG['DB_PREFIX']}Users where (FirstName like '$search_data%' or LastName like '$search_data%' or UserName like '$search_data%') AND (UserName!='deleteduser') ORDER BY LastName, FirstName");
 
	if ($rs->EOF) {
	
		$t->set_var('RBlock', '');
		$message = "There are no users matching your search criteria of $search_data";	
		
	} else { 
	
		while (!$rs->EOF) {
		
			$t->set_var('FIRST_NAME',$rs->fields[0]);
			$t->set_var('LAST_NAME',$rs->fields[1]);
			$t->set_var('EMAIL',$rs->fields[2]);
			$t->set_var('USER_NAME',$rs->fields[3]);
			
			if ($CONFIG['AUTH_TYPE']=='dbplain') {
			
				$t->set_var('PASSWORD',"<input name=\"password\" type=\"text\" id=\"password\" value=\"{$rs->fields[4]}\" size=\"30\">"); 
				
			} else {

				$t->set_var('PASSWORD',"<input name=\"password\" type=\"text\" id=\"password\" value=\"\" size=\"30\">"); 
				
			}			

			$level_menu = make_menu("SELECT Name,AccessLevelKey FROM {$CONFIG['DB_PREFIX']}AccessLevels",'level_key',$rs->fields[5],'1');
			$status_menu = make_menu("SELECT Name,AccountStatusKey FROM {$CONFIG['DB_PREFIX']}UserStatuses",'status_key',$rs->fields[7],'1');
			//now get array of user_groups that user is a member of
			$n=1;
			$rs_user_groups = $CONN->Execute("SELECT UserGroupKey FROM {$CONFIG['DB_PREFIX']}UserUserGroupLinks WHERE UserKey='{$rs->fields[6]}'");
			$user_group_keys = array();
			while (!$rs_user_groups->EOF) {
				$user_group_keys[$n]=$rs_user_groups->fields[0];
				$n++;
				$rs_user_groups->MoveNext();
			}
			$rs_user_groups->Close();
			$usergroup_menu = make_menu("SELECT GroupName, UserGroupKey FROM {$CONFIG['DB_PREFIX']}UserGroups ORDER BY GroupName",'user_group_keys[]',$user_group_keys,'4',true);
			$t->set_var('LEVEL_MENU',$level_menu);
			$t->set_var('STATUS_MENU',$status_menu); 
			$t->set_var('USERGROUP_MENU',$usergroup_menu);
			$t->set_var('USER_KEY',$rs->fields[6]);
			$t->set_var('USER_ID_NUMBER',$rs->fields[8]);			
			$t->Parse('RBlock', 'ResultBlock', true);	
			
			$rs->MoveNext();
  
		}
		
	}  

} else {

	$t->set_var('RBlock', '');

}

set_common_admin_vars('User Lookup', $message);

$t->set_var('RESULTS',$results);
$t->parse('CONTENTS', 'header', true); 
admin_navigation();
$t->parse('CONTENTS', 'form', true);
$t->parse('CONTENTS', 'footer', true);
$t->p('CONTENTS');

exit;


?>