<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify	|
// | it under the terms of the GNU General Public License as published by	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+
	
/**
* Common functions and variables
*
* This file contains functions and variables, etc. common to the other scripts
* and functions within the system
*
* @package Common
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: common.inc.php,v 1.171.2.3 2006/05/29 03:48:54 glendavies Exp $
* 
*/

// Global variables are now set in the init_config() function at about line 63
// VIEW PATHS are set via short_url setting in database... at about line 125


$CONFIG['ADODB_PATH']	= $CONFIG['BASE_PATH'].'/includes/adodb';
//Include database abstraction classes 
require_once($CONFIG['ADODB_PATH'].'/adodb.inc.php');
require_once($CONFIG['ADODB_PATH'].'/session/adodb-session.php');

//if cron job not set run autofunctions
//curently this option is disabled
//if ($CONFIG['CRON']!=1) {
	//require_once($CONFIG['BASE_PATH'].'/admin/auto.php');
//}

$CONN=&get_data_config();

//Fix for IIS which doesn't have REQUEST_URI
if(empty($_SERVER['REQUEST_URI'])) $_SERVER['REQUEST_URI']=$_SERVER['PHP_SELF'].(!empty($_SERVER['QUERY_STRING'])?'?'.$_SERVER['QUERY_STRING'].'':'');

error_reporting(E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR);
//error_reporting(E_ALL);

/**
* Init Config
*
* Sets up all global variables and database connection.
*
*/
function &init_config() {
	global $CONFIG,$ADODB_SESSION_DRIVER,$ADODB_SESSION_CONNECT,$ADODB_SESSION_USER,$ADODB_SESSION_PWD,$ADODB_SESSION_DB,$ADODB_SESSION_TBL, $general_strings;
	
	preg_match('|(https?://[[:alnum:]\._:-]+)(.*)|',$CONFIG['FULL_URL'],$regs);
	$CONFIG['SERVER_URL'] 	=$regs[1];
	$CONFIG['PATH'] 		=$regs[2];
	
	$CONFIG['SESSIONDB']    = $CONFIG['DATABASE'];
	$CONFIG['CHAT_SERVER']           = $CONFIG['DBSERVER'];
	$CONFIG['CHAT_DATABASE']         = $CONFIG['DATABASE'];
	$CONFIG['INCLUDES_PATH']         = $CONFIG['BASE_PATH'].'/includes';
	$CONFIG['TEMPLATE_CLASS_PATH']   = $CONFIG['BASE_PATH'].'/includes/';
	$CONFIG['TEMPLATES_PATH']        = $CONFIG['BASE_PATH'].'/templates';
	$CONFIG['LIBRARY_PATH']          = $CONFIG['DATA_PATH'].'/library';
	$CONFIG['MODULE_FILE_SAVE_PATH'] = $CONFIG['DATA_PATH'].'/modules';
	$CONFIG['USERS_PATH']            = $CONFIG['DATA_PATH'].'/users';
	$CONFIG['TEMP_DIR']				 = $CONFIG['DATA_PATH'].'/temp';
	$CONFIG['USER_INPUT_OPTIONAL_FIELDS'] = array('ID_NUMBER' => 0, 'LANGUAGE' => 0, 'PREFERED_NAME' => 0,'DETAILS' => 0, 'PHOTO' => 0, 'EDITOR' => 0, 'FLAG_POSTS' => 0, 'SKINS' => 0);
	$CONFIG['USER_MODIFY_OPTIONAL_FIELDS'] = array('ID_NUMBER' => 0, 'LANGUAGE' => 1, 'PREFERED_NAME' => 1,'DETAILS' => 1, 'PHOTO' => 1, 'EDITOR' => 1, 'FLAG_POSTS' => 1, 'AUTO_PASSWORD' => 0, 'SKINS' => 1);
	
//set the following to 1 if you want php script within 'page' components to be
//executed. This has some major security implications particularly if space
//admin is devolved to a wide group of users. If you are not aware of the what these
//security implications are then it is best to leave this set to 0
	$CONFIG['ALLOW_PHP'] = 0;
	
	$ADODB_SESSION_DRIVER	= $CONFIG['DATABASE_TYPE'];
	$ADODB_SESSION_CONNECT	= $CONFIG['DBSERVER'];
	$ADODB_SESSION_USER 	= $CONFIG['DBUSER'];
	$ADODB_SESSION_PWD 		= $CONFIG['DBPASSWORD'];
	$ADODB_SESSION_DB 		= $CONFIG['SESSIONDB'];
	$ADODB_SESSION_TBL 		= $CONFIG['DB_PREFIX'].'Sessions';
	
//make a database conection
	$new_conn = &ADONewConnection($CONFIG['DATABASE_TYPE']); 
	if (!$new_conn->NConnect($CONFIG['DBSERVER'],$CONFIG['DBUSER'],$CONFIG['DBPASSWORD'],$CONFIG['DATABASE'])) {
		echo 'There was a fatal error connecting to the database';
		if (strpos($_SERVER['SCRIPT_NAME'],'/admin/setup/')!==FALSE) {
			echo '<p class="message">The setup scripts were not able to connect to the database that you have specified in your config file</p>';
			echo '<p><a href="'.substr($_SERVER['SCRIPT_NAME'],0,strpos($_SERVER['SCRIPT_NAME'],'/admin/setup/')).'/help/admin/install/install.html">Instructions for installing a new copy of Interact</a></p>';
			echo '<p>Please check that the following lines in your config.inc.php file are correctly set for your database<br/ >$CONFIG[\'DBUSER\']<br />$CONFIG[\'DBPASSWORD\']<br />$CONFIG[\'DATABASE\']<br />$CONFIG[\'DBSERVER\']</p>';
		}
		exit;
	}
	
//get all the Interact server settings
	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
	$rs = $new_conn->GetRow("SELECT * FROM {$CONFIG['DB_PREFIX']}server_settings");
	$ADODB_FETCH_MODE = ADODB_FETCH_NUM;
	
	if (!isset($CONFIG['NO_SESSION'])) {session_start();}

	if (is_array($rs)){
		foreach($rs as $key => $value) {
			$CONFIG[strtoupper($key)] = $value;
		}
	
//VIEW PATHS are set via short_url setting in database.
		$CONFIG['DIRECT_PATH'] = ($CONFIG['SHORT_URLS']&4)?
			'/':
			'/direct'.(($CONFIG['SHORT_URLS']&1)?'':'.php').(($CONFIG['SHORT_URLS']&2)?'/':'?m=');
		
		$CONFIG['VIEWFILE_PATH'] = (($CONFIG['SHORT_URLS']&2)?
			'/viewfile.php/':(
				($CONFIG['SHORT_URLS']&4)?
					$CONFIG['DIRECT_PATH'].'viewf/':
					'/viewfile.php?path='
			)
		);
	
		$CONFIG['LIBRARY_VIEW_PATH'] = $CONFIG['PATH'].$CONFIG['VIEWFILE_PATH'].'library';
		$CONFIG['MODULE_FILE_VIEW_PATH'] = $CONFIG['PATH'].$CONFIG['VIEWFILE_PATH'];
		$CONFIG['USERS_VIEW_PATH']       = $CONFIG['PATH'].$CONFIG['VIEWFILE_PATH'].'users';
		set_language();
	//get language strings
		include_once($CONFIG['LANGUAGE_CPATH'].'/general_strings.inc.php');
	}

	return $new_conn;
}


/**
* Get Data Config
*
* gets data for requested install if multiple installs with a single codebase
*
*/
function get_data_config() {
	global $CONFIG,$ACONFIG;
	if(is_array($CONFIG['FULL_URL']))  {
		if(isset($ACONFIG['CONFIG_NUM'])) {
			if($ACONFIG['CONFIG_NUM']==0) {$ACONFIG['CONFIG']=$CONFIG;
				$ACONFIG['MAX_CONFIG_NUM']=count($CONFIG['FULL_URL']);
			}
			$CFkey=$ACONFIG['CONFIG_NUM'];
			$CONFIG['FULL_URL']=$CONFIG['FULL_URL'][$CFkey];
		} else {
			$this_url='http'.((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']=='on')?'s':'').'://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'];

			foreach ($CONFIG['FULL_URL'] as $CF=>$val) {
				if (strncasecmp($this_url,$val,strlen($val))===0) {$CFkey=$CF;break;}}
			if(isset($CFkey)) {$CONFIG['FULL_URL']=$val;} else {
				echo '<h1>Interact server error</h1>Cannot find matching site for '.$this_url;
				if(!empty($CONFIG['SHOW_URL_ARRAY_ON_ERROR'])){
					echo '<ul><h2 style="margin-bottom:2px">Maybe you wanted one of these sites:</h2>';
					foreach ($CONFIG['FULL_URL'] as $val) {
						if(substr($val,-1)!='/') $val.='/';
						echo "<li><a href='$val'>$val</a></li>";
					} echo'</ul>';
				}
				exit;
			}

		}
		
		foreach(array('DATABASE_TYPE','DATABASE','DBUSER','DBPASSWORD','DBSERVER','DB_PREFIX','DATA_PATH') as $key) {if(is_Array($CONFIG[$key])) $CONFIG[$key]=$CONFIG[$key][$CFkey]; }}

	$newCONN=&init_config();
	return $newCONN;
}


/**
* Set language 
*
* Sets the default language for current user
*
*/
function set_language() {
	global $CONFIG;

	$lpath=$CONFIG['BASE_PATH'].'/language/';
	if (isset($_SESSION['language'])) {
		$lpath.=$_SESSION['language'];
	} else {
		$lpath.=$CONFIG['DEFAULT_LANGUAGE'];
		$_SESSION['language']=$CONFIG['DEFAULT_LANGUAGE'];
	}
	$CONFIG['LANGUAGE_CPATH']=$lpath.'/strings/compiled';
} //end set_language

/**
* Authenticate 
* Checks users login status if accessing home page
*
*/
function authenticate_home()
{
   global $CONN,$CONFIG, $general_strings;
	
	//if there is no current_user_key cookie and this is a secure server
	//then refer to login page
	
	if (!isset($_SESSION['current_user_key']) && $CONFIG['SECURE_SERVER']==1) {
		
		session_destroy();
		$request_uri = urlencode($_SERVER['REQUEST_URI']);
		$message = urlencode($general_strings['login_needed']);
		Header ("Location: {$CONFIG['FULL_URL']}/login.php?request_uri=$request_uri&message=$message");
		exit;
		
	}   

}

/**
* Check variable 
* check that any required variables are present before proceeding
*
*/
function check_variables($check_space_key=false,$check_link_key=false,$check_module_key=false) 
{
	global $CONFIG,$space_key,$link_key,$module_key;
	if ($check_space_key==true) {
		if ($space_key=="") {
			header("Location: {$CONFIG['FULL_URL']}/index.php?message=You+seem+to+have+accessed+a+page+the+wrong+way+.+Please+try+again");
			exit;
		}
	}
	if ($check_link_key==true) {
		if ($link_key=="") {
			header("Location: {$CONFIG['FULL_URL']}/index.php?message=You+seem+to+have+accessed+a+page+the+wrong+way+.+Please+try+again");
			exit;
		}
	}
	
	   if ($check_module_key==true) {
		if ($module_key=="") {
			header("Location: {$CONFIG['FULL_URL']}/index.php?message=You+seem+to+have+accessed+a+page+the+wrong+way+.+Please+try+again");
			exit;
		}
	}
} //end check_variables

/**
* Authenticate 
* Checks users login status
*
*/
function authenticate($skip_JS_check) 
{

	global $CONN,$space_key,$module_key,$group_key, $CONFIG, $general_strings;
	
// Javascript check - check and come back if unset.
	if(!isset($_SESSION['JAVASCRIPT']) && !isset($skip_JS_check)) {
		if(isset($_GET['javascript'])) {
			$_SESSION['JAVASCRIPT']=$_GET['javascript'];

		} else {
			$redir_url=$_SERVER['REQUEST_URI'];
			$redir_url.=(strrpos($redir_url,'?')===false?'?':'&').'javascript=';
			$rs = $CONN->Execute("SELECT {$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}Modules.Description FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}Spaces WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}Spaces.ModuleKey AND {$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$space_key'");
			
			echo '<html><head><title>'.$CONFIG['SERVER_NAME'].' - '.$rs->fields[0].'</title><meta HTTP-EQUIV="Refresh" CONTENT="3; URL='.$redir_url.'0"></head>
<body>
<script type="text/javascript" language="javascript">
<!--
	window.location.href=\''.$redir_url.'1\';  // -->
</script>
<noscript>
	<p>'.$rs->fields[1].'</p>
	<div align="center">
	<br /><br /><br /><p>No javascript &mdash; some features will be reduced.</p><br />
	<p style="font-size:small">You should be redirected in 3 seconds&hellip;  or <a href="'.$redir_url.'0">click here</a></p>
	</div>
</noscript>
</body></html>';
			exit;
		}
	}
	

	$session_id =  session_id();
	$time = time();
	$sql_update = "UPDATE {$CONFIG['DB_PREFIX']}online_users SET user_key='{$_SESSION['current_user_key']}',session_id='$session_id',time='$time' WHERE user_key='{$_SESSION['current_user_key']}' AND session_id='$session_id'";
	$CONN->Execute($sql_update);
	if ($CONN->Affected_Rows()==0) {

		$sql_insert = "INSERT INTO {$CONFIG['DB_PREFIX']}online_users(user_key,session_id,time, status_key) VALUES ('{$_SESSION['current_user_key']}','$session_id','$time','1')";
		$CONN->Execute($sql_insert);

	}
	$no_poll_stale = time()-600;
	$poll_stale = time()-35;
	$CONN->Execute("DELETE FROM {$CONFIG['DB_PREFIX']}online_users WHERE (time<'$no_poll_stale' AND polling='0') OR (time<'$poll_stale' AND polling='1')");

	if (isset($module_key) && $module_key!="") {
		
		$sql = "SELECT {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey,GroupKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.AccessLevelKey  FROM {$CONFIG['DB_PREFIX']}Spaces,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE {$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey and ({$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$space_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey='$module_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4')";

		$rs = $CONN->Execute($sql);

		while (!$rs->EOF) {
			$space_access_level=$rs->fields[0];
			if ($group_key=="") {
				$group_key=$rs->fields[1];
			}
			$status_key = $rs->fields[2];
			$module_access_level = $rs->fields[3];
			$rs->MoveNext();
		}
		$rs->Close();

	} else {
		
		$sql = "SELECT {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey FROM {$CONFIG['DB_PREFIX']}Spaces LEFT JOIN {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ON {$CONFIG['DB_PREFIX']}Spaces.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey WHERE {$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$space_key'";
		$rs = $CONN->Execute($sql);
		while (!$rs->EOF) {
			$space_access_level=$rs->fields[0];
			$space_status_key=$rs->fields[1];
			$rs->MoveNext();
		}
		$rs->Close();
	}



		//check to see of use can view current page

		if ((!empty($_COOKIE['permanent_user_key']) && empty($_SESSION['current_user_key'])) || (empty($_SESSION['current_user_key']) && (($CONFIG['SECURE_SERVER']==1 && $space_access_level!=3) || $space_access_level==2 || $space_access_level==1 || $module_access_level==1 || $module_access_level==2))){
			
			$request_uri = urlencode($_SERVER['REQUEST_URI']);
			$message = urlencode($general_strings['login_needed']);
			header ("Location: {$CONFIG['FULL_URL']}/login.php?request_uri=$request_uri&message=$message");
			exit;
		
		}  
	

//if user is not an top level admin check to see if they have access to this space
//and what level of access

		if ($_SESSION['userlevel_key']!=1) {

			$sql = "select AccessLevelKey from {$CONFIG['DB_PREFIX']}SpaceUserLinks where UserKey='{$_SESSION['current_user_key']}' and SpaceKey='$space_key'";

			$rs = $CONN->Execute($sql);
			if ($rs->EOF) {
				
				if (($space_access_level!=1 &&  $space_access_level!=3 && $module_access_level!=3 && $module_access_level!=1) || (!isset($_SESSION['current_user_key']) && $module_access_level==1)  || $module_access_level=='2') {
					
					header("Location: {$CONFIG['FULL_URL']}/spaces/access.php?space_key=$space_key&module=$module");
					exit;
				}
				//see if user has access to module
				if($_SESSION['userlevel_key']!=1 && ($status_key==5 || $space_status_key==5)) {
						$message = urlencode($general_strings['access_denied']);
						header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key&message=$message");
						exit;		
				}
			} else {
				while (!$rs->EOF) {
					$accesslevel_key=$rs->fields[0];
					$rs->MoveNext();
				}
				//see if they have access to this module
				
				if (isset($module_key) && $module_key!='') {
					
					if($_SESSION['userlevel_key']!=1 && $accesslevel_key!=1 && $accesslevel_key!=3 && $status_key==5 ) {
						$message = urlencode($general_strings['access_denied']);
						header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key&message=$message");
						exit;		
					}
				} 
			}
		} //end if $userlevel_key


//find out which groups the user has access to 
				
	$group_access=array();
	$group_accesslevel=array();
	if ($_SESSION['userlevel_key']!="1" || $accesslevel_key!="1" || $accesslevel_key!="3") {
	$n=1;
	$sql = "select GroupKey,AccessLevelKey from {$CONFIG['DB_PREFIX']}GroupUserLinks where UserKey='{$_SESSION['current_user_key']}'";
	$rs = $CONN->Execute($sql);
	while (!$rs->EOF) {
		$group_key2 = $rs->fields[0];
		$group_accesslevel_key = $rs->fields[1];
		$group_access[$n]=$group_key2;
		$group_accesslevel[$group_key2] = $group_accesslevel_key;
		$n++;
		$rs->MoveNext();
	}
}
	
	//find out the access level of the group
	if (!class_exists(InteractGroup)) {
			
		require_once($CONFIG['BASE_PATH'].'/modules/group/lib.inc.php');
				
	}
			
	if (!is_object($groupObject)) {
			
	$groupObject = new InteractGroup();
			
	}
				
	$group_data = $groupObject->getGroupData($group_key);  

if ($accesslevel_key!=1 && $accesslevel_key!=3 && $_SESSION['userlevel_key']!=1  && (isset($group_key) && $group_key!=0) && $group_data['access_key']!=2) {
	
	if (!in_array($group_key,$group_access) || !$_SESSION['current_user_key'] || $_SESSION['current_user_key']=='0') {
  
		header("Location: {$CONFIG['FULL_URL']}/modules/group/access.php?space_key=$space_key&group_key=$group_key");
		exit;
	
	}
}

$access_levels=array();
$access_levels["accesslevel_key"]=$accesslevel_key;
$access_levels["groups"]=$group_access;
$access_levels["group_accesslevel"]=$group_accesslevel;



		return $access_levels;


} //end authenticate

/**
* Authenticate Admin 
* Check that user has admin rights
*
*/

function authenticate_admins($level='full')
{
	global $CONFIG,$accesslevel_key;
	
	if ($level=='full') {
		
		if ($_SESSION['userlevel_key']!=1) {
			
			$message = urlencode($general_strings['access_denied']);
			header("Location: {$CONFIG['FULL_URL']}/index.php?message=$message");
			exit;
		
		}
		
	} elseif ($level="space_only") {
	   
	   if ($_SESSION['userlevel_key']!=1 && $accesslevel_key!=1 && $accesslevel_key!=3) {
		   
			$message = urlencode($general_strings['access_denied']);
			header("Location: {$CONFIG['FULL_URL']}/index.php?message=$message");
			exit;
		
		}
	
	}

}


/**
* Format error messages 
* 
* @param [string] string of error message
* @return formatted error
*/

function sprint_error($string)
{
	if(!empty($string))
	{
		return("<br /><span class=\"error\">&nbsp;!&nbsp;$string</span>\n");
	}
} //end sprint_error


/**
* check to see if a string is in valid email address format  
* 
* @param [string] email address string 
* @return true or false
*/

function is_email($string)
{
	// Remove whitespace
	$string = trim($string);
	
	$ret = ereg(
				'^([a-zA-Z0-9_&]|\\-|\\.)+'.
				'@'.
				'(([a-zA_Z0-9_&]|\\-)+\\.)+'.
				'[a-zA_Z]{2,4}$',
				$string);
	
	return($ret);
}

/**
* get list of items as an HTML menu  
* @param [sql]sql to execute
* @param [name]name of the menu
* @param [selected] key of preselected items 
* @return html menu
*/
function make_menu($sql,$name,$selected,$size,$multiple=false,$blank=false)
{
	global $CONN;
	$rs = $CONN->Execute($sql);

	$menu = $rs->GetMenu2($name,$selected,$blank,$multiple,$size);
	return $menu;  
}

/**
* gets page details, space, module name, etc.  
* @param [space_key]current space key
* @param [module_key]current module key
* @return $page_details array
*/

function get_page_details($space_key,$link_key="")
{
	global $CONN, $trail, $general_strings, $CONFIG, $accesslevel_key;

	$PHP_SELF			   = $_SERVER['PHP_SELF'];
	$REQUEST_URI			= $_SERVER['REQUEST_URI'];
	$SCRIPT_NAME			= $_SERVER['SCRIPT_NAME'];
	$userlevel_key		  = $_SESSION['userlevel_key'];
	$current_user_firstname = $_SESSION['current_user_firstname'];
	
	//if there is no module_key then it must be the homepage of a space
	if (!isset($link_key) || $link_key=='') {

		$sql = "select ShortName, Name, Description,FilePath,AccessLevelKey,Header, ShowMembers, CombineNames, OwnedByKey, TypeKey, SkinKey, SpaceMap, AltHome FROM {$CONFIG['DB_PREFIX']}Spaces where SpaceKey='$space_key'";

		
		$rs = $CONN->Execute($sql);
		echo $CONN->ErrorMsg();
		while (!$rs->EOF) {
			$page_details=array();
			$page_details['space_description']=$rs->fields[2];
			$page_details['space_name']=$rs->fields[1];
			$page_details['space_short_name']=$rs->fields[0];
			$combine_name=$rs->fields[7];
			
			if ($combine_name==1 && $page_details['space_short_name']!='') {
				
				$page_details['full_space_name']=$rs->fields[0].' - '.$rs->fields[1];
				
			} else {
				
				$page_details['full_space_name']=$rs->fields[1];
				
			}
			
			$page_details["file_path"]=$rs->fields[3];
			$page_details["access_level_key"]=$rs->fields[4];
			$page_details["header"]=$rs->fields[5];	
			$page_details["show_members"]=$rs->fields[6];
			$page_details['space_owner_key']=$rs->fields[8];
			$page_details['type_key']=$rs->fields[9];
			$page_details['skin_key']=$rs->fields[10];	
			$page_details['spacemap']=$rs->fields[11];
			$page_details['space_alt_home']=$rs->fields[12];
			
			$rs->MoveNext();
		}
		
		$page_details["top_breadcrumbs"]=get_top_breadcrumbs($space_key, $page_details['space_alt_home']);
		   
		if ($PHP_SELF!="{$CONFIG['PATH']}/spaces/space.php" ) {
			
			 if ($page_details['space_short_name']!='') {
				
				$page_details["breadcrumbs"]="<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"spaceHeadingLink\">".$page_details["space_short_name"].'</a> &raquo;';
				
			} else {
			
				$page_details["breadcrumbs"]="<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"spaceHeadingLink\">".$page_details["space_name"].'</a> &raquo;';
			
			}
			
		
		} else {
		
			if ($space_key!=$CONFIG['DEFAULT_SPACE_KEY']) {
			
				$page_details["breadcrumbs"]='<span class="spaceHeading">'.$page_details["full_space_name"].'</span>';
				
			} else {
			
				$page_details["breadcrumbs"] = '';
			
			}
			
			if ($userlevel_key==1 || $accesslevel_key=='1' || $accesslevel_key=='3') {
			
				$admin_string = sprintf($general_strings['space_admin'], ucfirst($general_strings['space_text']));
				$page_details['breadcrumbs'] .= ' '.get_admin_tool($CONFIG['PATH'].'/spaceadmin/admin.php?space_key='.$space_key,true,$admin_string,'spanner');
			
			}
			
		}
//if logged in show  logout, else show login 
		if (isset($current_user_firstname)) {
			$login_link = "<a href=\"{$CONFIG['PATH']}/logout.php\" class=\"topnavigation\">".$general_strings['logout'].'</a>';

		} else {
			$request_uri=urlencode($REQUEST_URI);
			$login_link = "<a href=\"{$CONFIG['PATH']}/login.php?request_uri=$request_uri\" class=\"topnavigation\">".$general_strings['login'].'</a>';

		}
		
		$page_details["login_link"]=$login_link;
//		$page_details["other_header_links"]=get_other_header_links();		
//if on home page don't show Home link 
		if ($SCRIPT_NAME=="{$CONFIG['PATH']}/index.php") {
			$page_details["home_link"]="<span class=\"topnavigation\">".$general_strings['home'].'</a>';
		} else {
			$page_details["home_link"]="<a href=\"{$CONFIG['PATH']}/index.php\" class=\"topnavigation\">".$general_strings['home'].'</a>';
		}
	} else {

// if we have a link key then we need to also get module details and breadcrumb trail back to home


		$sql = "SELECT DISTINCT {$CONFIG['DB_PREFIX']}Spaces.ShortName, {$CONFIG['DB_PREFIX']}Spaces.Name, {$CONFIG['DB_PREFIX']}Spaces.Description, {$CONFIG['DB_PREFIX']}Spaces.FilePath,{$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey,{$CONFIG['DB_PREFIX']}Modules.Name,{$CONFIG['DB_PREFIX']}Modules.Description,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey, {$CONFIG['DB_PREFIX']}ModuleTypes.Code, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.IconKey, {$CONFIG['DB_PREFIX']}Modules.ModuleKey, {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey, {$CONFIG['DB_PREFIX']}Spaces.ShowMembers, {$CONFIG['DB_PREFIX']}Spaces.SpaceMap,{$CONFIG['DB_PREFIX']}Spaces.AltHome  FROM {$CONFIG['DB_PREFIX']}Spaces,{$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks, {$CONFIG['DB_PREFIX']}ModuleTypes WHERE {$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey={$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey AND   {$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey  AND  {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey='$link_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4'";

		$rs = $CONN->Execute($sql);
		
		while (!$rs->EOF) {
			$page_details=array();
			$page_details["space_short_name"]=$rs->fields[0];
			$page_details["space_name"]=$rs->fields[1];
			$page_details["space_description"]=$rs->fields[2];
			$page_details["file_path"]=$rs->fields[3];
			$page_details["access_level_key"]=$rs->fields[4];
			$page_details["module_name"]=$rs->fields[5];
			$page_details["module_description"]=$rs->fields[6];
			$page_details["parent_key"]=$rs->fields[7];
			$page_details["group_key"]=$rs->fields[8];
			$page_details["module_status_key"]=$rs->fields[9];
			$page_details["module_code"]=$rs->fields[10];
			$page_details["icon_key"]=$rs->fields[11];
			$page_details["module_key"]=$rs->fields[12];
			$page_details["module_type_key"]=$rs->fields[13];
			$page_details["show_members"]=$rs->fields[14];			
 			$page_details["spacemap"]=$rs->fields[15];
			$page_details["space_alt_home"]=$rs->fields[16];
			if ($page_details["space_short_name"]=='') {
				$page_details["full_space_name"]=$rs->fields[1];
			} else {
				$page_details["full_space_name"]=$rs->fields[0]." - ".$rs->fields[1];
			}
			$rs->MoveNext();
		}

		if ($page_details['space_short_name']!='') {
			
			$trail_name = $page_details['space_short_name'];
				
		} else {
			
			$trail_name = $page_details['space_name'];
				
		}
		
		if ($page_details['parent_key']==0 ) {
		 
			
			$page_details["top_breadcrumbs"]=get_top_breadcrumbs($space_key, $page_details['space_alt_home']);
			
			if ($PHP_SELF==$CONFIG['PATH'].'/modules/'.$page_details['module_code'].'/'.$page_details['module_code'].'.php') {
			$page_details["breadcrumbs"]="<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"spaceHeadingLink\">".$trail_name."</a> &raquo;";
			
			} else {
			
				if ($page_details['module_code']=='space') {

					$rs_space_key = $CONN->Execute("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE ModuleKey='{$page_details['module_key']}'");
					
					while (!$rs_space_key->EOF) {
					
						$space_key2 = $rs_space_key->fields[0];
						$rs_space_key->MoveNext();
					
					}
					$rs_space_key->Close();
					
					$page_details["breadcrumbs"] = '<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'" class="spaceHeadingLink">'.$trail_name.'</a> &raquo; <a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key2.'">'.$page_details['module_name'].'</a> &raquo; ';				
				
				} else {
					
					$page_details["breadcrumbs"] = '<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'" class="spaceHeadingLink">'.$trail_name.'</a> &raquo; <a href="'.$CONFIG['PATH'].'/modules/'.$page_details['module_code'].'/'.$page_details['module_code'].'.php?space_key='.$space_key.'&module_key='.$page_details['module_key'].'">'.$page_details['module_name'].'</a> &raquo; ';
					
				}
			
			}
		
		} else {
		
			$module_name = $page_details[module_name];
			$page_details["top_breadcrumbs"]=get_top_breadcrumbs($space_key, $page_details['space_alt_home']);
			
			if ($page_details['parent_key']!=0) {
			
				// the module is down more than one level so start recursive query to get full trail
				get_trail($page_details['parent_key'], $page_details);
				
			}
			
			
			if ($PHP_SELF==$CONFIG['PATH'].'/modules/'.$page_details['module_code'].'/'.$page_details['module_code'].'.php') {
			
				$page_details['breadcrumbs'] = '<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'" class="spaceHeadingLink">'.$trail_name.'</a> &raquo; '.$trail.'&raquo;';
				
				
			} else {
			
				if ($page_details['module_code']=='space') {

					$rs_space_key = $CONN->Execute("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE ModuleKey='{$page_details['module_key']}'");
					
					while (!$rs_space_key->EOF) {
					
						$space_key2 = $rs_space_key->fields[0];
						$rs_space_key->MoveNext();
					
					}
					$rs_space_key->Close();
					
					$page_details['breadcrumbs'] = '<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'" class="spaceHeadingLink">'.$trail_name.'</a> &raquo;'.$trail.' &raquo; <a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key2.'">'.$page_details['module_name'].'</a> &raquo; ';		
				
				} else {

					$page_details['breadcrumbs'] = '<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'" class="spaceHeadingLink">'.$trail_name.'</a> &raquo;'.$trail.' &raquo; <a href="'.$CONFIG['PATH'].'/modules/'.$page_details['module_code'].'/'.$page_details['module_code'].'.php?space_key='.$space_key.'&module_key='.$page_details['module_key'].'">'.$page_details['module_name'].'</a> &raquo; ';
				
				}
							
			}
		}
//if logged in show  logout, else show login 
		if (isset($current_user_firstname)) {
			$login_link = "<a href=\"{$CONFIG['PATH']}/logout.php\" class=\"topnavigation\">".$general_strings['logout'].'</a>';

		} else {
			$request_uri=urlencode($REQUEST_URI);
			$login_link = "<a href=\"{$CONFIG['PATH']}/login.php?request_uri=$request_uri\" class=\"topnavigation\">".$general_strings['login'].'</a>';

		}
//		$page_details["other_header_links"]=get_other_header_links();
		$page_details["login_link"]=$login_link;
//if on home page don't show Home link 
		if ($SCRIPT_NAME=="{$CONFIG['PATH']}/index.php") {
			$page_details["home_link"]="<span class=\"topnavigation\">".$general_strings['home']."</span>";
		} else {
			$page_details["home_link"]="<a href=\"{$CONFIG['PATH']}/index.php\" class=\"topnavigation\">".$general_strings['home'].'</a>';
		}
	} 
	
	return $page_details;
}

/**
* recursive query to generate breadcrumb trail.  
* @param [parent_key]parent of current module
*/

function get_trail($parent_key, $page_details) 
{
	global $CONN,$space_key, $CONFIG, $general_strings, $page_details, $trail;

	$sql = "select DISTINCT {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey, {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey, {$CONFIG['DB_PREFIX']}Modules.Name,{$CONFIG['DB_PREFIX']}Modules.ModuleKey from {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey='$parent_key'";

	$rs = $CONN->Execute($sql);
	if ($rs->EOF) {
	
		return false;
	
	}
	while (!$rs->EOF) {
		$link_key=$rs->fields[0];
		$new_parent_key=$rs->fields[1];
		$group_key=$rs->fields[2];
		$module_type_key=$rs->fields[3];
		$name=$rs->fields[4];
		$module_key=$rs->fields[5];
		$rs->MoveNext();
		}

	if ($new_parent_key==0) {

		if ($module_type_key==6) {
			$trail = "  <a href=\"{$CONFIG['PATH']}/modules/group/group.php?space_key=$space_key&amp;module_key=$module_key&amp;link_key=$link_key&amp;group_key=$group_key\">$name</a> ".$trail;
		} else {
			$trail = "  <a href=\"{$CONFIG['PATH']}/modules/folder/folder.php?space_key=$space_key&amp;module_key=$module_key&amp;link_key=$link_key&amp;group_key=$group_key\">$name</a> ".$trail;
		}

	} else {

		if ($module_type_key==6) {
			$trail = " &raquo;  <a href=\"{$CONFIG['PATH']}/modules/group/group.php?space_key=$space_key&amp;module_key=$module_key&amp;link_key=$link_key&amp;group_key=$group_key\">$name</a>  ".$trail;   
			get_trail($new_parent_key, $page_details);
		} else {
			$trail = " &raquo; <a href=\"{$CONFIG['PATH']}/modules/folder/folder.php?space_key=$space_key&amp;module_key=$module_key&amp;link_key=$link_key&amp;group_key=$group_key\">$name</a>  ".$trail;   
			get_trail($new_parent_key, $page_details);
		}

	}

}//end get_trail


/**
* Generate main navigation menu  
* 
*/

function get_navigation($include_active=true)
{
	global $space_key, $t, $CONN, $module_key, $group_key, $accesslevel_key,  $page_details, $group_access, $group_accesslevel,$link_key, $general_strings, $CONFIG, $objSpace;
 
	
	$PHP_SELF			   = $_SERVER['PHP_SELF'];
	$REQUEST_URI			= $_SERVER['REQUEST_URI'];
	$userlevel_key		  = $_SESSION['userlevel_key'];
	$current_user_key	   = $_SESSION['current_user_key'];
	$current_user_firstname = $_SESSION['current_user_firstname'];
	$current_user_lastname  = $_SESSION['current_user_lastname'];
	$hidden_divs = '';
	
	if (isset($current_user_key) && $current_user_key!='') {
	
		get_your_links_menu();
		
	}
	
	if (isset($_SESSION['current_user_key']) && $_SESSION['current_user_key']!='0' && $page_details['space_owner_key']==$_SESSION['current_user_key']) {
			$my_links = "<a class=\"myLinks\" href=\"{$CONFIG['PATH']}/spaces/myposts.php?space_key=$space_key\" >".$general_strings['my_posts'].'</a>';
			if ($CONFIG['ALLOW_TAGS']==1) {
				$my_links .= "<a class=\"myLinks\" href=\"{$CONFIG['PATH']}/urltags/urltags.php?space_key=$space_key\" >".$general_strings['url_tags'].'</a>';
			}
			$t->set_var("MY_LINKS",$my_links);
	}
	$rs = $CONN->Execute("SELECT ParentKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE ModuleKey='$module_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey='$space_key'");
	
	while (!$rs->EOF) {
	
		$parent_key = $rs->fields[0];
		$rs->MoveNext();
	
	}
	
	
	if ($parent_key!=0) {
	
		$rs = $CONN->Execute("SELECT ModuleTypeKey, NavigationMode, LinkKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks, {$CONFIG['DB_PREFIX']}FolderSettings WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}FolderSettings.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey='$parent_key'");
		
		if (!$rs->EOF) {
		
			while (!$rs->EOF) {
		
				$type_key = $rs->fields[0];
				$navigation_mode = $rs->fields[1];
				$parent_link_key = $rs->fields[2];
				$parent_module_key = $rs->fields[3];
				
				$rs->MoveNext();		
		
			}
	 
			if (isset($navigation_mode) && $navigation_mode==1) {
			
				require_once($CONFIG['BASE_PATH'].'/modules/folder/lib.inc.php');
				$objFolder = new InteractFolder();
				$folder_navigation = $objFolder->getFolderNavigation($parent_module_key, $parent_link_key,$space_key,$group_key, $module_key);
				$t->set_var("FOLDER_NAVIGATION",$folder_navigation['top']);
				$t->set_var("FOLDER_NAVIGATION_BOTTOM",$folder_navigation['bottom']);
				
			} 
			
		}
		
	} else {
	
		$t->set_var("FOLDER_NAVIGATION",'');
		
	}
	
	//if logged in show user name and logout, else show login link
	if (isset($current_user_key)) {
	
		if ($_SESSION['userlevel_key']!=5) {
		
			$login_details = get_login_details();
			
		} else {
		
			$login_details = $general_strings['logged_in_as']."<br /> $current_user_firstname $current_user_lastname";
		
		}

		$t->set_var("LOGIN_DETAILS","$login_details");
	

		//get users photo
		
		if (!class_exists('InteractUser')) {

			require_once($CONFIG['BASE_PATH'].'/includes/lib/user.inc.php');
	
		}

		$user = new InteractUser();
		$t->set_var("CURRENT_USER_PHOTO",$user->getUserPhotoTag($current_user_key, '35', $space_key));
		
		set_online_status_link();
		
	} else {
	
		$request_uri=urlencode($REQUEST_URI);
		$login_details = $general_strings['not_logged_in'];
		//$login_details .= "<br /><a href=\"{$CONFIG['PATH']}/login.php\" class=\"navlinks\">".$general_strings['login'].'</a>';		
		$t->set_var("LOGIN_DETAILS","$login_details");
	}
//if the user has admin rights show edit Add link and Admin Functions link

	if (($userlevel_key=="1" || $accesslevel_key=="1" || $accesslevel_key=="3") && (isset($space_key) && $space_key!='')) {
		
		$add_module = sprintf($general_strings['add_module_to'], $page_details['space_name']);
		$admin_links=' '.get_admin_tool($CONFIG['PATH'].'/modules/general/moduleadd.php?space_key='.$space_key,true,$add_module,'plus');

		$sql = "select {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey,{$CONFIG['DB_PREFIX']}Modules.ModuleKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey,{$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleTypes.Code, {$CONFIG['DB_PREFIX']}ModuleTypes.Image, {$CONFIG['DB_PREFIX']}Modules.Description,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.Target,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey,  {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.OwnerKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.EditRightsKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SortOrder, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.IconKey FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey='$space_key' and {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey='0' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.BlockKey='0') order by SortOrder,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.DateAdded";

		$t->set_var("ADMIN_LINKS","$admin_links");
		$admin_functions = "<a href=\"{$CONFIG['PATH']}/spaceadmin/admin.php?space_key=$space_key\" class=\"navlinks\">Admin</a>";
		$t->set_var("ADMIN_FUNCTIONS","$admin_functions");
		if ($module_key) {
			
			$current_module_string = sprintf($general_strings['current_module_no'], $general_strings['module_text']);
			$current_module_key='<br />'.$current_module_string.' '.$module_key;
			$t->set_var("CURRENT_MODULE_KEY",'<div id="currentModuleKey"'.get_admin_tool_class().'>'.$current_module_key.'</div>');
		}
	} else {

		$sql = "select {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey,{$CONFIG['DB_PREFIX']}Modules.ModuleKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey,{$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleTypes.Code, {$CONFIG['DB_PREFIX']}ModuleTypes.Image, {$CONFIG['DB_PREFIX']}Modules.Description,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.Target,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.EditRightsKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.OwnerKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SortOrder, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.IconKey FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey='$space_key' and {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey='0' and ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='1' OR {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='3') AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.BlockKey='0') ORDER BY SortOrder,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.DateAdded";
  
	}
	$members_page = $CONFIG['PATH']."/spaces/members.php";

	if ($space_key!=$CONFIG['DEFAULT_SPACE_KEY']) {
	
		if ($page_details['space_short_name']!='') {
		
			$space_name = $page_details['space_short_name'];
						
		} else {
		
			$space_name = $page_details['space_name'];
			
		}
	
		if ((isset($module_key) && $module_key!='')||($PHP_SELF == $members_page)) {
			$t->set_var("SPACE_NAME",'<a href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$space_key.'">'.$space_name.'</a>');
		} else {
			$t->set_var("SPACE_NAME",$space_name);
		}

		
	} else {
	
		$t->set_var("SPACE_NAME",'');
		
	}


//if space is restricted show link to members and if not show make_member link
	$make_member='';$members_link='';
	if (($page_details['show_members']!=0)||($PHP_SELF == $members_page)) {
//	echo '--'.$make_member.'--'.$page_details['access_level_key'];
//		if ($page_details['access_level_key']==1)  {
			$sql_member = "SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}SpaceUserLinks WHERE SpaceKey='$space_key' AND UserKey='$current_user_key'";

			$rsmember=$CONN->Execute($sql_member);
		
			if ($rsmember->EOF && (isset($space_key) && $space_key!='') && (isset($current_user_key) && $current_user_key!='')){
		
				$make_member = "<a class=\"addmeButton\" href=\"{$CONFIG['PATH']}/spaces/makemember.php?space_key=$space_key\" title=\"".sprintf($general_strings['add_me_explain'],$general_strings['space_text']).'">'.$general_strings['add_me'].'</a>';
			}
//		}
	}
	$t->set_var('MAKE_MEMBER',$make_member);

	
	if ($PHP_SELF == $members_page) {
   
		$members_link = "<strong id=\"activeMemberButton\" >".$general_strings['members'].'</strong>';
		
	} else if (isset($space_key) && $space_key!='' && $page_details['show_members']!=0){
	
		if (!isset($objSpace)) {
			if (!class_exists('InteractSpace')) {
				require_once($CONFIG['BASE_PATH'].'/spaces/lib.inc.php');
			}
			$objSpace = new InteractSpace();
		}
		$new_members = $objSpace->countNewMembers($space_key, $_SESSION['current_user_key']);
		//see if we have any new members

		if ($new_members>0) {
			$new_members = ' ('.sprintf($general_strings['new_postings_count'], $new_members).')';	
		} else {
			$new_members='';
		}
		$members_link = "<a id=\"memberButton\" href=\"{$CONFIG['PATH']}/spaces/members.php?space_key=$space_key\" >".$general_strings['members'].$new_members.'</a>';

	}

	$t->set_var('MEMBERS_LINK',$members_link);
	if ($members_link=='') {
		$t->set_block('navigation', 'MembersBlock');

		$t->set_var('MembersBlock','');
	}
	if ($page_details['spacemap']==1) {
		if (str_replace($CONFIG['PATH'],'',$_SERVER['SCRIPT_NAME'])!='/spaces/spacemap.php') {
			$t->set_var('SPACEMAP','<a id="spaceMapButton" href="'.$CONFIG['PATH'].'/spaces/spacemap.php?space_key='.$space_key.'">'.$general_strings['spacemap'].'</a>');
		} else {
			$t->set_var('SPACEMAP','<span id="activeSpaceMapButton"><strong>'.$general_strings['spacemap'].'</strong></span>');			
		}
	}	
	
	
	$rs = $CONN->Execute("$sql");

	$navHIndex=0;
	$header_array=array();$link='<ul class="navlevel">';
	while (!$rs->EOF) {


		$icon_tag = ''; 
		$module_type_key = $rs->fields[0];
		$nav_code = $rs->fields[4];

		$module_key2 = $rs->fields[1];
		$group_key2 = $rs->fields[2];
		
		//find out if group is visible or not
//		if ($module_type_key==6) {
if ($nav_code=='group') {		
			if (!class_exists(InteractGroup)) {
			
				require_once($CONFIG['BASE_PATH'].'/modules/group/lib.inc.php');
				
			}
			
			if (!is_object($groupObject)) {
			
				$groupObject = new InteractGroup();
			
			}
				
			$group_data = $groupObject->getGroupData($module_key2);
					
		}
		
		if ($nav_code!='group' || $userlevel_key==1 || $accesslevel_key==1 || $accesslevel_key==3 || in_array($module_key2,$group_access) || $group_data['visibility_key']==1) {

			
			$nav_name = $rs->fields[3];
			if(strlen($nav_name)>35){$nav_name=substr($nav_name,0,34).'&hellip;';}
			$nav_image = $rs->fields[4];
			$nav_description = strip_tags(substr($rs->fields[6],0,255));
			$target = ($rs->fields[8]=='new_window')?'target="'.$module_key2.'"':'';
			$status_key = $rs->fields[9];
			$link_key2 = $rs->fields[10];
			$owner_key = $rs->fields[11];
			$edit_rights_key = $rs->fields[12];
			$sort_order = $rs->fields[13];						
			$nav_admin = $nav_code."_input.php";
			$icon_key = $rs->fields[14];
			
			if ($icon_key>2) {
			
				if (!class_exists('InteractHtml')) {
			
					require_once($CONFIG['BASE_PATH'].'/includes/lib/html.inc.php');
				
				}
			
				if (!is_object($htmlObject)) {
			
					$htmlObject = new InteractHtml();
			
				}
				
				$icon_tag = $htmlObject->getIconUrl($icon_key, 'small');	
			
			}
			
			if (isset($icon_tag) && $icon_tag!=false) {
			
				$nav_image = "$icon_tag";
				
			} else if ($icon_key==1){
			
				$nav_image = "{$CONFIG['PATH']}/images/$nav_image.gif";
			
			} else if ($icon_key==2){
			
				$nav_image = '';
			
			}
			// if user has admin rights show edit image
			$can_edit_link = check_link_edit_rights($link_key2,$accesslevel_key,$group_accesslevel,$owner_key);

			$extra_info='';
			if ($can_edit_link==true) {
				$admin_javascript = "onMouseOver=\"showhide(this,'admin_$module_key2','visible')\" onmouseout=\"showhide(this,'admin_$module_key2','hidden')\"";
			} else {
				$admin_javascript = '';
			}

			if ($nav_code=='heading') {
				$rs2=$CONN->Execute("SELECT initial_state,level FROM {$CONFIG['DB_PREFIX']}headings WHERE module_key=$module_key2");
				$hclosed=(isset($_SESSION['disclose_statuses']['module'.$module_key2])?
					$_SESSION['disclose_statuses']['module'.$module_key2]:$rs2->fields[0]);
				$newhlevel=min(3,max(1,$rs2->fields[1]));
$extra_info.="<br />{$general_strings['heading']} $newhlevel ";
				if ($nav_name) {
					$link.=pophlist($header_array,$newhlevel)."<li><span class=\"navHeading\"  ";
					if ($_SESSION['JAVASCRIPT']) {
					$link.="style=\"background-image:url({$CONFIG['PATH']}/images/disclosure_white_";
						if($hclosed) {  //allow for later force-open for active link!
							$link.='{NAVSTATimg'.$navHIndex.'}';
							$t->set_var('NAVSTATimg'.$navHIndex,'closed');							
						} else {
							$link.='open';
						}
						
						$link.=".gif)\" onClick=\"disclose_it('navH$navHIndex',this.style,'backgroundImage','module$module_key2')\" $admin_javascript";
					} else {$hclosed=false;}
					
					$link.="><span>$nav_name</span></span><ul class=\"navlevel\" id=\"navH$navHIndex\" ";
					if($hclosed) {
						$link.='{NAVSTATsty'.$navHIndex.'}';
						$t->set_var('NAVSTATsty'.$navHIndex,'style="display:none;"');
					}
					$link.='>';
					$header_array[count($header_array)+1]=array($newhlevel,$navHIndex);
					$navHIndex++;
				} else {
					$link.=pophlist($header_array,$newhlevel)."<li ><span class=\"navSpacer\" $admin_javascript></span></li>";
				}

			} else {
				
				if ($status_key==2 || $status_key==5) {
						
					$hidden = '<span class="smallred">X</span>';
						
				} else {
					
					$hidden = '';
						
				}
				
				
				if ($link_key==$link_key2) {
					
					$link .= ($include_active? "<li ><strong  style=\"background-image: url($nav_image)\" class=\"navlinks\" id=\"activeLink\" $admin_javascript>$nav_name $hidden</strong></li>":"<li>&nbsp;</li>");
					
					foreach($header_array as $elem) {
						$t->set_var('NAVSTATimg'.$elem[1],'open');
						$t->set_var('NAVSTATsty'.$elem[1],'');
					}
					 
				} else {
								
					if ($nav_code=='space') {
						
						$rs_space_key = $CONN->Execute("SELECT SpaceKey,ShortName,CombineNames FROM {$CONFIG['DB_PREFIX']}Spaces WHERE ModuleKey='$module_key2'");
						
						$space_key2 = $rs_space_key->fields[0];
						$display_name = $rs_space_key->fields[1];
						if($display_name=='') {$display_name=$nav_name;} else {
							if($rs_space_key->fields[2]){$display_name.=' - '.$nav_name;
							} else {
								$nav_description=$nav_name.' - '.$nav_description;
							}
						}
						$rs_space_key->Close();

						$link .= "<li".($hidden?get_admin_tool_class():'')."><a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key2&link_key=$link_key2\"  title=\"$nav_description\" $target  style=\"background-image: url($nav_image)\" class=\"navlinks\"  $admin_javascript>$display_name $hidden</a> </li>";
						
					} else {
					
						$link .= "<li".($hidden?get_admin_tool_class():'')."><a href=\"{$CONFIG['PATH']}/modules/$nav_code/$nav_code.php?space_key=$space_key&amp;module_key=$module_key2&amp;link_key=$link_key2&amp;group_key=$group_key2\"  class=\"navlinks\" title=\"$nav_description\" $target style=\"background-image: url($nav_image)\" $admin_javascript>$nav_name $hidden</a> </li>";
						
					
					}
		
				}
				

			}
			
			if ($can_edit_link==true) {
			
				$admin_image=get_admin_tool("{$CONFIG['PATH']}/modules/$nav_code/$nav_admin?space_key=$space_key&amp;module_key=$module_key2&amp;link_key=$link_key2&amp;action=modify",false,"{$general_strings['edit']} {$general_strings['module_text']} $module_key2 - sort order $sort_order",'tool','',"onMouseOut=\"killpopup2(event,'admin_$module_key2')\"");
				

				$hidden_divs .= "<div id=\"admin_$module_key2\" class=\"popup\" onMouseOver=\"keeppopup('admin_$module_key2')\" onMouseOut=\"killpopup(event,'admin_$module_key2')\">  $admin_image {$general_strings['module_text']} #$module_key2 - {$general_strings['sort_order']} $sort_order$extra_info</div>";
				$admin_javascript = "onMouseOver=\"showhide(this,'admin_$module_key2','visible')\" 
onmouseout=\"showhide(this,'admin_$module_key2','hidden')\"";
				
			} else { 
				$admin_image='';
			}
			
			
		}
		$rs->MoveNext();
	}

	$t->set_var('HIDDEN_DIVS',$hidden_divs);
	
	$link.=pophlist($header_array,0);
	
	$sql="select Name,Url from {$CONFIG['DB_PREFIX']}CommonNavigationLinks where SpaceTypeKey='$page_details[type_key]'";
	$rs = $CONN->Execute("$sql");

	while (!$rs->EOF) {

		$name = $rs->fields[0];
		$Url = $rs->fields[1];
		$nav_image = "<td><img src=\"{$CONFIG['PATH']}/images/link.gif\" width=\"16\" height=\"16\" align=\"middle\" alt=\"icon\" /></td>";
		$t->set_var("NAV_IMAGE","$nav_image");
		$link .= "<td><a href=\"$Url\" class=\"navlinks\" >$name</a></td>";
		$t->set_var("ADMIN_IMAGE","");
		$rs->MoveNext();
	}
	//see if admin for current module, if so show admin tool
	$can_edit_link = check_link_edit_rights($link_key,$accesslevel_key,$group_accesslevel,$owner_key);				
	
	if ($can_edit_link==true) {
	
		$code = $page_details['module_code'];
		
		$current_module_admin=get_admin_tool("{$CONFIG['PATH']}/modules/".$page_details['module_code']."/".$page_details['module_code']."_input.php?space_key=$space_key&amp;module_key=$module_key&amp;link_key=$link_key&amp;action=modify",true,"{$general_strings['edit']} {$general_strings['module_text']} $module_key2 - {$general_strings['sort_order']} $sort_order",'tool',"{$general_strings['edit']} {$general_strings['module_text']} $module_key");
		
	
		$t->set_var("CURRENT_MODULE_ADMIN_IMAGE",$current_module_admin);		
	}

	if (($_SESSION['JAVASCRIPT']&&$can_edit_link) || $_SESSION['disclose_statuses']['admin_tool_button']) {
		$t->set_var('ADMIN_TOOL_BUTTON','<img src="'.$CONFIG['PATH'].'/images/admin_tool_'.($_SESSION['disclose_statuses']['admin_tool_button']?'closed':'open').'.gif" width="19" height="18" id="admin_tool_button" onclick="admin_toggle()" title="'.$general_strings['admin_tool_button'].'">');
	}

	$t->set_var("SPACE_KEY","$space_key");
	
	$t->set_var("NAV_LINK_TOTAL",$link."</ul>");
	$t->Parse('NAV_LINK', 'NAV_LINK_TOTAL');
	
	$t->parse("CONTENTS", "navigation", true);


} //end get_navigation


function pophlist(&$header_array,$newhlevel) {
	$header_depth=count($header_array);
	$pops='';
	while($header_depth>0 && $header_array[$header_depth][0]>=$newhlevel) {
		$pops.='</ul></li>';
		if($header_depth==$newhlevel){$pops.='<span class="nav_ul_EndSpacer"></span>';}
		unset($header_array[$header_depth--]);
	}
	return $pops;
}



function get_login_details() {
	global $general_strings,$CONFIG;
	return $general_strings['logged_in_as']."<br /> <a href=\"".$CONFIG['PATH']."/users/userinput.php?action=modify\" class=\"small\"  title=\"".$general_strings['modify_details']."\">{$_SESSION['current_user_firstname']} {$_SESSION['current_user_lastname']}</a>";
}


function set_online_status_link() {
	global $t,$general_strings,$CONFIG;
	if (isset($_SESSION['online_status']) && $_SESSION['online_status']==1) {
		$t->set_var("ONLINE_STATUS_LINK",'<a href="'.$CONFIG['PATH'].'/messaging/setstatus.php?status=0" title="'.$general_strings['hide_me_desc'].'">'.$general_strings['hide_me'].'</a>');
	} else {
		$t->set_var("ONLINE_STATUS_LINK",'<a href="'.$CONFIG['PATH'].'/messaging/setstatus.php?status=1" title="'.$general_strings['show_me_desc'].'">'.$general_strings['show_me'].'</a>');
	}
}

function get_your_links_menu() {
	global $t,$CONN,$space_keys,$general_strings, $CONFIG, $last_use, $spaces_sql, $groups_sql;

   	$PHP_SELF			   = $_SERVER['PHP_SELF'];
	$current_user_key	   = $_SESSION['current_user_key'];
	$current_user_firstname = $_SESSION['current_user_firstname'];
	$current_user_lastname  = $_SESSION['current_user_lastname'];
	$edit				   = $_GET['edit'];
	
	// find spaces that user is a member of
	$space_keys=array();
	$spaces = $spaces.'<form name="yourlinks" method="GET" action="'.$CONFIG['PATH'].'/redirect.php" style="margin: 0px; padding: 0px;"><select onChange="openDir(this.form)" class="small" name="URL">';
	
	//if user_notes enabled find out if there have been any notes added for this user
	$spaces .= '<option value="'.$CONFIG['PATH'].'/">'.$general_strings['home'].'</option>';
	$spaces .= '<option value="'.$_SERVER['REQUEST_URI'].'" selected>&mdash; '.$general_strings['your_links'].' &mdash;</option>';
	if ($CONFIG['USER_SPACES']==1) {
	
		//see if user has a MySpace
		$myspace_key = $CONN->GetOne("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE OwnedByKey='$current_user_key'");
		if ($myspace_key) {
			$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$myspace_key\">".$general_strings['myspace']."</option>";	
		}
				
	}
	if ($CONFIG['ALLOW_TAGS']==1) {

		$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/urltags/urltags.php\">".$general_strings['url_tags']."</option>";
			
	}
	if ($CONFIG['GLOBAL_GRADEBOOK']==1) {
	
		$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/modules/gradebook/globalgradebook.php\">".$general_strings['global_gradebook']."</option>";
			
	}

	

	
	//if server admin then give server admin link
	if ($_SESSION['userlevel_key']==1) {
	
		$spaces = $spaces.'<option value="'.$CONFIG['PATH'].'/admin/">Server Admin</option>';
		
	}
	
	$sql = "select {$CONFIG['DB_PREFIX']}Spaces.SpaceKey,ShortName,{$CONFIG['DB_PREFIX']}Spaces.Name from {$CONFIG['DB_PREFIX']}Spaces, {$CONFIG['DB_PREFIX']}SpaceUserLinks, {$CONFIG['DB_PREFIX']}Modules where {$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey AND {$CONFIG['DB_PREFIX']}Spaces.ModuleKey={$CONFIG['DB_PREFIX']}Modules.ModuleKey AND  ({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey='$current_user_key') AND ({$CONFIG['DB_PREFIX']}Spaces.ShortName!='$current_user_key') AND {$CONFIG['DB_PREFIX']}Modules.StatusKey='1' AND {$CONFIG['DB_PREFIX']}Spaces.OwnedByKey='0' ORDER BY ShortName";
	
	$rs = $CONN->Execute("$sql");
echo $CONN->ErrorMsg();
	if ($rs->EOF) {
	
	
	} else {
		
		$spaces .= '<optgroup label="'.ucfirst($general_strings['space_plural']).'">';
				
		while (!$rs->EOF) {
			$space_key = $rs->fields[0];
			$short_name = $rs->fields[1];
			$name = $rs->fields[2];
			
			if ($short_name=='') {
				
				if (strlen($name)>14) {
					$name = substr($name,0,13).'&hellip;';
				}
				$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\"> $name</option>";
				$space_keys[$space_key]=$name;
			} else {
				$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\"> $short_name</option>";
				$space_keys[$space_key]=$short_name;
			}
			
			$rs->MoveNext();
		}
		
	}
	$spaces .= "</optgroup>";
	
	//now get groups
		$sql = "select {$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks, {$CONFIG['DB_PREFIX']}GroupUserLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey={$CONFIG['DB_PREFIX']}GroupUserLinks.GroupKey AND  ({$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey='$current_user_key')  AND {$CONFIG['DB_PREFIX']}Modules.StatusKey='1' AND {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey='6' ORDER BY Name";
	
	$rs = $CONN->Execute("$sql");
echo $CONN->ErrorMsg();
	if ($rs->EOF) {
	
	
	} else {
		
		$spaces .= '<optgroup label="Groups">';
				
		while (!$rs->EOF) {
			$name = $rs->fields[0];
			$space_key= $rs->fields[1];
			$module_key = $rs->fields[2];
			
			if (strlen($name)>14) {
				$name = substr($name,0,13).'&hellip;';
			}
			$spaces = $spaces."<option value=\"{$CONFIG['PATH']}/modules/group/group.php?space_key=$space_key&module_key=$module_key\"> $name</option>";
			$space_keys[$space_key]=$name;
						
			$rs->MoveNext();
		}
		
	}
	$spaces .= "</optgroup>";
	$spaces .= '</select> <script type="text/javascript">
</script><noscript> <input name="submit" type="image" align="absbottom" src="'.$CONFIG['PATH'].'/images/go.gif" alt="go" title="follow link" height="17" width="23" /></noscript></form>';
	$t->set_var("YOUR_LINKS_MENU","$spaces");
} //get_your_links_menu()



function top_level_navigation() {
	global $t,$CONN,$space_keys,$general_strings, $CONFIG;

   	$PHP_SELF			   = $_SERVER['PHP_SELF'];
	$current_user_key	   = $_SESSION['current_user_key'];
	$current_user_firstname = $_SESSION['current_user_firstname'];
	$current_user_lastname  = $_SESSION['current_user_lastname'];
	$edit				   = $_GET['edit'];
	$browser=browser_get_agent();
	if ($browser[agent]=='MOZILLA' && $browser[version]<"5") {

		$netscape_spacer="<img src=\"{$CONFIG['PATH']}/images/netscapespacer.gif\" width=\"480\" height=\"1\">";
		$width="";
	} else {
		$netscape_space="";
		$width="100%";
	}
	$t->set_var("NETSCAPE_SPACER","$netscape_spacer");
	$t->set_var("WIDTH","$width");

	//if logged in show user name and logout, else show login link
	
	if (isset($current_user_key)) {
	
		if ($_SESSION['userlevel_key']!=5) {
		
			$login_details = $general_strings['logged_in_as']."<br /> <a href=\"".$CONFIG['PATH']."/users/userinput.php?action=modify\" class=\"small\"  title=\"".$general_strings['modify_details']."\">$current_user_firstname $current_user_lastname</a>";
			
		} else {
		
			$login_details = $general_strings['logged_in_as']."<br /> $current_user_firstname $current_user_lastname";
		
		}

		
		$t->set_var("LOGIN_DETAILS","$login_details");
		
		//get users photo
		
		if (!class_exists('InteractUser')) {

			require_once($CONFIG['BASE_PATH'].'/includes/lib/user.inc.php');
	
		}

		$user = new InteractUser();
		$t->set_var("CURRENT_USER_PHOTO",$user->getUserPhotoTag($current_user_key, '35'));		
		$t->set_var("LOGIN_DETAILS","$login_details");
		
	} else {
	
		$request_uri=urlencode($REQUEST_URI);
		$login_details = $general_strings['not_logged_in'];
		//$login_details .= "<br /><a href=\"{$CONFIG['PATH']}/login.php\" class=\"small\">".$general_strings['login'].'</a>';
		

		
	}

	if ($PHP_SELF==$CONFIG['PATH'].'/index.php') {
		if ($edit=="true") {
			$edit_switch="<a href=\"index.php\" class=\"smallred\">".$general_strings['finished_edit'].'</a>';
		} else {
			$edit_switch="<a href=\"index.php?edit=true\" class=\"smallred\">".$general_strings['edit'].'</a>';
		}
	} else {
		$edit_switch = "";
	}
	$t->set_var("EDIT_SWITCH","$edit_switch");



	// find spaces that user is a member of
	$space_keys=array();
	$spaces = $spaces."<ul class=\"YourLinksList\">";
	
	//if server admin then give server admin link
	if ($_SESSION['userlevel_key']==1) {
	
		$spaces = $spaces.'<li class="YourLinksListItem"><a href="'.$CONFIG['PATH'].'/admin/">'.$general_strings['server_admin'].'</a></li>';
		
	}
	
	$sql = "SELECT {$CONFIG['DB_PREFIX']}Spaces.SpaceKey from {$CONFIG['DB_PREFIX']}Spaces WHERE  ShortName='$current_user_key'";
	$rs = $CONN->Execute($sql);
	if (!$rs->EOF) {
		while (!$rs->EOF) {
			$space_key = $rs->fields[0];
//			$SPACE_TEXT = ucfirst($SPACE_TEXT);
			$spaces = $spaces."<li class=\"YourLinksListItem\"><a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"small\">My ".ucfirst($general_strings['space_text'])."</a></li>"; 
			$rs->MoveNext();
		}
	} 
			  
	$sql = "select {$CONFIG['DB_PREFIX']}Spaces.SpaceKey,ShortName,Name from {$CONFIG['DB_PREFIX']}Spaces, {$CONFIG['DB_PREFIX']}SpaceUserLinks where {$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey and ({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey='$current_user_key') AND ({$CONFIG['DB_PREFIX']}Spaces.ShortName!='$current_user_key') order by ShortName";
	$rs = $CONN->Execute("$sql");
echo $CONN->ErrorMsg();
	
	if ($rs->EOF) {
	
		if (!$spaces) {
		
			$spaces = sprintf($general_strings['no_memberships'],$general_strings['space_plural']);
		}
	
	} else {
		
		$warning = sprintf($general_strings['remove_membership_warning'],$general_strings['space_text']);

		while (!$rs->EOF) {
			$space_key = $rs->fields[0];
			$short_name = $rs->fields[1];
			$name = $rs->fields[2];
			
 			$rs_cannot_remove = $CONN->Execute("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}DefaultSpaceUserLinks WHERE SpaceKey='$space_key' AND Permanent='1'");
						
			if ($edit=="true" && $rs_cannot_remove->EOF) {
				$edit_link = "<a href=\"removespace.php?space_key=$space_key\" class=\"smallred\" onClick=\"return confirmDelete('$warning')\">".$general_strings['remove'].'</a>';
			} else {
			
				$edit_link = '';
			
			}
			
			if ($short_name=='') {
				
				$spaces = $spaces."<li class=\"YourLinksListItem\"><a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"YourLinks\">$name</a>  $edit_link</li>";
				$space_keys[$space_key]=$name;
			} else {
				$spaces = $spaces."<li class=\"YourLinksListItem\"><a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"YourLinks\">$short_name</a> $edit_link</li>";
				$space_keys[$space_key]=$short_name;
			}
			
			$rs->MoveNext();
		}
		$spaces .= '</ul>';
	}
	$t->set_var("FULL_NAME","$current_user_firstname $current_user_lastname");
	$t->set_var("SPACES","$spaces");
} //end top_level_navigation

/**
* create admin navigation  
*/

function admin_navigation() 
{
	global $t, $CONFIG, $general_strings;
	
	get_your_links_menu();

	if (!class_exists('InteractUser')) {
		require_once($CONFIG['BASE_PATH'].'/includes/lib/user.inc.php');
	}
	$user = new InteractUser();
		$t->set_var("CURRENT_USER_PHOTO",$user->getUserPhotoTag($_SESSION['current_user_key'], '35', ''));

	$current_user_firstname = $_SESSION['current_user_firstname'];
	$current_user_lastname = $_SESSION['current_user_lastname'];
	if (isset($current_user_firstname)) {
		$t->set_var("LOGIN_DETAILS",get_login_details());
		$t->set_var("LOGIN_LINK","<a href=\"{$CONFIG['PATH']}/logout.php\" class=\"topnavigation\">".$general_strings['logout'].'</a>');
	}
//	$SPACE_TEXT = ucfirst($SPACE_TEXT);
	$t->set_var("NAVIGATION","$navlinks");
	$t->set_var("SPACE_TEXT",ucfirst($general_strings['space_text']));
	
	set_online_status_link();

//hack top heading into link if not on admin index page
	if(substr($_SERVER['SCRIPT_NAME'],-15)!='admin/index.php') {
		$t->set_var('SERVER_ADMIN','<a href="'.$CONFIG['PATH'].'/admin/">'.$general_strings['server_admin'].'</a>');}

	$t->parse("CONTENTS", "navigation", true);
	
	
//sneaky hack to make menu highlight current page
$SCRNAME=preg_replace('/\\//' ,'\\/', $_SERVER['SCRIPT_NAME'].(!empty($_SERVER['QUERY_STRING'])? '\\?'.$_SERVER['QUERY_STRING'] : ''));



$t->set_var("CONTENTS",(preg_replace("/<a href=\"".$SCRNAME."\"([^\>]+)class=(\"[^>]*>[^>]+<\/)a>/", "<strong\\1 id=\"activeLink\" class=\\2strong>", $t->get_var("CONTENTS"))));
	
} //end admin_navigation



function get_admin_tool($href,$class_it=true,$title='*',$type='tool',$alt='',$miscImgTags='') {
	global $CONFIG,$general_strings;
	
	$isize=16;
	switch($type) {
	case 'tool':if($title=="*"){$title=$general_strings['edit'];}
	break;
	case 'plus':$isize=10;if($title=="*"){$title=$general_strings['add'];}
	break;
	case 'smallplus':$isize=8;if($title=="*"){$title=$general_strings['add'];}
	break;
	}
	if($title=='*') {$title=$general_strings['edit'];}
	return "<a href=\"$href\"".($class_it?get_admin_tool_class():'')."><img src=\"{$CONFIG['PATH']}/images/$type.gif\" width=\"$isize\" height=\"$isize\" border=\"0\" title=\"".($title?$title:$alt).'" '.($alt?'alt="'.$alt.'"':($title?'alt="'.$title.'"':'')).' '.$miscImgTags.'></a>';
}

function get_admin_tool_class() {
	return ' class="admin_tool"'.(($_SESSION['disclose_statuses']['admin_tool_button']==1)?' style="display:none"':'');
}

/**
* Print headers to stop pages being cached  
*/

function print_headers() 
{
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");
} //end print_headers




function get_top_breadcrumbs($space_key, $space_alt_home='')
{
	global $CONN,$top_trail, $CONFIG, $general_strings, $link_key ;
	
	//see if default space - if so no top breadcrumbs needed
	if ($space_key==$CONFIG['DEFAULT_SPACE_KEY']) {
		return false;
	}
	//if(isset($link_key) && $link_key!='') {
		//$link_sql = 'AND LinkKey=\''.$link_key.'\'';
	//} else {
		$link_sql='';	
	//}
// removed $link_sql from before AND
		$sql="SELECT 
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey 
			FROM 
				{$CONFIG['DB_PREFIX']}Spaces, 
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks 
			WHERE  
			({$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$space_key'
				) AND 
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey=
				{$CONFIG['DB_PREFIX']}Spaces.ModuleKey				
			";
	if(!($rs = $CONN->Execute($sql))){echo $CONN->ErrorMsg();}
	while (!$rs->EOF) {		  
 
		$parent_key=$rs->fields[0];
		$rs->MoveNext();
	
	}
	
	if (!empty($space_alt_home)) {
		$home_crumb="<a href=\"$space_alt_home\" class=\"smallgrey\">".$general_strings['home']."</a> &raquo;";
	} else {
		$home_crumb="<a href=\"{$CONFIG['PATH']}/\" class=\"smallgrey\">".$general_strings['home']."</a> &raquo;";
	}
	$top_trail='';
	if ($parent_key==0) {
		return $home_crumb;
	} else {
		get_top_breadcrumbs_recurse($parent_key);
		return $home_crumb.$top_trail;
	}
}


function get_top_breadcrumbs_recurse($parent_key)
{
	global $CONN,$top_trail, $CONFIG;
	
	$sql="SELECT 
	 			{$CONFIG['DB_PREFIX']}Spaces.Spacekey, 
				{$CONFIG['DB_PREFIX']}Spaces.Name, 
				{$CONFIG['DB_PREFIX']}Spaces.ShortName,
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey 
			FROM
				{$CONFIG['DB_PREFIX']}Spaces,
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks 
			WHERE
				{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey
				={$CONFIG['DB_PREFIX']}Spaces.ModuleKey 
			AND 
				({$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$parent_key')";
	
	$rs = $CONN->Execute($sql);
	echo $CONN->ErrorMsg();
	while (!$rs->EOF) {		  
 
		$space_key=$rs->fields[0];
		$name=$rs->fields[1];
		$short_name=$rs->fields[2];
		$parent_key=$rs->fields[3];
		$rs->MoveNext();
	
	
		if ($space_key!=$CONFIG['DEFAULT_SPACE_KEY']) {
		
			if ($short_name=='') {
		
				$breadcrumbs="<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"smallgrey\">$name</a> &raquo; ".$breadcrumbs;
		
			} else {
		
				$breadcrumbs="<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\" class=\"smallgrey\">$short_name</a> &raquo; ".$breadcrumbs;
		
			}
			
		}
	
		if ($parent_key==0) {
			$top_trail =  $breadcrumbs.$top_trail;
			 return true;
		} else {
			$top_trail =  $breadcrumbs.$top_trail;
			get_top_breadcrumbs_recurse($parent_key);
		}	  
		$rs->MoveNext();
	}

} //end get_breadcrumb_links

function statistics($type="read") 
{
	
	global $CONN, $space_key,$module_key,$accesslevel_key, $CONFIG;
	
	$REMOTE_ADDR	  = $_SERVER['REMOTE_ADDR'];
	$userlevel_key	= $_SESSION['userlevel_key'];
	$current_user_key = $_SESSION['current_user_key'];	
	

	$date = date("Y-m-d H:i:s");

	$CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}Statistics(SpaceKey,ModuleKey,UserKey,DateAccessed,UseType, Location) VALUES ('$space_key','$module_key','$current_user_key','$date','$type','$REMOTE_ADDR')");
}

function browser_get_agent () {
	
	$HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT']; 

	$browser=array();
	if (ereg( 'MSIE ([0-9].[0-9]{1,2})',$HTTP_USER_AGENT,$log_version)) {
		$browser["version"]=$log_version[1];
		$browser["agent"]='IE';
	} elseif (ereg( 'Opera ([0-9].[0-9]{1,2})',$HTTP_USER_AGENT,$log_version)) {
		$browser["version"]=$log_version[1];
		$browser["agent"]='OPERA';
	} elseif (ereg('Safari/([0-9]+\.[0-9]+)',$HTTP_USER_AGENT,$log_version)) {
		$browser["version"]=$log_version[1];
		$browser["agent"]='SAFARI';
	} elseif (ereg( 'Mozilla/([0-9].[0-9]{1,2})',$HTTP_USER_AGENT,$log_version)) {
		$browser["version"]=$log_version[1];
		$browser["agent"]='MOZILLA';
	} else {
		$browser["version"]=0;
		$browser["agent"]='OTHER';
	}
	if (ereg( 'Gecko\/([0-9]*)',$HTTP_USER_AGENT,$log_version)) {
		$browser["gecko_version"]=$log_version[1];
	} 
	if (strstr($HTTP_USER_AGENT,'Win')) {
	$browser["platform"]='Win';
	} else if (strstr($HTTP_USER_AGENT,'Mac')) {
	$browser["platform"]='Mac';
	} else if (strstr($HTTP_USER_AGENT,'Linux')) {
	$browser["platform"]='Linux';
	} else if (strstr($HTTP_USER_AGENT,'Unix')) {
	$browser["platform"]='Unix';
	} else {
	$browser["platform"]='Other';
	}
		return $browser;
}



function delete_directory($dir) 
{ 
 
     global $CONFIG;
     
     if (strpos($dir, $CONFIG['DATA_PATH'])!==0) {
         return false;
     }

		
	if(!$opendir = opendir($dir)) {
		
		return false;
		
	}

	while(false !== ($readdir = readdir($opendir))) {

		if($readdir !== '..' && $readdir !== '.') {
	
			$readdir = trim($readdir);
			
			if(is_file($dir.'/'.$readdir)) {
			
				if(!unlink($dir.'/'.$readdir)) {
					
					return false;

				}

		   } elseif(is_dir($dir.'/'.$readdir)) {

			   // Calls itself to clear subdirectories

			   if(!delete_directory($dir.'/'.$readdir)) {
			   
				   return false; 
			   
			   }

		   }

	   }

	}

	closedir($opendir);

	if(!rmdir($dir)) {

		return false;
	
	}

	return true;

}

function copy_directory($source, $dest){
     // Simple copy for a file
     if (is_file($source)) {
        $c = copy($source, $dest);
        chmod($dest, 0777);
        return $c;
      }
 
     // Make destination directory
     if (!is_dir($dest)) {
          $oldumask = umask(0);
          mkdir($dest, 0777);
        umask($oldumask);
      }
 
     // Loop through the folder
     if ($dir = dir($source)) {
     
		 $c=true;
		 while ($c && (false !== $entry = $dir->read())) {
			  // Skip pointers
			  if ($entry == '.' || $entry == '..') {
				   continue;
			   }
	  
			  // Deep copy directories
			  if ($dest !== "$source/$entry") {
				   $c=copy_directory("$source/$entry", "$dest/$entry");
			   }
		  }
	 } else {return false;}
	 
     // Clean up
     $dir->close();
     return $c;
}


function _is_valid($string, $min_length, $max_length, $regex)
{
	// Check if the string is empty
	$str = trim($string);
	if(empty($str))
	{
		return(false);
	}

	// Does the string entirely consist of characters of $type?
	if(!eregi("^$regex$", $string))
	{
		return(false);
	}
	
	// Check for the optional length specifiers
	$strlen = strlen($string);
	if(($min_length != 0 && $strlen < $min_length) || ($max_length != 0 && $strlen > $max_length))
	{
		return(false);
	}

	// Passed all tests
	return(true);

}

/*
 *	  bool is_alpha(string string[, int min_length[, int max_length]])
 *	  Check if a string consists of alphabetic characters only. Optionally
 *	  check if it has a minimum length of min_length characters and/or a
 *	  maximum length of max_length characters.
 */
function is_alpha($string, $min_length = 0, $max_length = 0)
{
	$ret = _is_valid($string, $min_length, $max_length, "[[:alpha:]]+");

	return($ret);
}


/*
 *	  bool is_alphanumeric(string string[, int min_length[, int max_length]])
 *	  Check if a string consists of alphanumeric characters only. Optionally
 *	  check if it has a minimum length of min_length characters and/or a
 *	  maximum length of max_length characters.
 */
function is_alphanumeric($string, $min_length = 0, $max_length = 0)
{
	$ret = _is_valid($string, $min_length, $max_length, "[[:alnum:]]+");

	return($ret);
}

function email_error($error_type)
{
	global $CONFIG,$module_key,$space_key;
	
	$current_user_key = $_SESSION['current_user_key'];
	
	$message = "There was an error - $error_type\n";
	$message .= "\nmodule_key=$module_key\n";
	$message .= "space_key=$space_key\n";
	$message .= "current_user_key=$current_user_key\n";
	$subject = "Interact Error";

	mailfrom($CONFIG['ERROR_EMAIL'],$CONFIG['ERROR_EMAIL'],$CONFIG['ERROR_EMAIL'],$subject,$message,$headers);
}

function mailfrom($fromaddress, $toaddress, $fullto,$subject, $body, $headers) { 
$toaddress=ereg_replace( "&", "\&", $toaddress);
$fullto=ereg_replace( "&", "\&", $fullto);
$headers="Content-Transfer-Encoding: 8bit\n".$headers;
$fp = popen('/usr/sbin/sendmail -f'.$fromaddress.' '.$toaddress,"w"); 
if(!$fp) return false; 

fputs($fp, "To: $fullto\n"); 
fputs($fp, "Subject: $subject\n"); 
fputs($fp, $headers."\n\n"); 
fputs($fp, $body); 
fputs($fp, "\n"); 
pclose($fp); 
}

//returns selected userkeys as an array
function get_userkey_array($sql)
{
	global $CONN;
	$n=0;
	$user_keys = array();
	$rs = $CONN->Execute("$sql");
   
	while (!$rs->EOF) {
		$user_keys[$n] = $rs->fields[0];
		$n++;
		$rs->MoveNext();
	}
	return $user_keys;
}

function get_readposts_array($module_key='',$user_key)
{
	global $CONN, $CONFIG;
	$n=0;
	$readposts_array = array();
	if ($module_key=="") {
		$sql = "SELECT post_key FROM {$CONFIG['DB_PREFIX']}ReadPosts WHERE UserKey='$user_key'";
	} else {
		$sql = "SELECT post_key FROM {$CONFIG['DB_PREFIX']}ReadPosts WHERE ModuleKey='$module_key' AND UserKey='$user_key'";
	}

	$rs = $CONN->Execute($sql);
	while (!$rs->EOF) {
		$readposts_array[$n] = $rs->fields[0];
		$n++;
		$rs->MoveNext();
	}
	return $readposts_array;

}



function set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel)
{
	global $t, $CONFIG, $CONN, $general_strings, $objHtml, $objSkins;

	if(xmlhconn_ok()) {$t->set_var('XMLHCONN','<script type="text/javascript" language="javascript"  src="'.$CONFIG['PATH'].'/messaging/messagingjs.php"></script>');}

	if (isset($_SESSION['current_user_key']) && $_SESSION['current_user_key']!=0) {
		$rs = $CONN->Execute("SELECT message_key,added_by_key, message, FirstName, LastName, time FROM {$CONFIG['DB_PREFIX']}user_messages, {$CONFIG['DB_PREFIX']}Users WHERE {$CONFIG['DB_PREFIX']}user_messages.added_by_key={$CONFIG['DB_PREFIX']}Users.UserKey AND  added_for_key={$_SESSION['current_user_key']} AND ({$CONFIG['DB_PREFIX']}user_messages.status_key=1 OR {$CONFIG['DB_PREFIX']}user_messages.status_key=2)");

		if (!$rs->EOF) {
			
			$record_count = $rs->RecordCount();
			$t->set_var('MESSAGE_ALERT_STYLE','style="display:block"');
			if (isset($_SESSION['message_count']) && $_SESSION['message_count']<$record_count) { 
			$t->set_var('MESSAGES','<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="20" height="20" id="bing" align="middle"> <param name="allowScriptAccess" value="sameDomain" /> <param name="movie" value="'.$CONFIG['PATH'].'/messaging/messagebing.swf?snd=1" /> <param name="quality" value="high" /><param name="wmode" value="transparent" />  <embed src="'.$CONFIG['PATH'].'/messaging/messagebing.swf?snd=1" quality="high"  width="20" height="20" name="messagebing" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" wmode="transparent"/></object> '."<a href=\"javascript:open_window('".$CONFIG['PATH']."/messaging/message_admin.php?action=read','messsageAdmin','features')\">".$general_strings['messages'].'</a> (<span id="messageCount">'.$record_count.'</span>)');
			
			} else {
			
				$t->set_var('MESSAGES','<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000"codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" width="20" height="20" id="bing" align="middle"> <param name="allowScriptAccess" value="sameDomain" /> <param name="movie" value="'.$CONFIG['PATH'].'/messaging/messagebing.swf?snd=0" /> <param name="quality" value="high" /><param name="wmode" value="transparent" />  <embed src="'.$CONFIG['PATH'].'/messaging/messagebing.swf?snd=0" quality="high"  width="20" height="20" name="messagebing" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" wmode="transparent"/></object> '."<a href=\"javascript:open_window('".$CONFIG['PATH']."/messaging/message_admin.php?action=read','messsageAdmin','features')\">".$general_strings['messages'].'</a> (<span id="messageCount">'.$record_count.'</span>)');			
			}
			
		} 
		$_SESSION['message_count'] = $record_count;
		$rs->Close();
	}
	$t->set_var('MESSAGE_COUNT',isset($record_count)?$record_count:0);
	$t->set_var('SERVER_NAME',$CONFIG['SERVER_NAME']);
	$t->set_var('PATH',$CONFIG['PATH']);
	$t->set_var('MODULE_FILE_VIEW_PATH',$CONFIG['MODULE_FILE_VIEW_PATH']);
	$t->set_block('footer', 'TagBlock', 'TGSBlock');
	
	if (!is_object($objSkins)) {
		if (!class_exists('InteractSkins')) {
			require_once($CONFIG['BASE_PATH'].'/skins/lib.inc.php');
		}
		$objSkins = new InteractSkins();
	}
	$skin_key = $objSkins->getSkinKey($space_key, $page_details['type_key']);
	$t->set_var('SKIN_KEY',$skin_key);
	
	if (empty($message)) {
		$message = !empty($_GET['message'])?
			$_GET['message']:
			(!empty($_POST['message'])?
				$_POST['message']:'');
	}
	
	if (!is_array($page_details)) {
		
		$t->set_var('TGSBlock','');
		$t->set_var('MESSAGE',$message);
		
	} else {
		if (!is_object($objHtml)) {
			if (!class_exists('InteractHtml')) {
				require_once($CONFIG['BASE_PATH'].'/includes/lib/html.inc.php');
			}
			$objHtml = new InteractHtml();
		}
	
		$t->set_var('LOGIN_LINK',isset($page_details['login_link']) ? $page_details['login_link'] : '');
		$t->set_var('CHARACTER_SET',$general_strings['character_set']);
		$t->set_var('OTHER_HEADER_LINKS',isset($page_details['other_header_links']) ? $page_details['other_header_links'] : '');
		$t->set_var('HOME_LINK',isset($page_details['home_link']) ? $page_details['home_link'] : '');
		$t->set_var('PAGE_TITLE',$page_details['full_space_name'].' - '.$page_details['module_name']);
		$t->set_var('SERVER_NAME',$CONFIG['SERVER_NAME']);

		$t->set_var('SEARCH',$general_strings['search']);
		$t->set_var('SUBMIT',$general_strings['submit']);

		$t->set_var('MESSAGE',$message);	
		$t->set_var('TOP_BREADCRUMBS',$page_details['top_breadcrumbs']);
		$t->set_var('BREADCRUMBS',$page_details['breadcrumbs']);
		$t->set_var('DESCRIPTION',$objHtml->parseText($page_details['module_description']));	
		$t->set_var('FULL_NAME',$current_user);
		if (!empty($page_details['space_alt_home'])) {
			$t->set_var('HEADER_HOME_LINK',$page_details['space_alt_home']);
		} else {
			$t->set_var('HEADER_HOME_LINK',$CONFIG['PATH'].'/spaces/space.php?space_key='.$CONFIG['DEFAULT_SPACE_KEY']);
		}
		
		if (($_SERVER['PHP_SELF']!=$CONFIG['PATH'].'/modules/'.$page_details['module_code'].'/'.$page_details['module_code'].'.php') && (isset($space_key) && $space_key!='')) {
			$t->set_block('navigation', 'ModuleHeadingBlock', 'MHBlock');
			$t->set_var('MHBlock','');
		
		} else {
	
			if (!class_exists('InteractHtml')) {
				require_once($CONFIG['BASE_PATH'].'/includes/lib/html.inc.php');
	 		}
	
			$html = new InteractHtml();
			$t->set_var('MODULE_NAME',$page_details['module_name']);
			$icon_tag = $html->getIconTag($page_details['icon_key'], 'large');
	
			if ($icon_tag!=false) {
				$t->set_var('ICON_TAG',$icon_tag);
			} else {
				$t->set_var('ICON_TAG','<img src="'.$CONFIG['PATH'].'/images/'.$page_details['module_code'].'.gif'.'" height="16" width="16" alt="Icon">');
			}
		
		}
	
		//if tags enabled set Add Tag link
		if ($CONFIG['ALLOW_TAGS']==1 && isset($_SESSION['current_user_key'])) {
			if ($space_key!='' && $_SERVER['PHP_SELF']!='/urltags/urltaginput.php') {
				$current_url = urlencode($_SERVER['REQUEST_URI']);
				$add_tag_link = '<a href="'.$CONFIG['PATH'].'/urltags/urltaginput.php?space_key='.$space_key.'&module_key='.$module_key.'&tag_url='.$current_url.'" title="'.$general_strings['tag_page'].'"><img src="'.$CONFIG['PATH'].'/images/addtag.gif" border="0"></a>';
				$t->set_var('ADD_TAG',$add_tag_link);
			} else {
		   		$t->set_var('ADD_TAG','');
	   		}
	
			//get any url tags for this page
			if (!class_exists('InteractUrlTags')) {
				require_once($CONFIG['BASE_PATH'].'/urltags/lib.inc.php');
			}
			$objUrlTags = new InteractUrlTags();
			$urltags = $objUrlTags->getUrlTags($_SERVER['REQUEST_URI'], $space_key, $_SESSION['current_user_key'], $accesslevel_key, $group_accesslevel, $module_key);
		
		} else {
			$t->set_var('TGSBlock','');
		}
	}
}

function set_common_admin_vars($page_title, $message)
{
	global $t, $CONFIG, $general_strings,$admin_strings;
	
	if(xmlhconn_ok()) {$t->set_var('XMLHCONN','<script type="text/javascript" language="javascript"  src="'.$CONFIG['PATH'].'/messaging/messagingjs.php"></script>');}

	if (empty($message)) {
		$message = !empty($_GET['message'])?
			$_GET['message']:
			(!empty($_POST['message'])?
				$_POST['message']:'');
	}
	
	//find out which skin to use
	if (!is_object($objSkins)) {
		if (!class_exists('InteractSkins')) {
			require_once($CONFIG['BASE_PATH'].'/skins/lib.inc.php');
		}
		$objSkins = new InteractSkins();
	}
	$skin_key = $objSkins->getSkinKey($space_key);
	$t->set_var('SKIN_KEY',$skin_key);
	$t->set_var('PAGE_TITLE',$CONFIG['SERVER_NAME'].' - Server Admin - '.$page_title);
	$t->set_var('SPACE_TITLE',$CONFIG['SERVER_NAME'].' - Server Admin - '.$page_title);
	$t->set_var('CHARACTER_SET',$general_strings['character_set']);
	$t->set_var('PATH',$CONFIG['PATH']);
	$t->set_var('MESSAGE',$message);
	$t->set_var('MESSAGE_COUNT','0');	
	$t->set_var('FULL_NAME',$current_user);
	$t->set_block('footer', 'UserNoteBlock', 'UNBlock');	
	$t->set_var('UNBlock','');
	$t->set_var('MODULE_TEXT',ucfirst($general_strings['module_text']));
	$t->set_var('HEADER_HOME_LINK',$CONFIG['PATH'].'/spaces/space.php?space_key='.$CONFIG['DEFAULT_SPACE_KEY']);
	$t->set_strings('navigation', $admin_strings);

}

function get_module_key($link_key)
{
	global $CONN, $CONFIG;
	$sql = "SELECT ModuleKey from {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE LinkKey='$link_key'";

	$rs = $CONN->Execute("$sql");
   
	while (!$rs->EOF) {
		$module_key = $rs->fields[0];
		$rs->MoveNext();
	}
	return $module_key;
}
function get_space_key()
{
	
	if (isset($_GET['space_key']) && $_GET['space_key']!='') {

		$space_key	= $_GET['space_key'];
	
	} else if (isset($_POST['space_key'])){

		$space_key	= $_POST["space_key"];

	}

	if (!isset($space_key)) {
	
		$space_key = $_SESSION['current_space_key'];

	} else if ($space_key!=$_SESSION['current_space_key']){

		$_SESSION[current_space_key] = $space_key;

	}
	
	return $space_key;
	
}

function get_link_key($module_key,$space_key)
{
	global $CONN, $CONFIG;
	
	$link_key 	= $_GET["link_key"];

	if (!$link_key) {

	$sql = "SELECT LinkKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE ModuleKey='$module_key' and SpaceKey='$space_key'";
   	$rs = $CONN->Execute("$sql");

   	while (!$rs->EOF) {

	   	$link_key = $rs->fields[0];
	   	$rs->MoveNext();

   	}

}	
	return $link_key;
}

function check_module_link_rights($module_key) 
{

	global $CONN, $CONFIG;
	$current_user_key = $_SESSION['current_user_key'];
	$userlevel_key	= $_SESSION['userlevel_key'];

	if ($userlevel_key=='1') {
	
		return true;
	
	}
	
	$sql = "SELECT EditRightsKey,OwnerKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleKey='$module_key'";
	$rs = $CONN->Execute($sql);
		
	while (!$rs->EOF) {
		
		$edit_rights_key = $rs->fields[0]; 
		$owner_key = $rs->fields[1];
		$rs->MoveNext();
			
	}

	$rs->Close();	
	
	if ($owner_key==$current_user_key) {
	
		return true;
		
	} 

   	switch ($edit_rights_key) {
	
		case 1:
		
			return true;
		
		break;
		
		
		case 2: 
		
			return true;
			
		break;
		
		case 3:
	
			$sql = "SELECT UserKey From {$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE UserKey='$current_user_key' AND ModuleKey='$module_key'";
			$rs = $CONN->Execute($sql);
			
			if (!$rs->EOF) {
			
				return true;
				
			} else {
			
				$sql = "SELECT {$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey FROM {$CONFIG['DB_PREFIX']}GroupUserLinks,{$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.GroupKey={$CONFIG['DB_PREFIX']}GroupUserLinks.GroupKey AND ({$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey='$current_user_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.ModuleKey='$module_key')";
			
				$rs = $CONN->Execute($sql);
			
				if (!$rs->EOF) {
	
						return true;
				
				} else {
				
					return false;
					
				}
				
			}
			
	   		break;
	
			default:
			
	 	  		return false;
	 	
			break;
	
		}
			
}

function check_module_edit_rights($module_key) 
{

	global $CONN,$accesslevel_key,$group_accesslevel, $CONFIG;

	$current_user_key = $_SESSION['current_user_key'];
	$userlevel_key	= $_SESSION['userlevel_key'];

	if ($userlevel_key=='1') {
	
		return true;
	
	}
	
	$sql = "SELECT EditRightsKey,OwnerKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleKey='$module_key'";
	
	$rs = $CONN->Execute($sql);
		
	while (!$rs->EOF) {
		
		$edit_rights_key = $rs->fields[0]; 
		$owner_key = $rs->fields[1];
		$rs->MoveNext();
			
	}

	$rs->Close();	

	if ($owner_key==$current_user_key) {
	
		
		return true;
		
	} 

   	switch ($edit_rights_key) {
	
		case 2:
		
			return true;
		
		break;
		
		
		case 3:
	
			$sql = "SELECT UserKey From {$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE UserKey='$current_user_key' AND ModuleKey='$module_key' AND EditLevel='1'";
			$rs = $CONN->Execute($sql);
			
			if (!$rs->EOF) {
			
				return true;
				
			} else {
			
				$sql = "SELECT {$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey FROM {$CONFIG['DB_PREFIX']}GroupUserLinks,{$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.GroupKey={$CONFIG['DB_PREFIX']}GroupUserLinks.GroupKey AND ({$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey='$current_user_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.ModuleKey='$module_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.EditLevel='1')";
			
				$rs = $CONN->Execute($sql);
			
				if (!$rs->EOF) {
	
						return true;
				
				} else {
				
					return false;
					
				}
				
			}
			
	   		break;
	
			case 6:
			
				if ($accesslevel_key==1|$accesslevel_key==3|$group_accesslevel==1) {
				
					return true;
					
				} else {
				  
					return false;
					
				}
			
			break;
			
			default:
			
	 	  		return false;
	 	
			break;
	
		}
			
}

function check_module_copy_rights($module_key) 
{

	global $CONN, $CONFIG, $accesslevel_key, $group_accesslevel;
	$current_user_key = $_SESSION['current_user_key'];
	$userlevel_key	= $_SESSION['userlevel_key'];

	if ($userlevel_key=='1') {
	
		return true;
	
	}
	
	$sql = "SELECT EditRightsKey,OwnerKey FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleKey='$module_key'";
	$rs = $CONN->Execute($sql);
		
	while (!$rs->EOF) {
		
		$edit_rights_key = $rs->fields[0]; 
		$owner_key = $rs->fields[1];
		$rs->MoveNext();
			
	}

	$rs->Close();	
	
	if ($owner_key==$current_user_key) {
	
		return true;
		
	} 

   	switch ($edit_rights_key) {
	
		case 2:
		
			return true;
		
		break;
		
		
		case 3:
	
			$sql = "SELECT UserKey From {$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE UserKey='$current_user_key' AND ModuleKey='$module_key' AND EditLevel='3'";
			$rs = $CONN->Execute($sql);
			
			if (!$rs->EOF) {
			
				return true;
				
			} else {
			
				$sql = "SELECT {$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey FROM {$CONFIG['DB_PREFIX']}GroupUserLinks,ModuleEditRightLinks WHERE {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.GroupKey={$CONFIG['DB_PREFIX']}GroupUserLinks.GroupKey AND ({$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey='$current_user_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.ModuleKey='$module_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.EditLevel='3')";
			
				$rs = $CONN->Execute($sql);
			
				if (!$rs->EOF) {
	
						return true;
				
				} else {
				
					return false;
					
				}
				
			}
			
	   		break;
	
			case 6:
			
				if ($accesslevel_key==1|$accesslevel_key==3|$group_accesslevel==1) {
				
					return true;
					
				} else {
				  
					return false;
					
				}
			
			break;
			default:
			
	 	  		return false;
	 	
			break;
	
		}
			
}

function check_link_edit_rights($link_key,$accesslevel_key,$group_accesslevel,$owner_key='',$edit_rights_key='') 
{

	global $CONN, $CONFIG;
	$current_user_key = $_SESSION['current_user_key'];
	$userlevel_key	= $_SESSION['userlevel_key'];

	//temporary section to fix bug with $link_key not set in version 1.8.5
	if ($link_key=='') {
	
		if ($_SERVER['REQUEST_METHOD']=='GET') {
		
			$link_key = $_GET['link_key'];
			
		} else {
		
			$link_key = $_POST['link_key'];
			
		}
		
	}
	
	if ($userlevel_key=='1') {
	
		return true;
		
	}
					
	if ($owner_key=='' || $edit_rights_key=='') {
	
		$sql = "SELECT EditRightsKey,OwnerKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE LinkKey='$link_key'";
		$rs = $CONN->Execute($sql);
		
		while (!$rs->EOF) {
		
			$edit_rights_key = $rs->fields[0]; 
			$owner_key = $rs->fields[1];
			$rs->MoveNext();
			
		}

		$rs->Close();
		
	}
	
	if ($owner_key==$current_user_key) {
	
		return true;
		
	}

	switch ($edit_rights_key) {
	
  		case 1:
		
			if ($accesslevel_key=='1' || $accesslevel_key=='3' || $group_accesslevel=='1') {
			
				return true;
				
			} else {
			
				return false;
				
			}
		
		break;
		
		case 2: 
		
			$sql = "SELECT UserKey From {$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE UserKey='$current_user_key' AND LinkKey='$link_key'";
			
			$rs = $CONN->Execute($sql);
			
			if (!$rs->EOF) {
			
				return true;
				
			} else {
			
				$sql = "SELECT {$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey FROM {$CONFIG['DB_PREFIX']}GroupUserLinks,{$CONFIG['DB_PREFIX']}ModuleEditRightLinks WHERE {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.GroupKey={$CONFIG['DB_PREFIX']}GroupUserLinks.GroupKey AND ({$CONFIG['DB_PREFIX']}GroupUserLinks.UserKey='$current_user_key' AND {$CONFIG['DB_PREFIX']}ModuleEditRightLinks.LinkKey='$link_key')";
			
				$rs = $CONN->Execute($sql);
			
				if (!$rs->EOF) {
			
					return true;
				
				} else {
				
					return false;
					
				}
				
			}
			
		break;
	
		case 4:
			return true;
		break;
		default:
			
			return false;
		
		break;
	
	}
}

function get_date_space_modified($space_key) 
{

	global $CONN, $CONFIG, $objDates;
	
	$sql = "SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE SpaceKey='$space_key' ORDER BY DateAdded DESC";
	$rs=$CONN->SelectLimit($sql,1);

	while (!$rs->EOF) {
	
		$date_modified = $rs->fields[0];
		
		$rs->MoveNext();
		
	}
	
	$rs->Close();

	$sql = "SELECT DateModified FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE SpaceKey='$space_key' ORDER BY DateModified DESC";
	$rs=$CONN->SelectLimit($sql,1);

	while (!$rs->EOF) {
	
		$date_modified2 = $rs->fields[0];
		
		if ($date_modified2>$date_modified) {
		
			$date_modified = $date_modified2;
			
		}
			
		$rs->MoveNext();		
		
	}
	
	$rs->Close();	

	$sql = "SELECT DateAdded FROM {$CONFIG['DB_PREFIX']}News WHERE SpaceKey='$space_key' ORDER BY DateAdded DESC";
	$rs=$CONN->SelectLimit($sql,1);

	while (!$rs->EOF) {
	
		$date_modified2 = $rs2->fields[0];
		
		if ($date_modified2>$date_modified) {
		
			$date_modified = $date_modified2;
			
		}

		$rs->MoveNext();		
		
	}
	
	$rs->Close();
	
	if ($date_modified=='') {
	
		$date_modified = 'Never modified';
		
	} else {

		if (!is_object($objDates)) {

			if (!class_exists('InteractDate')) {

				require_once($CONFIG['BASE_PATH'].'/includes/lib/date.inc.php');
	
			}

			$objDates = new InteractDate();

		}
		
		$date_modified = $objDates->formatDate(strtotime($date_modified),'long');
			
	}
	
	return $date_modified;
	
}

	
function check_file_upload($name) 
{
		
	global $CONFIG;
	
	$mb_max_size = $CONFIG['MAX_FILE_UPLOAD_SIZE']/1000000;		

	switch ($_FILES[$name]['error']){
	
		case 0:
			
			return true;
				
		break;
			
		case 1:
			
			return "The uploaded file is too large. Files must not be larger than $mb_max_size MB";
				
		break;

		case 2:
			
			return "The uploaded file is too large. Files must not be larger than $mb_max_size MB";
				
		break;

		case 3:
			
			return "The uploaded file was only partially uploaded. Please try again";
				
		break;
			
		case 4:
			
			return "No file was uploaded, please try again";

		break;

		case 5:

			return "Uploaded file seems to be empty, please try again";
				
		break;

	}
	
} //end check_file_upload


/**
* Validate data returned by a form  
* 
* @param array $field_names an array of field names to check
* @param array $field_data an array of data fields returned by the form
* @param array $string_file array of language strings for current module
* @return $errors array an array of any error messages
*/

function check_form($field_names, $field_data, $string_file)
{
	global $CONN, $CONFIG, $general_strings;
	$errors = array();
	foreach($field_names as $value) {
		if (!isset($field_data[$value]) || $field_data[$value]=='') {
			if (isset($string_file[$value.'_error'])) {
				$errors[$value] = $string_file[$value.'_error'];
			} else if (isset($general_strings[$value.'_error'])) {
				$errors[$value] = $string_file[$value.'_error'];
			}else {
				$errors[$value] = $general_strings['required_field_empty'];
			}
		}
	}
	return $errors;
} //end check_form


function xmlhconn_ok() {
	$browser=browser_get_agent();
	return ($_SESSION['JAVASCRIPT'] && !($browser['agent']=='IE' && $browser['platform']=='Mac' ));
}

?>