<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Ldap authentication
*
* Authenticates users against ldap server if interact running on smartnet box
*
* @package Authentication
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: snet_ldap.inc.php,v 1.1.2.1 2006/05/03 01:08:08 glendavies Exp $
* 
*/

/**
* Check password against ldap server 
* 
* @param string $username not actually required for this auth method
* @param string $password password entered by user
* @param string $password2 md5 password from database
* @return true if passwords match
*/
function auth_snet_ldap($user_name, $password, $password2, $level_key) {

	global $CONFIG;
	
	if ($level_key=='4') {
		if (md5($password)==$password2) {
			return true;
		} else {
			return false;
		}
		
	} else {
		if ($conn = @ldap_connect('localhost')) {
  			$binddn = "uid=$user_name,ou=Users,dc=smart-net,dc=local";
  			if (!$rs = @ldap_bind($conn, $binddn, $password)) {
    			return false;
  			} else {
    			return true;
  			}
		} else {
  			return false;
		}
	}
	
} //end auth_snet_ldap

function show_password_change($level_key) {
	
	if ($level_key==4) {
		return true;
	} else {
		return false;
	}
	
}

function get_default_user_level() {
	
	return 4;
	
}
?>
