<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+


/**
* Journal rss page
*
* Displays a journal entries as an rss feed
*
* @package Journals
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2003 
* @version $Id: rss.php,v 1.3 2006/02/12 22:37:15 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../../local/config.inc.php');
require_once($CONFIG['LANGUAGE_CPATH'].'/journal_strings.inc.php');

$module_key			= $_GET['module_key'];
$journal_user_key   = $_GET['journal_user_key'];
$tag_key   	= isset($_GET['tag_key'])? $_GET['tag_key'] : '';
header("Content-Type: text/xml"); 
echo '<?xml version="1.0" encoding="iso-8859-1" ?>';

if (isset($module_key) && $module_key!='') {

	$rs = $CONN->Execute("SELECT Name FROM {$CONFIG['DB_PREFIX']}Modules WHERE ModuleKey='$module_key'");
	
	while (!$rs->EOF) {
	
		$module_name = $rs->fields[0];
		$rs->MoveNext();
	
	}

}
if (isset($journal_user_key) && $journal_user_key!='') {

	if (!class_exists(InteractUser)) {
	
		require_once('../../includes/lib/user.inc.php');
		
	} 
	
	$userObj = new InteractUser();
	$user_data = $userObj->getUserData($journal_user_key);
	$name = '('.$user_data['first_name'].' '.$user_data['last_name'].')';

}
if (!isset($objPosts) || !is_object($objPosts)) {
	if (!class_exists('InteractPosts')) {
		require_once('../../includes/lib/posts.inc.php');
	} 
	$objPosts = new InteractPosts();
}
?>

 
<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns="http://my.netscape.com/rdf/simple/0.9/">
<channel>
  <title><?php echo $CONFIG['SERVER_NAME'].' - '.$module_name; ?></title> 
  <link>http://intranet.navcon.org.nz/modules/journal/journalview.php?module_key=<?php echo $module_key;?>&amp;journal_user_key=<?php echo $journal_user_key;?></link> 
  <description><?php echo $module_name.' '.$name; ?></description> 
  </channel>
  
<?php

$limits = array('module_key'=>$module_key, 'journal_user_key'=>$journal_user_key, 'tag_key'=>$tag_key);	
$rs = $objPosts->getPostData($limits,false);
echo $CONN->ErrorMsg();
while (!$rs->EOF) {
	
	$entry_key = $rs->fields['post_key'];
	$heading = $rs->fields['subject'];
	$body = $rs->fields['body'];
	$first_name = $rs->fields['first_name'];
	$second_name = $rs->fields['last_name'];
	$date_added = $CONN->UnixTimestamp($rs->fields['date_added']);
	$user_key = $rs->fields['added_by_key'];
	$day = date('j M, Y',$date_added);
	$hour = date('g:i a',$date_added);
	echo 	'<item>';
  	echo		'<title>'.$heading.'</title>'; 
  	echo 		'<description>'.$body.'</description>';
  	echo 		'<link>'.$CONFIG['FULL_URL'].'/entry.php?module_key='.$module_key.'&amp;journal_user_key='.$journal_user_key.'&amp;entry_key='.$entry_key.'</link>';
  	echo	'</item>';
	$rs->MoveNext();
	
}

$CONN->Close();	   
	
?>
</rdf:RDF>


