<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Notel Module functions
*
* Contains the functions for adding/modifying/deleting a page
* module
*
* @package Page
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2003 
* @version $Id: page.inc.php,v 1.7 2005/09/22 02:49:27 glendavies Exp $
* 
*/

/**
* Function called by Module class when adding a new page module
*
* @param  int $module_key  key of new page module
* @return true if details added successfully
*/

function add_page($module_key) {

	global $CONN, $CONFIG;
	
	if ($_FILES['file']['name']) {
	 
	   $handle = fopen($_FILES['file']['tmp_name'], "r");
	   $body=fread($handle,filesize($_FILES['file']['tmp_name']));
	   fclose($handle);
	   $body = $CONN->qstr($body);

	} else {
	
		$body = $CONN->qstr($_POST['body']);
	
	} 
	
	$sql = "INSERT INTO {$CONFIG['DB_PREFIX']}Pages(ModuleKey,Body) values ('$module_key',$body)";
	
	if ($CONN->Execute($sql) === false) {
  
		$message =  'There was an error adding your page: '.$CONN->ErrorMsg().' <br />';

		return $message;
		
	} else {	  
	
			return true;  
	}
	

}

/**
* Function called by Module class to get exisiting page data 
*
* @param  int $module_key  key of page module
* @return true if data retrieved
*/

function get_page_data($module_key) {

	global $CONN,$module_data, $CONFIG;
	$sql = "SELECT Body FROM {$CONFIG['DB_PREFIX']}Pages WHERE ModuleKey='$module_key'";	
	$rs = $CONN->Execute($sql);
	
	while (!$rs->EOF) {

		$body = preg_replace("/(<[^>]*)(form[ >])/si", "$1embedded-$2", $rs->fields[0]);
		$body = preg_replace("/(<[^>]*)(textarea[ >])/si", "$1embedded-$2", $body);		
		$module_data['body'] = $body;
		$rs->MoveNext();
	
	}
	
	return true;

}

/**
* Function called by Module class to get exisiting page data 
*
* @param  int $module_key  key of page module
* @return true if data retrieved
*/

function modify_page($module_key,$link_key) {

	global $CONN, $CONFIG;

	if ($_FILES['file']['name']) {
	 
	   $handle = fopen($_FILES['file']['tmp_name'], "r");
	   $body=fread($handle,filesize($_FILES['file']['tmp_name']));
	   fclose($handle);
	   $body = $CONN->qstr($body);

	} else {

	   $body = $CONN->qstr($_POST['body']);
	   
	}
	
	$body = preg_replace("/(<[^>]*)embedded-(form[ >])/", "$1$2", $body);
  	$body = preg_replace("/(<[^>]*)embedded-(textarea[ >])/", "$1$2", $body);
	
	$sql = "UPDATE {$CONFIG['DB_PREFIX']}Pages SET Body=$body WHERE ModuleKey='$module_key'";	
	
	if ($CONN->Execute($sql) === false) {
	
		$message =  'There was an error modifying your page: '.$CONN->ErrorMsg().' <br />';
		return $message;
		
	} else {	  
	
			return true;  
	}

} //end modify_page



/**
* Function called by Module class to delete exisiting page data 
*
* @param  int $module_key  key of page module
* @param  int $space_key  space key of page module
* @param  int $link_key  link key of page module being modified
* @param  int $delete_action 
* @return true if successful
*/
function delete_page($module_key,$space_key,$link_key,$delete_action) 
{
	global $CONN, $CONFIG;
	
	if ($delete_action=='all' || $delete_action=='last') {

		$sql = "DELETE FROM {$CONFIG['DB_PREFIX']}Pages WHERE ModuleKey='$module_key'";
		
		$CONN->Execute($sql);		
		$rows_affected = $CONN->Affected_Rows();

		   if ($rows_affected < '1') {	

				$message = "There was an problem deleting a $module_code link during a module link deletion ModuleKey=$module_key".$CONN->ErrorMsg();
				email_error($message);
				return $message;
		
		} else { 
	
			return true;
						
		}
	
	} else {	
	
		return true;
		
	}

} //end delete_page	 

/**
* Function called by Module class to flag a page for deletion 
*
* @param  int $module_key  key of page module
* @param  int $space_key  space key of page module
* @param  int $link_key  link key of page being modified
* @param  int $delete_action 
* @return true if successful
*/
function flag_page_for_deletion($module_key,$space_key,$link_key,$delete_action) 
{
   
	return true;

} //end flag_page_for_deletion

/**
* Function called by Module class to copy a page 
*
* @param  int $existing_module_key  key of page being copied
* @param  int $existing_link_key  link key of page module being copied
* @param  int $new_module_key  key of page being created
* @param  int $new_link_key  link key of page module being created
* @param  int $module_data  array of existing module data
* @param  int $space_key  space key of page module
* @param  int $new_group_key  heading key of new page
* @return true if successful
*/
function copy_page($existing_module_key, $existing_link_key, $new_module_key, $new_link_key, $module_data,$space_key,$new_group_key) 
{

	global $CONN, $CONFIG;
	$body = $CONN->qstr($module_data['body']);
	$sql = "INSERT INTO {$CONFIG['DB_PREFIX']}Pages(ModuleKey,Body) values ('$new_module_key',$body)";
	
	if ($CONN->Execute($sql) === false) {
	
		$message =  'There was an error copying your page: '.$CONN->ErrorMsg().' <br />';

		return $message;
		
	} else {	  
	
			return true;  
	}

} //end copy_page

/**
* Function called by Module class to add new page link
*
* @param  int $module_key  key of page module
* @return true if successful
*/

function add_page_link($module_key) {

	return true;

}

?>