<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Page homepage
*
* Displays a page start page. 
*
* @package Note
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2003 
* @version $Id: page.php,v 1.20 2006/01/12 22:46:34 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../../local/config.inc.php');
session_start();

//set variables
$space_key 	= get_space_key();
$module_key	= $_GET['module_key'];
$link_key 	= get_link_key($module_key,$space_key);
$group_key	= $_GET['group_key'];
$message	= $_GET['message'];


check_variables(true,true,true);

//check to see if user is logged in. If not refer to Login page.
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups'];
$is_admin = check_module_edit_rights($module_key);

//update statistics 
statistics('read');

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(
	'header'		  => 'Header.ihtml',
	'navigation'	  => 'Navigation.ihtml',
	'note'			=> 'pages/Page.ihtml',
	'footer'		  => 'Footer.ihtml'
));

$page_details = get_page_details($space_key,$link_key);
set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);

$t->set_var('PRINTING_STRING',$general_strings['print_display']);
$t->set_var('DESCRIPTION','');
$t->parse('CONTENTS', 'header', true); 

get_navigation();

$sql = "SELECT {$CONFIG['DB_PREFIX']}Modules.ModuleKey,AdminUrl,{$CONFIG['DB_PREFIX']}Modules.Name,Body FROM {$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes,{$CONFIG['DB_PREFIX']}Pages WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}Pages.ModuleKey AND ({$CONFIG['DB_PREFIX']}Modules.ModuleKey='$module_key')";

$rs = $CONN->Execute($sql);

if (!class_exists('InteractHtml')) {

	require_once('../../includes/lib/html.inc.php');

}

$objHtml = new InteractHtml();

while (!$rs->EOF) {

	$module_key2 = $rs->fields[0];
	$admin_url  = $rs->fields[1];
	$body = $rs->fields[3];

	//replace any garbage MS characters 
	$body = ereg_replace(0x92, "'", $body);
	$body = ereg_replace(0x91, "'", $body);	
	$body = ereg_replace(0x93, "&#147;", $body);
	$body = ereg_replace(0x94, "&#148;", $body);
	$body = ereg_replace('', " ", $body);
	$body = ereg_replace('%3f', '?', $body);
	$body = $objHtml->parseText($body);
	
	if ($CONFIG['ALLOW_PHP']==true) {
	
		$body = eval_html($body);
		
	}
	
	$t->set_var('SPACE_KEY',$space_key);
	$t->set_var('MODULE_KEY',$module_key2);
	$t->set_var('BODY',$body);
	
	
	if ($is_admin==true) {
	
		$admin_image=get_admin_tool("{$CONFIG['PATH']}/modules/page/page_input.php?space_key=$space_key&module_key=$module_key2&link_key=$link_key&parent_key={$page_details['parent_key']}&action=modify");
	
	}
	
	$t->set_var('ADMIN_IMAGE',$admin_image);
	$t->parse('CONTENTS', 'note', true);
	$rs->MoveNext();

}

$rs->Close();
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
	   
$CONN->Close();
exit;

function eval_buffer($string) { 
   ob_start(); 
   eval("$string[2];"); 
   $ret = ob_get_contents(); 
   ob_end_clean(); 
   return $ret; 
} 

function eval_html($string) { 
   return preg_replace_callback("/(<\?php|<\?)(.*?)\?>/si", 
"eval_buffer",$string); 
} 

?>