<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+


/**
* Add an item to a quiz
*
* Displays a page to select items for adding to a quiz
*
* @package Quiz
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2003 
* @version $Id: additems.php,v 1.9 2006/03/03 04:00:39 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../../local/config.inc.php');
require_once($CONFIG['LANGUAGE_CPATH'].'/quiz_strings.inc.php');
require_once('lib.inc.php');
session_start();

//set the required variables

if ($_SERVER['REQUEST_METHOD']=='GET') {

	$space_key	= $_GET['space_key'];
	$module_key	= $_GET['module_key'];
	
	if (isset($_GET['category_key'])) {
	
		$category_key = $_GET['category_key'];
	
	}
		
	$action 	= $_GET['action'];

	
} else {

	$module_key	  = $_POST['module_key'];
	$category_key = $_POST['category_key'];
	$action		  = $_POST['action'];		
							

}

$space_key 	= get_space_key();
$link_key 	= get_link_key($module_key,$space_key);

//check we have the required variables
check_variables(true,false,true);

//check to see if user is logged in. 
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups'];
$group_accesslevel = $access_levels['group_accesslevel'][$group_key];
$is_admin = check_module_edit_rights($module_key);

if ($is_admin==false) {

	$message = urlencode($general_strings['no_edit_rights'].' '.$general_strings['module_text']);
	header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key&message=$message");
	
}

$current_user_key = $_SESSION['current_user_key'];
$quiz = new InteractQuiz($space_key, $module_key, $group_key, $is_admin, $quiz_strings);

//see if we are adding a new entry

if ($action) {

	switch($action) {
	
		case 'add_items':
		
			$item_keys = $_POST['item_keys'];
			
			foreach ($item_keys as $item_key) {
			
				$CONN->Execute("INSERT INTO {$CONFIG['DB_PREFIX']}QTModuleItemLinks(ModuleKey, ItemKey) VALUES ('$module_key', '$item_key')");
			
			}

		break;
		
		case 'modify_items':
		
			$delete_link_keys = isset($_POST['delete_link_keys'])? $_POST['delete_link_keys'] : '';
			$link_keys		= isset($_POST['link_keys'])? $_POST['link_keys'] : '';
			
			if (is_array($delete_link_keys)) {
			
				$quiz->removeItems($delete_link_keys);			 
			
			}
		
			if (is_array($link_keys)) {
			
				foreach($link_keys as $value) {
				
					$sort_order = $CONN->qstr($_POST[$value.'_sort_order']);
					$score	  = $CONN->qstr($_POST[$value.'_score']);
					
					$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}QTModuleItemLinks SET SortOrder=$sort_order, Score=$score WHERE LinkKey='$value' AND ModuleKey='$module_key'");
					
			
				}
				
			}
		
		break;

	}

}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(

	'header'	 => 'Header.ihtml',
	'navigation' => 'Navigation.ihtml',
	'quiz'	   => 'quiz/AddItems.ihtml',
	'footer'	 => 'Footer.ihtml'

));

// get page details for titles and breadcrumb navigation
$page_details = get_page_details($space_key,$link_key);
set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);

//first get an items already in this module
$t->set_block('quiz', 'CurrentItemsBlock', 'CIBlock');
$rs = $CONN->Execute("SELECT {$CONFIG['DB_PREFIX']}QTItem.ItemKey, Name, SortOrder, Score, LinkKey FROM {$CONFIG['DB_PREFIX']}QTItem, {$CONFIG['DB_PREFIX']}QTModuleItemLinks WHERE {$CONFIG['DB_PREFIX']}QTItem.ItemKey={$CONFIG['DB_PREFIX']}QTModuleItemLinks.ItemKey AND {$CONFIG['DB_PREFIX']}QTModuleItemLinks.ModuleKey='$module_key' ORDER BY SortOrder");

if ($rs->EOF) {

	$t->set_var('CIBlock','');
	$t->set_var('CURRENT_ITEMS_STRING',$quiz_strings['no_current_items']);
	$t->set_block('quiz', 'ModifyButtonBlock', 'MBBlock');
	$t->set_var('MBBlock','');

} else {

	$t->set_var('MODIFY_STRING',$general_strings['modify']);
	$t->set_var('REMOVE_STRING',ucfirst($general_strings['remove']));
	$t->set_var('SCORE_STRING',$quiz_strings['score']);
	$t->set_var('SORT_ORDER_STRING',$general_strings['sort_order']);
	$t->set_var('NAME_STRING',$general_strings['name']);				
 
	while (!$rs->EOF) {
	   
		$t->set_var('ITEM_KEY',$rs->fields[0]);
		$t->set_var('ITEM_NAME',$rs->fields[1]);
		$t->set_var('SORT_ORDER',$rs->fields[2]);
		$t->set_var('SCORE',$rs->fields[3]);				   
		$t->set_var('LINK_KEY',$rs->fields[4]);
		$t->parse('CIBlock', 'CurrentItemsBlock', true);
		$rs->MoveNext();
		   
	}	

}
require_once('../../includes/lib/category.inc.php');
$category = new InteractCategory();

$category_sql  = "SELECT Name, CategoryKey, ParentKey FROM {$CONFIG['DB_PREFIX']}QTCategories WHERE (SpaceKey='$space_key' OR UserKey='{$_SESSION['current_user_key']}') ";

$category_array = $category->getCategoryArray($category_sql);

if (!class_exists('InteractHtml')) {

	require_once('../../includes/lib/html.inc.php');

}

$html = new InteractHtml();

$category_menu = $html->arrayToMenu($category_array,'category_key',$category_key, false,'',true);
$t->set_var('CATEGORY_MENU',$category_menu);

//check if category selected
$t->set_block('quiz', 'ListItemsBlock', 'LIBlock');

if (!$category_key) {

	$t->set_var('SELECT_ITEMS_MESSAGE',$quiz_strings['select_category']);
	$t->set_block('quiz', 'AddButtonBlock', 'ABBlock');
	$t->set_var('ABBlock','');	   	   		
	$t->set_block('quiz', 'EditCategoryBlock', 'ECBlock');
	$t->set_var('ECBlock','');	   	   		

} else {

	//show create new item link
   
	$t->set_var('CREATE_NEW_LINK',"<a href=\"multichoiceinput.php?space_key=$space_key&module_key=$module_key&category_key=$category_key\">".$quiz_strings['create_new_item']."</a>"); 

	//category is selected so get all items for this category
   
	$rs = $CONN->Execute("SELECT {$CONFIG['DB_PREFIX']}QTItem.ItemKey, Name FROM {$CONFIG['DB_PREFIX']}QTItem, {$CONFIG['DB_PREFIX']}QTCategoryItemLinks WHERE {$CONFIG['DB_PREFIX']}QTItem.ItemKey={$CONFIG['DB_PREFIX']}QTCategoryItemLinks.ItemKey AND {$CONFIG['DB_PREFIX']}QTCategoryItemLinks.CategoryKey='$category_key' ORDER BY Name");

	if ($rs->EOF) {
   
		$t->set_var('LIBlock','');
		$t->set_var('SELECT_ITEMS_MESSAGE',$quiz_strings['no_items']);
		$t->set_block('quiz', 'AddButtonBlock', 'ABBlock');
		$t->set_var('ABBlock','');	   	   	   
   
	} else {
   
		$t->set_var('SELECT_ITEMS_MESSAGE',$quiz_strings['current_category_items']);
		
		while (!$rs->EOF) {
	   
			$t->set_var('ITEM_KEY',$rs->fields[0]);
			$t->set_var('ITEM_NAME',$rs->fields[1]);
			$t->parse('LIBlock', 'ListItemsBlock', true);
			$rs->MoveNext();
		   
		}
	   
	}

}

$t->set_var('ADD_ITEM_HEADING', sprintf($quiz_strings['add_item_heading'], $page_details['module_name']));
$t->set_var('SELECT_STRING',$general_strings['select']);
$t->set_var('ADD_STRING',$general_strings['add']);
$t->set_var('FINISHED_STRING',$general_strings['finished']);
$t->set_var('CURRENT_ITEMS_STRING',$quiz_strings['current_items']);
$t->set_var('SELECT_ITEMS_STRING',$quiz_strings['select_items']);
$t->set_var('ADD_CATEGORY_STRING',$quiz_strings['add_category']);
$t->set_var('EDIT_CATEGORY_STRING',$quiz_strings['edit_category']);
$t->set_var('MODULE_KEY',$module_key);
$t->set_var('SPACE_KEY',$space_key);
$t->set_var('CATEGORY_KEY',$category_key);
$t->parse('CONTENTS', 'header', true); 

get_navigation();
$t->parse('CONTENTS', 'quiz', true);
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
$CONN->Close();	   
exit;	
?>
