<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+


/**
* View attempt data
*
* Displays a full attempt data for a given quiz 
*
* @package Quiz
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2003 
* @version $Id: viewattemptdata.php,v 1.7 2006/03/03 04:00:39 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../../local/config.inc.php');
require_once($CONFIG['LANGUAGE_CPATH'].'/quiz_strings.inc.php');
require_once('lib.inc.php');
session_start();

//set the required variables


$module_key	= $_GET['module_key'];
$group_key	= $_GET['group_key'];
$view_type	= $_GET['view_type'];

if(!$view_type || $view_type=='by_user') {

	$view_type = 'by_user';
	$new_view_type = 'by_item';
	$view_text = 'View by Question';

} else {

	$new_view_type = 'by_user';
	$view_text = 'View by User';

}

$userlevel_key = $_SESSION['userlevel_key'];

$space_key 	= get_space_key();
$link_key 	= get_link_key($module_key,$space_key);

//check we have the required variables
check_variables(true,false,true);

//check to see if user is logged in. 
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups'];
$group_accesslevel = $access_levels['group_accesslevel'][$group_key];
$is_admin = check_module_edit_rights($module_key);
if ($is_admin==false) {

	$message = urlencode($general_strings['no_edit_rights'].' '.$general_strings['module_text']);
	header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key&message=$message");
	

}
$quiz = new InteractQuiz($space_key, $module_key, $group_key, $is_admin, $quiz_strings);
echo '<html><head><title>Quiz Attempt Data</title></head><body>';
echo '<p align="center"><a href="javascript:close();">Close Window</a></p>';
echo '<p align="center"><a href="viewattemptdata.php?space_key='.$space_key.'&module_key='.$module_key.'&view_type='.$new_view_type.'">'.$view_text.'</a></p>';

if ($view_type=='by_user') {

	echo '<table border="1" cellpadding="5"><tr><th>'.$general_strings['name'].'</th><th>'.$quiz_strings['question'].'</th><th>'.$quiz_strings['response'].'</th><th>'.$quiz_strings['correct'].'</th></tr>';
	$attempt_key='';
	$name = '';
	$rs = $CONN->Execute("SELECT DISTINCT {$CONFIG['DB_PREFIX']}Users.FirstName, {$CONFIG['DB_PREFIX']}Users.LastName , {$CONFIG['DB_PREFIX']}QTAttemptsData.ResponseIdent,{$CONFIG['DB_PREFIX']}QTAttemptsData.Correct, {$CONFIG['DB_PREFIX']}QTAttemptsData.AttemptKey, {$CONFIG['DB_PREFIX']}QTAttemptsData.ItemKey FROM {$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}QTAttempts, {$CONFIG['DB_PREFIX']}QTAttemptsData WHERE {$CONFIG['DB_PREFIX']}Users.UserKey={$CONFIG['DB_PREFIX']}QTAttempts.UserKey AND {$CONFIG['DB_PREFIX']}QTAttempts.AttemptKey={$CONFIG['DB_PREFIX']}QTAttemptsData.AttemptKey AND  {$CONFIG['DB_PREFIX']}QTAttempts.ModuleKey='$module_key' ORDER BY {$CONFIG['DB_PREFIX']}QTAttemptsData.AttemptKey, {$CONFIG['DB_PREFIX']}QTAttemptsData.ItemKey");

	while (!$rs->EOF) {

	
		if ($attempt_key!=$rs->fields[4]) {
		
			$attempt_key=$rs->fields[4];
			echo '<tr><td colspan="4" height="10">&nbsp;</td></tr>';
		
		} 
	
		$full_name = $rs->fields[0].' '.$rs->fields[1];
		
		$item_data = $quiz->getItemData($rs->fields[5]);


		if ($rs->fields[2] == '') {
	
			$responses = 'no response';
		 
		} else {
	
		
			if ($item_data['rcardinality'] == 'Multiple'){
	
				$responses = '';
				$response_ident = explode(',',$rs->fields[2]);
			
				foreach($response_ident as $ident) {
			
					$responses .= $quiz->getResponseText($ident).'<br />';
	
				}
					
			} else {
	
				$ident = $rs->fields[2];
				$responses = $quiz->getResponseText($ident);
	
			}
		 
		}
		
		$correct = $rs->fields[3]=='0'? 'no': 'yes';

		echo '<tr><td valign=\"top\">'.$full_name.'</td><td valign=\"top\">'.$item_data['question'].'</td><td valign=\"top\">'.$responses.'</td><td valign=\"top\">'.$correct.'</td></tr>';
	
		
		$rs->MoveNext();
	
	}
	
	echo '</table>';

} else {

	echo '<table border="1" cellpadding="5"><tr><th>'.$quiz_strings['question'].'</th><th>'.$quiz_strings['response'].'</th></tr>';
	$attempt_key='';
	$name = '';
	$rs = $CONN->Execute("SELECT DISTINCT {$CONFIG['DB_PREFIX']}QTItem.ItemKey, Mattext  FROM {$CONFIG['DB_PREFIX']}QTItem,{$CONFIG['DB_PREFIX']}QTModuleItemLinks WHERE {$CONFIG['DB_PREFIX']}QTItem.ItemKey={$CONFIG['DB_PREFIX']}QTModuleItemLinks.ItemKey AND	{$CONFIG['DB_PREFIX']}QTModuleItemLinks.ModuleKey='$module_key' ORDER BY {$CONFIG['DB_PREFIX']}QTModuleItemLinks.SortOrder");
echo $CONN->ErrorMsg();
	while (!$rs->EOF) {
	
		$item_key = $rs->fields[0];
		$question = $rs->fields[1];
		$correct_count = $quiz->countResponses($item_key, $module_key, 'correct');
		$wrong_count   = $quiz->countResponses($item_key, $module_key, 'wrong');
		
		echo '<tr><td valign="top">'.$question.'</td><td valign="top">'.$quiz_strings['correct'].': '.$correct_count.'<br />'.$quiz_strings['not_correct'].': '.$wrong_count.'</td></tr>';
	
		$rs->MoveNext();
	}
	
	echo '</table>';

}

$CONN->Close();	   
exit;	
?>
