<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Search
*
* Provides a search function across all spaces
* 
*
* @package Common
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: search.php,v 1.24.2.1 2006/05/22 04:28:57 glendavies Exp $
* 
*/

/**
* Include main config file 
*/
require_once('local/config.inc.php');

session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');

$search_terms = $_GET['search_terms'];
$rule		 = $_GET['rule'];
$current_user_key = $_SESSION['current_user_key'];

//check to see if user is logged in. If not refer to Login page.
authenticate_home();

if (!is_object($objDates)) {

	if (!class_exists('InteractDate')) {

		require_once('includes/lib/date.inc.php');
	
	}

	$objDates = new InteractDate();

}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  

$t->set_file(array(
	'header' => 'Header.ihtml',
	'navigation'	  => 'Navigation.ihtml',
	'body'   => 'Search.ihtml',
	'footer' => 'Footer.ihtml'
));


$page_details = get_page_details($space_key,'');
set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);
$t->set_var('PAGE_TITLE','Search');

$t->set_var('BREADCRUMBS','');
$t->set_block('navigation', 'ModuleHeadingBlock', 'ModuleHeadBlock');

$t->set_var('SEARCH_HEADING', sprintf($space_strings['search_heading2'], $general_strings['space_text']));
$t->set_var('YOUR_LINKS_STRING', sprintf($general_strings['your_links'], $general_strings['space_plural']));
$t->set_var('SPACE_STRING', $general_strings['space_plural']);

$t->set_var('SEARCH_STRING', $general_strings['search']);
$t->set_var('ALL_WORDS_STRING', $general_strings['all_words']);
$t->set_var('ANY_WORDS_STRING', $general_strings['any_words']);
$t->set_var('EXACT_PHRASE_STRING', $general_strings['exact_phrase']);
$t->set_var('SITE_CONTENT_STRING', $general_strings['site_content']);
$t->set_var('FORUM_POSTINGS_STRING', $general_strings['forum_postings']);

$t->parse('CONTENTS', 'header', true);  
get_navigation();

if (!$search_terms) {

	$t->set_block('body', 'ResultsBlock', 'RBlock');
	$t->set_var('RBlock', '');

} else {

	if ($search_terms!='') {

		//find out what groups user is a member of

		$groups_sql='(';
		$n=1;
		$sql = "select GroupKey from {$CONFIG['DB_PREFIX']}GroupUserLinks where UserKey='$current_user_key'";
		$rs = $CONN->Execute($sql);

		if ($rs->EOF) {

			$groups_sql.='-1)';

		} else {
			
			$record_count=$rs->RecordCount();

			while (!$rs->EOF) {

				$current_row=$rs->CurrentRow();
				$group_key = $rs->fields[0];
				$group_access[$n]=$group_key;

				if(++$current_row==$record_count) {

					$groups_sql.="$group_key ";

				} else {

					$groups_sql.="$group_key, ";

				}

				$n++;
				$rs->MoveNext();

			}
			
			$rs->Close();

			$groups_sql.=')';

		}
 
		$space_search_string = create_space_search_string($search_terms, $rule);

		$sql = "SELECT DISTINCT {$CONFIG['DB_PREFIX']}Spaces.SpaceKey,Name FROM {$CONFIG['DB_PREFIX']}Spaces, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE {$CONFIG['DB_PREFIX']}Spaces.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='1' AND  {$CONFIG['DB_PREFIX']}Spaces.TypeKey!='1' AND ($space_search_string) ORDER BY {$CONFIG['DB_PREFIX']}Spaces.Name";  
		$rs = $CONN->Execute($sql);
		echo $CONN->ErrorMsg();
		if ($rs->EOF) {

			$t->set_block('body', 'SpaceBlock', 'SBlock');
			$t->set_var('SBlock', sprintf($space_strings['space_search_fail'],$general_strings['space_text'],$search_terms));

		} else {

			$t->set_block('body', 'SpaceBlock', 'SBlock');
			$t->set_var('MESSAGE',sprintf($space_strings['search_results'],$search_terms));
			$number=1;

			while (!$rs->EOF) {

				$space_key = $rs->fields[0];
			 	$space_name=$rs->fields[1];
			   								
				$t->set_var('SPACE_KEY',$space_key);
				$t->set_var('SPACE_NAME',$space_name);
		 		$t->set_var('NUMBER',$number);
				$t->Parse('SBlock', 'SpaceBlock', true);
				$number++;
				$rs->MoveNext();

				}
				
			$rs->Close();

			}
			
		$content_search_string = create_content_search_string($search_terms, $rule);
		$sql = "SELECT DISTINCT {$CONFIG['DB_PREFIX']}Modules.ModuleKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey,{$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleTypes.Code, {$CONFIG['DB_PREFIX']}Modules.Description,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleTypes,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks,{$CONFIG['DB_PREFIX']}Spaces,{$CONFIG['DB_PREFIX']}SpaceUserLinks WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey AND {$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey={$CONFIG['DB_PREFIX']}Spaces.SpaceKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND   {$CONFIG['DB_PREFIX']}Spaces.TypeKey!='1' AND ({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey='$current_user_key' OR {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey='1' OR {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey='3') AND ({$CONFIG['DB_PREFIX']}Modules.StatusKey='1' OR {$CONFIG['DB_PREFIX']}Modules.StatusKey='3') AND (GroupKey='0' OR GroupKey in $groups_sql) AND ($content_search_string)  AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='2') ORDER BY {$CONFIG['DB_PREFIX']}Modules.Name";

		$rs = $CONN->Execute($sql);
		echo $CONN->ErrorMsg();
		
		if ($rs->EOF) {
			$t->set_block('body', 'ContentBlock', 'CBlock');
			$t->set_var('CBlock', sprintf($space_strings['content_search_fail'],$search_terms));
		
		} else {
		
			$t->set_block('body', 'ContentBlock', 'CBlock');
			$t->set_var(MESSAGE,sprintf($space_strings['search_results'],$search_terms));
			$number=1;
	
			while (!$rs->EOF) {

				$module_key = $rs->fields[0];
				$group_key = $rs->fields[1];
				$name = $rs->fields[2];
				$url = $rs->fields[3];
				
				if ($rs->fields[4]=='') {
				
					$description = $rs->fields[4];
				
				} else {
			
					$description = ' - '.$rs->fields[4];
		
				}
				
				$space_key = $rs->fields[5];
				$link_key = $rs->fields[6];								
				$t->set_var('GROUP_KEY',$group_key);
				$t->set_var('MODULE_KEY',$module_key);
				$t->set_var('LINK_KEY',$link_key);				
				$t->set_var('MODULE_NAME',$name);
				$t->set_var('CODE',$url);
				$t->set_var('PATH',$CONFIG['PATH']);
				$t->set_var('SPACE_KEY',$space_key);				
				$t->set_var('DESCRIPTION',$description);
				$t->set_var('NUMBER',$number);
				$t->Parse('CBlock', 'ContentBlock', true);
				$number++;
				$rs->MoveNext();
				
				}
				
			$rs->Close();	
				
			}

		//now search Forum postings

		$forum_search_string = create_forum_search_string($search_terms, $rule);
		$sql = "SELECT DISTINCT {$CONFIG['DB_PREFIX']}posts.module_key,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey,{$CONFIG['DB_PREFIX']}posts.post_key,{$CONFIG['DB_PREFIX']}posts.thread_key,{$CONFIG['DB_PREFIX']}posts.subject,FirstName,LastName,{$CONFIG['DB_PREFIX']}posts.date_added,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey FROM {$CONFIG['DB_PREFIX']}ModuleSpaceLinks, {$CONFIG['DB_PREFIX']}posts,{$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}Spaces,{$CONFIG['DB_PREFIX']}SpaceUserLinks, {$CONFIG['DB_PREFIX']}Modules WHERE {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey={$CONFIG['DB_PREFIX']}posts.module_key AND {$CONFIG['DB_PREFIX']}posts.added_by_key={$CONFIG['DB_PREFIX']}Users.UserKey AND  {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey AND {$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey={$CONFIG['DB_PREFIX']}Spaces.SpaceKey AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey={$CONFIG['DB_PREFIX']}Modules.ModuleKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey='3' AND ({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey='$current_user_key' OR {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey='1' OR {$CONFIG['DB_PREFIX']}Spaces.AccessLevelKey='3') AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey='0' OR {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.GroupKey in $groups_sql) AND ($forum_search_string) AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='2') ORDER BY {$CONFIG['DB_PREFIX']}posts.subject";

		$rs = $CONN->Execute($sql);
		echo $CONN->ErrorMsg();

		if ($rs->EOF) {

			$t->set_block('body', 'ForumBlock', 'FBlock');
			$t->set_var('FBlock', sprintf($space_strings['forum_search_fail'],$search_terms));

		} else {

			$t->set_block('body', 'ForumBlock', 'FBlock');
			$t->set_var('MESSAGE',sprintf($space_strings['search_results'],$search_terms));
			$number=1;
	
			while (!$rs->EOF) {

				$module_key = $rs->fields[0];
				$group_key = $rs->fields[1];
				$post_key = $rs->fields[2];
				$thread_key = $rs->fields[3];				
				$subject = $rs->fields[4];
				$added_by = $rs->fields[5].' '.$rs->fields[6];
				$date_added = $objDates->formatDate($CONN->UnixTimeStamp($rs->fields[7]),'short');
				$space_key = $rs->fields[8];
												
				$t->set_var('GROUP_KEY',$group_key);
				$t->set_var('MODULE_KEY',$module_key);
				$t->set_var('POST_KEY',$post_key);
				$t->set_var('THREAD_KEY',$thread_key);
				$t->set_var('SPACE_KEY',$space_key);				
				$t->set_var('PATH',$CONFIG['PATH']);
				$t->set_var('SUBJECT',$subject);
				$t->set_var('NUMBER',$number);
				$t->set_var('ADDED_BY',$added_by);
				$t->set_var('DATE_ADDED',$date_added);				
				$t->Parse('FBlock', 'ForumBlock', true);
				$number++;
				$rs->MoveNext();
				
			}
			
			$rs->Close();
		
		}

	} else {

		$t->set_block('body', 'ResultsBlock', 'RBlock');
		$t->set_var('RBlock', '');
		$t->set_var('MESSAGE', $space_strings['no_search_terms']);

	}

}

$t->parse('CONTENTS', 'body', true);
$t->parse('CONTENTS', 'footer', true);

$t->p('CONTENTS');
$CONN->Close();
exit;

function create_content_search_string($search_terms, $rule) { 
	 

	global $CONFIG;
	// Split up $keywords by the delimiter (" ") 

	$arg = split(' ', $search_terms); 

	if ($rule == 'all') { 

		$joiner = 'AND'; 

	} elseif ($rule == 'any') { 

		$joiner = 'OR';  

	} 
	
	if ($rule != 'exact') { 
	
		for($i=0; $i<count($arg); $i++) { 

			if ($i==0) {

				$cond = "(({$CONFIG['DB_PREFIX']}Modules.Name LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}Modules.Description LIKE '%$arg[$i]%'))"; 

			} else {

				$cond = "$cond $joiner (({$CONFIG['DB_PREFIX']}Modules.Name LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}Modules.Description LIKE '%$arg[$i]%'))"; 

			}	   
						
		} 

	} else {
 
			$cond = "(({$CONFIG['DB_PREFIX']}Modules.Name LIKE '%$search_terms%') OR ". 
					"({$CONFIG['DB_PREFIX']}Modules.Description LIKE '$search_terms%'))"; 

	} 

	return $cond;

} // end function create_content_search_string

function create_space_search_string($search_terms, $rule) { 
	 
	global $CONFIG;
	
	// Split up $keywords by the delimiter (" ") 
	$arg = split(' ', $search_terms); 
	if ($rule == 'all') { 
	
		$joiner = 'AND'; 
	
	} elseif ($rule == 'any') { 
		
		$joiner = 'OR';  

	}
	 
	if ($rule != 'exact') {
	 
		for($i=0; $i<count($arg); $i++) { 
	
			if ($i==0) {
	
				$cond = "(({$CONFIG['DB_PREFIX']}Spaces.Name LIKE '%$arg[$i]%' OR {$CONFIG['DB_PREFIX']}Spaces.Code LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}Spaces.Description LIKE '%$arg[$i]%'))"; 
	
			} else {
	
				$cond = "$cond $joiner (({$CONFIG['DB_PREFIX']}Spaces.Name LIKE '%$arg[$i]%' OR {$CONFIG['DB_PREFIX']}Spaces.Code LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}Spaces.Description LIKE '%$arg[$i]%'))"; 
	
			}	   
						
	
		} 
	
	} else {
 
			$cond = "(({$CONFIG['DB_PREFIX']}Spaces.Name LIKE '%$search_terms%' OR {$CONFIG['DB_PREFIX']}Spaces.Code LIKE '%$arg[$i]%') OR ". 
					"({$CONFIG['DB_PREFIX']}Spaces.Description LIKE '$search_terms%'))"; 
	
	} 

	return $cond;

} // end function create_space_search_string

function create_forum_search_string($search_terms, $rule) { 
	 
	global $CONFIG;
	// Split up $keywords by the delimiter (" ") 

	$arg = split(' ', $search_terms); 
	if ($rule == 'all') { 

		$joiner = 'AND'; 

	} elseif ($rule == 'any') { 
		
		$joiner = 'OR';  
	
	} 
	
	if ($rule != 'exact') { 
	
		for($i=0; $i<count($arg); $i++) { 

			if ($i==0) {

				$cond = "(({$CONFIG['DB_PREFIX']}posts.subject LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}posts.body LIKE '%$arg[$i]%'))"; 

			} else {

				$cond = "$cond $joiner (({$CONFIG['DB_PREFIX']}posts.subject LIKE '%$arg[$i]%') OR ". 
						"({$CONFIG['DB_PREFIX']}posts.body LIKE '%$arg[$i]%'))"; 

			}	   
						
		} 

	} else {
 
			$cond = "(({$CONFIG['DB_PREFIX']}posts.subject LIKE '%$search_terms%') OR ". 
					"({$CONFIG['DB_PREFIX']}posts.body LIKE '$search_terms%'))"; 

	} 

	return $cond;

} // end function create_forum_search_string
?>