<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Space admin homepage
*
* Displays the space admin homepage with links to space administration 
* functions
*
* @package SpaceAdmin
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: admin.php,v 1.24 2006/03/16 22:40:54 glendavies Exp $
* 
*/

/**
* Include main system config file 
*/

require_once('../local/config.inc.php');
session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');

if ($_SERVER['REQUEST_METHOD']=='GET') {

	$space_key = $_GET['space_key'];
	
} else {

	$space_key   = $_POST['space_key'];
	$email_who   = $_POST['email_who'];
	$subject	 = $_POST['subject'];
	$body		= $_POST['body'];
	$copyself	= $_POST['copyself'];
	$member_keys = $_POST['member_keys'];	
	$carbon_copy = $_POST['carbon_copy'];
	$file		= $_FILES['file'];					
	$action	  = $_POST['action'];	
	
}
$current_user_key = $_SESSION['current_user_key'];
//check we have the required variables
check_variables(true,false);




//check to see if user is logged in. If not refer to Login page.
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
authenticate_admins($level='space_only');
$group_access = $access_levels['groups'];	 
$page_details=get_page_details($space_key);

if ($action=='email') {

	$errors = check_form_input();

	if(count($errors) == 0) {

		require_once('../includes/email.inc.php');

		 if (!$member_keys && $email_who=='all' ) {

			$sql = "SELECT {$CONFIG['DB_PREFIX']}Users.UserKey FROM {$CONFIG['DB_PREFIX']}Users, {$CONFIG['DB_PREFIX']}SpaceUserLinks WHERE {$CONFIG['DB_PREFIX']}Users.UserKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey AND (SpaceKey='$space_key' AND {$CONFIG['DB_PREFIX']}Users.UserKey!='$current_user_key')";
			$member_keys = get_userkey_array($sql);
			
		} else if ($member_keys && $email_who=='selected' ) {
		
			$member_keys = $_POST['member_keys'];
			
		}
		
		if (isset($page_details['space_short_name']) && $page_details['space_short_name']!='') {
		
			$subject = '['.$page_details['space_short_name'].'] - '.$subject;
			
		} else {
		
			$subject = '['.$page_details['space_name'].'] - '.$subject;
		
		}
		
		email_users($subject, $body, $member_keys, $copyself, $file, $carbon_copy);
		
		if ($_POST['save_as_news']==1) {
		
			$date_added=$CONN->DBDate(date('Y-m-d H:i:s'));
			$heading_esc = $CONN->qstr($_POST['subject']); 
			$body_esc = $CONN->qstr(nl2br($_POST['body'])); 
			$CONN->Execute("INSERT into {$CONFIG['DB_PREFIX']}News VALUES ('','$space_key',$heading_esc,$body_esc,$date_added,'','$current_user_key')");
			echo $CONN->ErrorMsg();
		
		
		}
		
		$message = urlencode($general_strings['email_sent']);
		header ("Location: {$CONFIG['FULL_URL']}/spaceadmin/admin.php?space_key=$space_key&message=$message");
		exit;
	
	}

} else if ($action=='select_skin') {
	
	$skin_key = $_POST['skin_key'];
	$CONN->Execute("UPDATE {$CONFIG['DB_PREFIX']}Spaces SET SkinKey='$skin_key' WHERE SpaceKey='$space_key'");
	header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key");
	exit;
}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(
	'header'		   => 'Header.ihtml',
	'navigation'	   => 'Navigation.ihtml',
	'body'			 => 'spaceadmin/Home.ihtml',
	'footer'		   => 'Footer.ihtml'
));

set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);

//get spaces module_key and link key

$rs = $CONN->Execute("SELECT {$CONFIG['DB_PREFIX']}Spaces.ModuleKey, LinkKey, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces LEFT JOIN {$CONFIG['DB_PREFIX']}ModuleSpaceLinks ON {$CONFIG['DB_PREFIX']}Spaces.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey WHERE {$CONFIG['DB_PREFIX']}Spaces.SpaceKey='$space_key'");

while (!$rs->EOF) {

	
	$t->set_var('MODULE_KEY',$rs->fields[0]);
	$t->set_var('LINK_KEY',$rs->fields[1]);
	$t->set_var('PARENT_SPACE_KEY',$rs->fields[2]);
	$rs->MoveNext();
	
}

$rs->MoveNext();


if ($page_details['type_key']==1) {

	$t->set_block('body', 'FullOptionsBlock', 'FullOptsBlock');
	$t->set_var('FullOptsBlock','');
	$t->set_var('ADMIN_HEADER',$space_strings['portfolio_admin']);
	if (!isset($objSkins)) {
		if (!class_exists('InteractSkins')) {
			require_once('lib.inc.php');
		}
		$objSkins = new InteractSkins();
	}
	//create list of alt stylesheets
	$skins_array = $objSkins->getSkinArray('view');
	if ($skins_array==false) {
		$t->set_block('form', 'ModifyFormBlock', 'MFBlock');
		$t->set_var('MFBlock','');
	} else {
		$alt_style_sheets='';
		foreach($skins_array as $key => $value) {
			$skin_data = $objSkins->getSkinData($key);
			$alt_style_sheets.='<link rel="alternate stylesheet" type="text/css" href="'.$CONFIG['PATH'].'/skins/skin.php?skin_key='.$key.'" title="'.$key.'" />';
		}
		$t->set_var('META_TAGS',$alt_style_sheets);
		$t->set_var('SKINS_MENU',$objHtml->arrayToMenu($skins_array,'skin_key',$page_details['skin_key'],false,'',false,'onChange="setActiveStyleSheet(this.value)"'));
	}	
	$t->set_var('SKIN_STRING',$general_strings['skin']);
	$t->set_var('SELECT_STRING',$general_strings['select']);
	$t->set_var('MODIFY_SKINS_STRING',$space_strings['modify_skins']);
} else {
	$t->set_block('body', 'LimitedOptionsBlock', 'LimitedOptsBlock');
	$t->set_var('LimitedOptsBlock','');
	$concat = $CONN->Concat('Lastname', '\', \'','FirstName');
	$members_sql="SELECT $concat,{$CONFIG['DB_PREFIX']}Users.UserKey FROM {$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}SpaceUserLinks WHERE {$CONFIG['DB_PREFIX']}Users.UserKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey and {$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey='$space_key' ORDER BY LastName";

	$members_menu = make_menu($members_sql,'member_keys[]','','8','true');
	$subject_error = sprint_error($errors['subject']);
	$body_error = sprint_error($errors['body']);
	$file_error = sprint_error($errors['file']);
	$email_who_error = sprint_error($errors['email_who']);
	$t->set_var('SPACE_KEY',$space_key);
	$t->set_var('SUBJECT_ERROR',$subject_error);
	$t->set_var('BODY_ERROR',$body_error);
	$t->set_var('FILE_ERROR',$file_error);
	$t->set_var('EMAIL_WHO_ERROR',$email_who_error);
	$t->set_var('SUBJECT',$subject);
	$t->set_var('BODY',$body);
	$t->set_var('MEMBERS_MENU',$members_menu);

	//if site admins allowed to create accounts show account 
	//creation link

	if ($CONFIG['DEVOLVE_ACCOUNT_CREATION']==1) {

		$t->set_var('ACCOUNT_CREATION',"<a href=\"userinput.php?space_key=$space_key\">".$space_strings['account_creation'].'</a>');

	}
	$t->set_var('ADMIN_HEADER',$space_strings['admin_header']);
	$t->set_var('SHOW_ALL_URLS_STRING',$space_strings['show_all_urls']);
	$t->set_var('PREFERENCES_STRING',$space_strings['preferences']);
	$t->set_var('CHECK_STRING',$general_strings['check']);
	$t->set_var('ACCESS_CODE_STRING',$space_strings['access_code']);
	$t->set_var('STATISTICS_STRING',$space_strings['statistics']);
	$t->set_var('REMOVE_MEMBERS_STRING',$space_strings['remove_members']);
	$t->set_var('TRASH_STRING',$space_strings['trash']);
	$t->set_var('EDIT_HEADER_STRING',$space_strings['edit_header']);
	$t->set_var('MEMBERS_STRING',$space_strings['members']);
	$t->set_var('EMAIL_MEMBERS_STRING',$general_strings['email_members']);
	$t->set_var('SUBJECT_STRING',$general_strings['subject']);
	$t->set_var('MESSAGE_STRING',$general_strings['message']);
	$t->set_var('CC_STRING',$general_strings['carboncopy']);
	$t->set_var('CC_INSTRUCTIONS',$general_strings['cc_instructions']);
	$t->set_var('ATTACHMENT_STRING',$general_strings['attachment']);
	$t->set_var('COPY_SELF_STRING',$general_strings['copy_self']);
	$t->set_var('INSTRUCTIONS_STRING',$general_strings['email_instructions']);
	$t->set_var('GROUP_MEMBERS_STRING',$group_strings['group_members']);
	$t->set_var('ALL_MEMBERS_STRING',$general_strings['email_all']);
	$t->set_var('SELECTED_MEMBERS_STRING',$general_strings['email_selected']);
	$t->set_var('SEND_STRING',$general_strings['send']);
	$t->set_var('REMOVE_NEWS_STRING',$space_strings['remove_news']);


	if ($_SESSION['userlevel_key']==1) {

		$t->set_var('ADD_SUBSPACE_STRING',sprintf($space_strings['add_subspace'], $general_strings['space_text']));
	
	}
}
$t->parse('CONTENTS', 'header', true);
get_navigation();
$t->parse('CONTENTS', 'body', true);
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
$CONN->Close();
exit;



function check_form_input() 
{

	global $general_strings ; 


	// Initialize the errors array

	$errors = array();

	//check to see if we have all the information we need
	
	if(!$_POST['email_who']) {

		$errors['email_who'] = $general_strings['email_who_error'];

	}
	
	if($_POST['email_who']=='selected' && !$_POST['member_keys']) {

		$errors['email_who'] = $general_strings['email_who_error2'];

	}
	
	if(!$_POST['subject']) {

		$errors['subject'] = $general_strings['no_subject'];
	

	}


	if(!$_POST['body']) {

		$errors['body'] = $general_strings['no_message'];

	}
	
	if( $_FILES['file']['size'] > 200000) {

		$errors['file'] = $general_strings['attachment_to_big'];

	}

	return $errors;

} //end check_form_input
?>