<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Display statistics as a spreadsheet
*
* Displays access statistics for a space as an excel spreadsheet
*
* @package SpaceAdmin
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: excelstats.php,v 1.13 2005/09/22 23:08:19 glendavies Exp $
* 
*/

/**
* Include main system config file 
*/

require_once('../local/config.inc.php');
session_start();

$space_key  = $_GET['space_key'];
$module_key = $_GET['module_key'];

//check we have the required variables
check_variables(true,false);


//check to see if user is logged in. If not refer to Login page.
$access_levels = authenticate();
$accesslevel_key = $access_levels["accesslevel_key"];
authenticate_admins($level="space_only");

if (!class_exists('InteractDate')) {

	require_once('../includes/lib/date.inc.php');

}
$dates = new InteractDate();

header("Content-Type: application/vnd.ms-excel");



echo "Name	Component	Date Accesses	Use Type	Location\n";



$sql = "SELECT FirstName, LastName, {$CONFIG['DB_PREFIX']}Modules.Name,{$CONFIG['DB_PREFIX']}Statistics.DateAccessed,UseType, Location,{$CONFIG['DB_PREFIX']}ModuleTypes.Name FROM {$CONFIG['DB_PREFIX']}Statistics,{$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}Modules,{$CONFIG['DB_PREFIX']}ModuleTypes WHERE {$CONFIG['DB_PREFIX']}Statistics.ModuleKey={$CONFIG['DB_PREFIX']}Modules.ModuleKey AND {$CONFIG['DB_PREFIX']}Statistics.UserKey={$CONFIG['DB_PREFIX']}Users.UserKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND ({$CONFIG['DB_PREFIX']}Statistics.SpaceKey='$space_key') ORDER BY DateAccessed DESC";
	$rs=$CONN->Execute($sql);
	if ($rs->EOF) {
		?>
		There are no statistics yet for this space
		
		<?php

	} else {
		while (!$rs->EOF) {
			$user_name = $rs->fields[0].' '.$rs->fields[1];
			$module_name = $rs->fields[2];
			$date_accessed = $dates->formatDate($CONN->UnixTimeStamp($rs->fields[3]),'short', true);
			$use_type =  $rs->fields[4];
			$location = $rs->fields[5];
			$module_type = $rs->fields[6];
			 
			 
			echo "$user_name	$module_name ($module_type.)	$date_accessed	$use_type	$location\n";
			
			$rs->MoveNext();
			 
			}

			
   }
		
		
  
?>