<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Show all module urls
*
* Displays a list of all module urls for site 
*
* @package SpaceAdmin
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: showallurls.php,v 1.5 2006/02/12 22:38:44 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../local/config.inc.php');
session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');

$space_key = $_GET['space_key'];
	

//check we have the required variables
check_variables(true,false);

//check to see if user is logged in. If not refer to Login page.
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
authenticate_admins($level='space_only');
$group_access = $access_levels['groups'];	 


require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(
	'header'		  => 'Header.ihtml',
	'navigation'	  => 'Navigation.ihtml',
	'form'			=> 'spaceadmin/ShowAllUrls.ihtml',
	'footer'		  => 'Footer.ihtml'
));

//format any errors from form submission

$access_code_error = sprint_error($errors['access_code']);
$page_details=get_page_details($space_key);
set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);
$t->parse('CONTENTS', 'header', true);
get_navigation();
$t->set_var('HEADING_STRING',$space_strings['show_urls_heading']);
//now get all the module urls for this space.
$sql = "select {$CONFIG['DB_PREFIX']}Modules.ModuleKey,{$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleTypes.Code FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks WHERE {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey='$space_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey!='4') ORDER BY {$CONFIG['DB_PREFIX']}Modules.Name";

$rs = $CONN->Execute($sql);
echo $CONN->ErrorMsg();
while (!$rs->EOF) {

	$module_key = $rs->fields[0];
	$name	   = $rs->fields[1];
	$code	   = $rs->fields[2];
	$all_urls  .= '<tr><td>'.$name.'</td><td>'.$CONFIG['PATH'].'/modules/'.$code.'/'.$code.'.php?module_key='.$module_key.'</td></tr>';
	$rs->MoveNext();
	
}
$t->set_var('ALL_URLS',$all_urls);
$t->set_var('SPACE_KEY',$space_key);

$t->parse('CONTENTS', 'form', true);
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
$CONN->Close();
exit;

?>