<?php
// +----------------------------------------------------------------------+
// | This file is part of Interact.									   |
// |																	  | 
// | This program is free software; you can redistribute it and/or modify |
// | it under the terms of the GNU General Public License as published by |
// | the Free Software Foundation (version 2)							 |
// |																	  | 
// | This program is distributed in the hope that it will be useful, but  |
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 |
// | General Public License for more details.							 |
// |																	  | 
// | You should have received a copy of the GNU General Public License	|
// | along with this program; if not, you can view it at				  |
// | http://www.opensource.org/licenses/gpl-license.php				   |
// |																	  |
// |																	  |
// | access.php - allows users to enter access code to gain access to	 |
// | restricted spaces													|
// +----------------------------------------------------------------------+
/**
* Space Access Code Page
*
* If space is restricted and user is not a member, then this page
* requests an access code. If access code correct then UserKey is
* entered in the SpaceUserLinks table and user is forwarded to the space
*
* @package Spaces
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: access.php,v 1.12 2006/03/03 04:00:31 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../local/config.inc.php');
session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');

if ($_SERVER['REQUEST_METHOD']=='GET') {
	
	$space_key  = $_GET['space_key'];

	
} else {
	
	$space_key   = $_POST['space_key'];
	$action		 = $_POST['action'];
	$access_code = $_POST['access_code'];
	
}
$current_user_key = $_SESSION['current_user_key'];

//check we have the required variables

check_variables(true,false);

if ($action=='add') {

	$sql = "SELECT AccessCode,NewUserAlert FROM {$CONFIG['DB_PREFIX']}Spaces WHERE SpaceKey='$space_key'";
	$rs = $CONN->Execute($sql);
	
	while (!$rs->EOF) {
	
		$true_access_code=$rs->fields[0];
		$new_user_alert=$rs->fields[1];
		$rs->MoveNext();
	}
	
	$rs->Close();
	
	if (strtoupper($true_access_code)!=strtoupper($access_code)) {
	
		$message = $space_strings['access_code_fail'];
		
	} else {
	
		$date_added = $CONN->DBDate(date('Y-m-d H:i:s'));
		$sql = "INSERT INTO {$CONFIG['DB_PREFIX']}SpaceUserLinks(SpaceKey,UserKey, AccessLevelKey, DateAdded) VALUES ('$space_key','$current_user_key','2', $date_added)";
		$CONN->Execute($sql);
		echo $CONN->ErrorMsg();
		//if new user alert true get course lecturers and notify them that a new student has accessed site

		if ($new_user_alert=='true') {
			
			$sql = "SELECT FirstName, LastName, Details FROM {$CONFIG['DB_PREFIX']}Users WHERE UserKey='$current_user_key'";
			$rs = $CONN->Execute($sql);
			
			while (!$rs->EOF) {
				
				$name = $rs->fields[0].' '.$rs->fields[1];
				$details = ereg_replace( 10, "\n", $rs->fields[2]);
				$rs->MoveNext();
				
			}
			
			$rs->Close();
	   
			$member_keys = array();
			$n = 0;
			
			$sql = "SELECT {$CONFIG['DB_PREFIX']}Users.UserKey,{$CONFIG['DB_PREFIX']}Spaces.Name FROM {$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}SpaceUserLinks,{$CONFIG['DB_PREFIX']}Spaces WHERE {$CONFIG['DB_PREFIX']}Users.UserKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey AND {$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey AND ({$CONFIG['DB_PREFIX']}SpaceUserLinks.AccessLevelKey='1' AND {$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey='$space_key')";

			$rs = $CONN->Execute($sql);
			
			while (!$rs->EOF) {
			
				$member_keys[$n] = $rs->fields[0];
				$space_name = $rs->fields[1];
				$n++;
				$rs->MoveNext();
				
			}
			
			$mailbody = sprintf($space_strings['new_user_alert'], $name, $space_name, $general_strings['space_text']);
			$mailbody .= "\n\n";
			$mailbody .= sprintf($space_strings['details'], $name);
				
			if ($details!='') {
					
				$mailbody = $mailbody."\n$details";
				
			} else {
			   
				$mailbody = $mailbody."\n".$space_strings['no_details'];
				
			}
			
			require_once('../includes/email.inc.php');
			$subject = sprintf($space_strings['new_member'], $space_name);
			email_users($subject, $mailbody, $member_keys, '', '', '');
			
			 
		}
		
		$rs->Close();
		$CONN->Close();
		header("Location: {$CONFIG['FULL_URL']}/spaces/space.php?space_key=$space_key");
		exit;
	
	} 
	   
}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(

	'header'	 => 'Header.ihtml',
	'accessform' => 'spaces/Access.ihtml',
	'footer'	 => 'Footer.ihtml'
	
));

$sql = "SELECT Name FROM {$CONFIG['DB_PREFIX']}Spaces WHERE SpaceKey='$space_key'";

$rs = $CONN->Execute($sql);

while (!$rs->EOF) {

	$space_name=$rs->fields[0];
	$rs->MoveNext();
}

$rs->Close();

$sql = "SELECT Email FROM {$CONFIG['DB_PREFIX']}Users,{$CONFIG['DB_PREFIX']}SpaceUserLinks WHERE {$CONFIG['DB_PREFIX']}Users.UserKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey AND {$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey='$space_key' AND {$CONFIG['DB_PREFIX']}SpaceUserLinks.AccessLevelKey='1'";

$rs = $CONN->Execute($sql);
if ($rs->EOF) {

	$site_admins = sprintf($space_strings['no_admins'], $general_strings['space_text'], $general_strings['space_text']);
	
} else {

	while (!$rs->EOF) {

		$email = $rs->fields[0];
		$site_admins .= "<li><a href=\"mailto:$email\">$email</a></li>";
		$rs->MoveNext();
	
	}
	
}
$rs->Close();
$page_details = get_page_details('','');
set_common_template_vars('','',$page_details, $message, $accesslevel_key, $group_accesslevel);

$t->set_var('PAGE_TITLE','No Access at Present');
$t->set_var('SPACE_KEY',$space_key);

$t->set_var('SITE_ADMINS',$site_admins);
$t->set_var('INSTRUCTION_STRING', $space_strings['access_instruction']);
$t->set_var('ACCESS_CODE_STRING',$space_strings['access_code']);
$t->set_var('SUBMIT_STRING',$general_strings['submit']);
$t->set_var('CANCEL_STRING',$general_strings['cancel']);
$t->set_var('INSTRUCTION_STRING2',sprintf($space_strings['access_instruction2'], $general_strings['space_text'],$general_strings['space_text']));
$t->set_var('HEADING_STRING',sprintf($space_strings['access_heading'], $space_name));
$t->parse('CONTENTS', 'header', true); 

$t->parse('CONTENTS', 'accessform', true);
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
$CONN->Close();
exit;
?>