<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Email Users
*
* Sends email to selected User of a Space
*
* @package Spaces
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: emailuser.php,v 1.9 2006/02/12 22:38:52 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../local/config.inc.php');
session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');

if ($_SERVER['REQUEST_METHOD']=='GET') {
	
	$space_key  = $_GET['space_key'];
	$email_user_name  = urldecode($_GET['email_user_name']);
	
} else {
	
	$space_key = $_POST['space_key'];
	$action	   = $_POST['action'];
	
}
$current_user_key = $_SESSION['current_user_key'];

//check we have the required variables
check_variables(true,false);

//check to see if user is logged in. If not refer to Login page.
$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups']; 

if ($action=='email') {
	
	$errors = check_form_input();
	
	if(count($errors) == 0) {
		
		require_once('../includes/email.inc.php');
		
email_users($_POST['subject'], $_POST['body'], $_POST['email_user_key'], $_POST['copyself'], $_FILES['file'], $_POST['carbon_copy']);	   
		
		$message = urlencode($space_strings['email_success']);
		header ("Location: {$CONFIG['FULL_URL']}/spaces/members.php?space_key=$space_key&message=$message");
		exit;
	
	}

}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  
$t->set_file(array(
	'header'		  => 'Header.ihtml',
	'navigation'	  => 'Navigation.ihtml',
	'body'			=> 'spaces/EmailUser.ihtml',
	'footer'		  => 'Footer.ihtml'
));

$page_details=get_page_details($space_key);
set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);

$breadcrumbs = "<a href=\"{$CONFIG['PATH']}/spaces/space.php?space_key=$space_key\">".$space_strings['start']."</a> -> <a href=\"members.php?space_key=$space_key\">".$space_strings['members']."</a> - <b>".$space_strings['email_members']."</b>";
$t->set_var('BREADCRUMBS',$breadcrumbs);
$email_user_name2=urldecode($email_user_name);
$t->set_var('EMAIL_USER_NAME2',$email_user_name2);
$t->set_var('EMAIL_USER_NAME',$_GET['email_user_name']);

$t->parse('CONTENTS', 'header', true);
get_navigation();
$body_error = sprint_error($errors['body']);
$subject_error = sprint_error($errors['subject']);
$t->set_var('SPACE_KEY',$space_key);
$t->set_var('EMAIL_USER_KEY', $_GET['email_user_key']);
$t->set_var('SUBJECT_ERROR',$subject_error);
$t->set_var('BODY_ERROR',$body_error);
$t->set_var('SUBJECT',$subject);
$t->set_var('BODY',$body);

$t->set_var('EMAIL_USER_STRING',sprintf($space_strings['email_user'], $email_user_name2));
$t->set_var('SUBJECT_STRING',$general_strings['subject']);
$t->set_var('MESSAGE_STRING',$general_strings['message']);
$t->set_var('CC_STRING',$general_strings['carboncopy']);
$t->set_var('CC_INSTRUCTIONS',$general_strings['cc_instructions']);
$t->set_var('ATTACHMENT_STRING',$general_strings['attachment']);
$t->set_var('COPY_SELF_STRING',$general_strings['copy_self']);
$t->set_var('SEND_STRING',$general_strings['send']);
$t->parse('CONTENTS', 'body', true);
$t->parse('CONTENTS', 'footer', true);
print_headers();
$t->p('CONTENTS');
$CONN->Close();
exit;

function check_form_input() 
{
	
	global $general_strings; 

	// Initialize the errors array

	$errors = array();


	//check to see if we have all the information we need
	if(!$_POST['subject']) {

		$errors['subject'] = $general_strings['no_subject'];

	}


	if(!$_POST['body']) {

		$errors['body'] = $general_strings['no_message'];

	}

	return $errors;
	
} //end check_form_input
?>