<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* News display
*
* Displays news items, either from single space or from all users spaces
*
* @package Spaces
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: news.php,v 1.13 2006/02/12 22:38:52 websterb4 Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../local/config.inc.php');
session_start();

//get language strings

require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');


//check to see if user is logged in. If not refer to Login page.
$space_key  = isset($_GET['space_key'])? $_GET['space_key'] : '';
$offset	 = isset($_GET['offset'])? $_GET['offset'] : 2;
$current_user_key=$_SESSION['current_user_key'];

$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups'];   



//if they have not logged in before set their last login to today
if ($_SESSION['last_use']>0) {

	$last_use = $_SESSION['last_use'];
	
} else {

	$last_use = date('Y-m-d H:i:s');
	
}

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  

$t->set_file(array(
	'header'	 => 'Header.ihtml',
	'navigation' => 'Navigation.ihtml',
	'body'	   => 'spaces/News.ihtml',
	'footer'	 => 'Footer.ihtml'));
// get page details for titles and breadcrumb navigation
$page_details=get_page_details($space_key);

set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);
$t->set_var('NEWS_HEADING',$general_strings['news']);
if ($space_key == $CONFIG['DEFAULT_SPACE_KEY']) {
	
	if ($CONFIG['DISPLAY_LATEST']==0 || isset($_POST['last_use'])) {

		$date_limit = "AND {$CONFIG['DB_PREFIX']}News.DateAdded>'$last_use'";

	}
	
	$sql = "SELECT 
		{$CONFIG['DB_PREFIX']}News.Heading,
		{$CONFIG['DB_PREFIX']}News.Body,
		{$CONFIG['DB_PREFIX']}News.DateAdded, 
		FirstName, LastName, 
		{$CONFIG['DB_PREFIX']}News.UserKey, 
		{$CONFIG['DB_PREFIX']}News.NewsKey, 
		{$CONFIG['DB_PREFIX']}Spaces.Name,
		{$CONFIG['DB_PREFIX']}News.SpaceKey, 
		{$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey
		FROM 
		{$CONFIG['DB_PREFIX']}News, 
		{$CONFIG['DB_PREFIX']}Users, 
		{$CONFIG['DB_PREFIX']}Spaces LEFT JOIN
		{$CONFIG['DB_PREFIX']}SpaceUserLinks ON
		{$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}SpaceUserLinks.SpaceKey 
		WHERE 
		{$CONFIG['DB_PREFIX']}News.UserKey={$CONFIG['DB_PREFIX']}Users.UserKey 
		AND 
		{$CONFIG['DB_PREFIX']}Spaces.SpaceKey={$CONFIG['DB_PREFIX']}News.SpaceKey
		AND 
		({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey='$current_user_key' 
		OR 
		({$CONFIG['DB_PREFIX']}SpaceUserLinks.UserKey IS NULL AND 		{$CONFIG['DB_PREFIX']}News.SpaceKey='$space_key'))
		ORDER BY {$CONFIG['DB_PREFIX']}News.DateAdded DESC";
	
} else {

	$sql = "SELECT {$CONFIG['DB_PREFIX']}News.Heading,{$CONFIG['DB_PREFIX']}News.Body,{$CONFIG['DB_PREFIX']}News.DateAdded, FirstName, LastName,  {$CONFIG['DB_PREFIX']}News.UserKey, {$CONFIG['DB_PREFIX']}News.NewsKey FROM {$CONFIG['DB_PREFIX']}News, {$CONFIG['DB_PREFIX']}Users  WHERE {$CONFIG['DB_PREFIX']}News.UserKey={$CONFIG['DB_PREFIX']}Users.UserKey AND {$CONFIG['DB_PREFIX']}News.SpaceKey='$space_key'  ORDER BY {$CONFIG['DB_PREFIX']}News.DateAdded DESC";

}

		
$t->set_block('body', 'NewsBlock', 'NWBlock');
$rs = $CONN->Execute($sql);
$total_news = $rs->RecordCount();
$rs = $CONN->SelectLimit($sql,10, $offset);

if (!class_exists('InteractDate')) {

	require_once('../includes/lib/date.inc.php');
	
}

$objDates = new InteractDate();


if (!class_exists('InteractUser')) {

	require_once('../includes/lib/user.inc.php');
	
}

$objUser = new InteractUser();

while (!$rs->EOF) {

$heading = $rs->fields[0];
		
		$body=$objHtml->parseText($rs->fields[1]);
		$date_added = $objDates->formatDate($CONN->UnixTimeStamp($rs->fields[2]),'long');	
		$name = $rs->fields[3].' '.$rs->fields[4];
		$user_key = $rs->fields[5];
		$news_key = $rs->fields[6];
		$space_name = $rs->fields[7];
		$news_space_key = $rs->fields[8];
		$photo_tag = $objUser->getUserPhotoTag($user_key, '40');
	
		if ($photo_tag==false) {
	
			$photo_tag='&nbsp;';
	
		}
		if ($_SESSION['userlevel_key']=='1' || $accesslevel_key=='1' || $accesslevel_key=='3') {
            
	    	$admin_image=get_admin_tool("{$CONFIG['PATH']}/news/newsinput.php?space_key=$space_key&news_key=$news_key&action=modify");
        	$t->set_var('ADMIN_IMAGE',$admin_image);
        
		}
		$t->set_var('PHOTO_TAG',$photo_tag);
		$t->set_var('SPACE_HEADING',$space_name);
		$t->set_var('HEADING',$heading);
		$t->set_var('ADDED_BY',$name);
		$t->set_var('DATE_ADDED',$date_added);
		$t->set_var('BODY',$body);
		$t->set_var('SPACE_HEADING',$space_name);
		$t->set_var('NEWS_SPACE_KEY',$news_space_key);	
		$t->parse('NWBlock', 'NewsBlock', true);
		$rs->MoveNext();
		}

$rs->Close();

if ($offset>=10) {

	$previous_offset = $offset-10;
	$t->set_var('PREVIOUS_LINK'," < <a href=\"news.php?space_key=$space_key&offset=$previous_offset\">{$general_strings['previous']}</a>");

}

$next_offset = $offset+10;
if ($next_offset<$total_news) {

	$next_offset = $offset+10;
	$t->set_var('NEXT_LINK',"<a href=\"news.php?space_key=$space_key&offset=$next_offset\">{$general_strings['next']}</a> > ");

}


if (!isset($space_key) || $space_key=='') {
 
	$t->set_var('BREADCRUMBS','');
	$t->set_var('PAGE_TITLE',$general_strings['news']);
	$t->set_var('SPACE_TITLE','');
	$t->set_var('MAKE_MEMBER','');
	$t->set_block('navigation', 'ModuleHeadingBlock', 'MHBlock');
	$t->set_var('MHBlock','');	
	
}
$t->parse('CONTENTS', 'header', true);

get_navigation();

$t->parse('CONTENTS', 'body', true);
$t->parse('CONTENTS', 'footer', true);
$t->p('CONTENTS');

$CONN->Close();
exit;




?>
