<?php
// +------------------------------------------------------------------------+
// | This file is part of Interact.											|
// |																	  	| 
// | This program is free software; you can redistribute it and/or modify 	|
// | it under the terms of the GNU General Public License as published by 	|
// | the Free Software Foundation (version 2)							 	|
// |																	  	|	 
// | This program is distributed in the hope that it will be useful, but  	|
// | WITHOUT ANY WARRANTY; without even the implied warranty of		   		|
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU	 	|
// | General Public License for more details.							 	|
// |																	  	|	 
// | You should have received a copy of the GNU General Public License		|
// | along with this program; if not, you can view it at				  	|
// | http://www.opensource.org/licenses/gpl-license.php				   		|
// +------------------------------------------------------------------------+

/**
* Sitemap display
*
* Displays a sitemap of all components in a given space
*
* @package Spaces
* @author Glen Davies <glen.davies@cce.ac.nz>
* @copyright Christchurch College of Education 2001 
* @version $Id: spacemap.php,v 1.3 2006/03/20 20:53:12 glendavies Exp $
* 
*/

/**
* Include main system config file 
*/
require_once('../local/config.inc.php');

//get language strings
require_once($CONFIG['LANGUAGE_CPATH'].'/space_strings.inc.php');


//check to see if user is logged in. If not refer to Login page.
$space_key  = isset($_GET['space_key'])? $_GET['space_key'] : '';
$current_user_key=$_SESSION['current_user_key'];

$access_levels = authenticate();
$accesslevel_key = $access_levels['accesslevel_key'];
$group_access = $access_levels['groups'];   

require_once($CONFIG['TEMPLATE_CLASS_PATH'].'/template.inc');
$t = new Template($CONFIG['TEMPLATES_PATH']);  

$t->set_file(array(
	'header'	 => 'Header.ihtml',
	'navigation' => 'Navigation.ihtml',
	'body'	   => 'spaces/SpaceMap.ihtml',
	'footer'	 => 'Footer.ihtml'));
// get page details for titles and breadcrumb navigation
$page_details=get_page_details($space_key);

set_common_template_vars($space_key,$module_key,$page_details, $message, $accesslevel_key, $group_accesslevel);

$t->parse('CONTENTS', 'header', true);
get_navigation();

$init_links = '';
$module_links = get_site_map($space_key, 0,$init_links);
$t->set_var('MODULE_LINKS','<ul>'.$module_links.'</ul>');
$t->set_var('SPACEMAP',$general_strings['spacemap']);
$t->parse('CONTENTS', 'body', true);
$t->parse('CONTENTS', 'footer', true);
$t->p('CONTENTS');

$CONN->Close();
exit;

function get_site_map($space_key, $parent_key, &$module_links) {
	
	global $CONN,$CONFIG, $accesslevel_key, $group_access;
	
	$rs = $CONN->Execute("SELECT {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey,{$CONFIG['DB_PREFIX']}Modules.ModuleKey,{$CONFIG['DB_PREFIX']}Modules.Name, {$CONFIG['DB_PREFIX']}ModuleTypes.Code,{$CONFIG['DB_PREFIX']}Modules.Description,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.LinkKey  FROM {$CONFIG['DB_PREFIX']}Modules, {$CONFIG['DB_PREFIX']}ModuleTypes, {$CONFIG['DB_PREFIX']}ModuleSpaceLinks where {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey={$CONFIG['DB_PREFIX']}ModuleTypes.ModuleTypeKey AND {$CONFIG['DB_PREFIX']}Modules.ModuleKey={$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ModuleKey AND ({$CONFIG['DB_PREFIX']}ModuleSpaceLinks.SpaceKey='$space_key' and {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.ParentKey='$parent_key' AND {$CONFIG['DB_PREFIX']}ModuleSpaceLinks.StatusKey='1') AND {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey!=10 AND {$CONFIG['DB_PREFIX']}Modules.ModuleTypeKey!=5 ORDER BY SortOrder,{$CONFIG['DB_PREFIX']}ModuleSpaceLinks.DateAdded");
	
	echo $CONN->ErrorMsg();
	while(!$rs->EOF) {
		
		$type_key = $rs->fields[0];
		$module_key = $rs->fields[1];
		$name = $rs->fields[2];
		$code = $rs->fields[3];
		$description = substr(strip_tags($rs->fields[4],0,20));
		$link_key = $rs->fields[5];
		if ($type_key==19) {
			
			$module_space_key = $CONN->GetOne("SELECT SpaceKey FROM {$CONFIG['DB_PREFIX']}Spaces WHERE ModuleKey='$module_key'");
			$module_links .= '<li style="list-style-image: url('.$CONFIG['PATH'].'/images/'.$code.'.gif);"><a title="'.$description.'" href="'.$CONFIG['PATH'].'/spaces/space.php?space_key='.$module_space_key.'">'.$name.'</li>';
		
		} else {
			
			if ($type_key==4 || $type_key==6) {
				if ($type_key==6) {
					if (!class_exists('InteractGroup')) {
						require_once($CONFIG['BASE_PATH'].'/modules/group/lib.inc.php');
					}
					if (!is_object($objGroup)) {
						$objGroup = new InteractGroup();
					}
					$group_data = $objGroup->getGroupData($module_key);
					
				}
				
				if ($type_key==4 ||$_SESSION['userlevel_key']==1 || $accesslevel_key==1 || $accesslevel_key==3 || in_array($module_key,$group_access) || $group_data['visibility_key']==1) {
						$module_links .= '<li style="list-style-image: url('.$CONFIG['PATH'].'/images/'.$code.'.gif);"><a title="'.$description.'" href="'.$CONFIG['PATH'].'/modules/'.$code.'/'.$code.'.php?space_key='.$space_key.'&module_key='.$module_key.'">'.$name.'</li>';		
						$module_links .= '<ul>';
						if($type_key==4 ||$_SESSION['userlevel_key']==1 || $accesslevel_key==1 || $accesslevel_key==3 || in_array($module_key,$group_access) || $group_data['access_key']==2) {
							get_site_map($space_key, $link_key, $module_links);
							
						}
						$module_links .= '</ul>';
				}
				
			} else {
				$module_links .= '<li style="list-style-image: url('.$CONFIG['PATH'].'/images/'.$code.'.gif);"><a title="'.$description.'" href="'.$CONFIG['PATH'].'/modules/'.$code.'/'.$code.'.php?space_key='.$space_key.'&module_key='.$module_key.'">'.$name.'</li>';	
			
			}
		}
		$rs->MoveNext();
		
	}
	return $module_links;
}


?>
